/* MutterDisplayConfig.c generated by valac 0.46.10, the Vala compiler
 * generated from MutterDisplayConfig.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE (mutter_display_config_interface_get_type ())
#define MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterface))
#define IS_MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE))
#define MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterfaceIface))

typedef struct _MutterDisplayConfigInterface MutterDisplayConfigInterface;
typedef struct _MutterDisplayConfigInterfaceIface MutterDisplayConfigInterfaceIface;

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE_PROXY (mutter_display_config_interface_proxy_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_CRTC (mutter_read_display_crtc_get_type ())
typedef struct _MutterReadDisplayCrtc MutterReadDisplayCrtc;
typedef enum  {
	DISPLAY_TRANSFORM_NORMAL = 0,
	DISPLAY_TRANSFORM_ROTATION_90 = 1,
	DISPLAY_TRANSFORM_ROTATION_180 = 2,
	DISPLAY_TRANSFORM_ROTATION_270 = 3,
	DISPLAY_TRANSFORM_FLIPPED = 4,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_90 = 5,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_180 = 6,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_270 = 7
} DisplayTransform;

#define TYPE_DISPLAY_TRANSFORM (display_transform_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_OUTPUT (mutter_read_display_output_get_type ())
typedef struct _MutterReadDisplayOutput MutterReadDisplayOutput;

#define TYPE_MUTTER_READ_DISPLAY_MODE (mutter_read_display_mode_get_type ())
typedef struct _MutterReadDisplayMode MutterReadDisplayMode;

#define TYPE_MUTTER_WRITE_DISPLAY_CRTC (mutter_write_display_crtc_get_type ())
typedef struct _MutterWriteDisplayCrtc MutterWriteDisplayCrtc;

#define TYPE_MUTTER_WRITE_DISPLAY_OUTPUT (mutter_write_display_output_get_type ())
typedef struct _MutterWriteDisplayOutput MutterWriteDisplayOutput;

#define TYPE_MUTTER_READ_MONITOR (mutter_read_monitor_get_type ())
typedef struct _MutterReadMonitor MutterReadMonitor;

#define TYPE_MUTTER_READ_MONITOR_INFO (mutter_read_monitor_info_get_type ())
typedef struct _MutterReadMonitorInfo MutterReadMonitorInfo;

#define TYPE_MUTTER_READ_MONITOR_MODE (mutter_read_monitor_mode_get_type ())
typedef struct _MutterReadMonitorMode MutterReadMonitorMode;

#define TYPE_MUTTER_READ_LOGICAL_MONITOR (mutter_read_logical_monitor_get_type ())
typedef struct _MutterReadLogicalMonitor MutterReadLogicalMonitor;
typedef enum  {
	MUTTER_APPLY_METHOD_VERIFY = 0,
	MUTTER_APPLY_METHOD_TEMPORARY = 1,
	MUTTER_APPLY_METHOD_PERSISTENT = 2
} MutterApplyMethod;

#define TYPE_MUTTER_APPLY_METHOD (mutter_apply_method_get_type ())

#define TYPE_MUTTER_WRITE_LOGICAL_MONITOR (mutter_write_logical_monitor_get_type ())
typedef struct _MutterWriteLogicalMonitor MutterWriteLogicalMonitor;

#define TYPE_MUTTER_WRITE_MONITOR (mutter_write_monitor_get_type ())
typedef struct _MutterWriteMonitor MutterWriteMonitor;
enum  {
	MUTTER_DISPLAY_CONFIG_INTERFACE_MONITORS_CHANGED_SIGNAL,
	MUTTER_DISPLAY_CONFIG_INTERFACE_NUM_SIGNALS
};
static guint mutter_display_config_interface_signals[MUTTER_DISPLAY_CONFIG_INTERFACE_NUM_SIGNALS] = {0};
typedef GDBusProxy MutterDisplayConfigInterfaceProxy;
typedef GDBusProxyClass MutterDisplayConfigInterfaceProxyClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MutterReadDisplayCrtc {
	guint id;
	gint64 winsys_id;
	gint x;
	gint y;
	gint width;
	gint height;
	gint current_mode;
	DisplayTransform current_transform;
	DisplayTransform* transforms;
	gint transforms_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayOutput {
	guint id;
	gint64 winsys_id;
	gint current_crtc;
	guint* possible_crtcs;
	gint possible_crtcs_length1;
	gchar* connector_name;
	guint* modes;
	gint modes_length1;
	guint* clones;
	gint clones_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayMode {
	guint id;
	gint64 winsys_id;
	guint width;
	guint height;
	gdouble frequency;
	guint flags;
};

struct _MutterWriteDisplayCrtc {
	guint id;
	gint new_mode;
	gint x;
	gint y;
	DisplayTransform transform;
	guint* outputs;
	gint outputs_length1;
	GHashTable* properties;
};

struct _MutterWriteDisplayOutput {
	guint id;
	GHashTable* properties;
};

struct _MutterReadMonitorInfo {
	gchar* connector;
	gchar* vendor;
	gchar* product;
	gchar* serial;
};

struct _MutterReadMonitorMode {
	gchar* id;
	gint width;
	gint height;
	gdouble frequency;
	gdouble preferred_scale;
	gdouble* supported_scales;
	gint supported_scales_length1;
	GHashTable* properties;
};

struct _MutterReadMonitor {
	MutterReadMonitorInfo monitor;
	MutterReadMonitorMode* modes;
	gint modes_length1;
	GHashTable* properties;
};

struct _MutterReadLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterReadMonitorInfo* monitors;
	gint monitors_length1;
	GHashTable* properties;
};

struct _MutterWriteMonitor {
	gchar* connector;
	gchar* monitor_mode;
	GHashTable* properties;
};

struct _MutterWriteLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterWriteMonitor* monitors;
	gint monitors_length1;
};

struct _MutterDisplayConfigInterfaceIface {
	GTypeInterface parent_iface;
	void (*get_resources) (MutterDisplayConfigInterface* self, guint* serial, MutterReadDisplayCrtc** crtcs, gint* crtcs_length1, MutterReadDisplayOutput** outputs, gint* outputs_length1, MutterReadDisplayMode** modes, gint* modes_length1, gint* max_screen_width, gint* max_screen_height, GError** error);
	void (*apply_configuration) (MutterDisplayConfigInterface* self, guint serial, gboolean persistent, MutterWriteDisplayCrtc* crtcs, gint crtcs_length1, MutterWriteDisplayOutput* outputs, gint outputs_length1, GError** error);
	gint (*change_backlight) (MutterDisplayConfigInterface* self, guint serial, guint output, gint value, GError** error);
	void (*get_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint** red, gint* red_length1, guint** green, gint* green_length1, guint** blue, gint* blue_length1, GError** error);
	void (*set_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint* red, gint red_length1, guint* green, gint green_length1, guint* blue, gint blue_length1, GError** error);
	void (*get_current_state) (MutterDisplayConfigInterface* self, guint* serial, MutterReadMonitor** monitors, gint* monitors_length1, MutterReadLogicalMonitor** logical_monitors, gint* logical_monitors_length1, GHashTable* * properties, GError** error);
	void (*apply_monitors_config) (MutterDisplayConfigInterface* self, guint serial, MutterApplyMethod method, MutterWriteLogicalMonitor* logical_monitors, gint logical_monitors_length1, GHashTable* properties, GError** error);
	gint (*get_power_save_mode) (MutterDisplayConfigInterface* self);
	void (*set_power_save_mode) (MutterDisplayConfigInterface* self, gint value);
};

GType mutter_display_config_interface_proxy_get_type (void) G_GNUC_CONST;
guint mutter_display_config_interface_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
GType mutter_read_display_crtc_get_type (void) G_GNUC_CONST;
GType display_transform_get_type (void) G_GNUC_CONST;
MutterReadDisplayCrtc* mutter_read_display_crtc_dup (const MutterReadDisplayCrtc* self);
void mutter_read_display_crtc_free (MutterReadDisplayCrtc* self);
void mutter_read_display_crtc_copy (const MutterReadDisplayCrtc* self,
                                    MutterReadDisplayCrtc* dest);
void mutter_read_display_crtc_destroy (MutterReadDisplayCrtc* self);
GType mutter_read_display_output_get_type (void) G_GNUC_CONST;
MutterReadDisplayOutput* mutter_read_display_output_dup (const MutterReadDisplayOutput* self);
void mutter_read_display_output_free (MutterReadDisplayOutput* self);
void mutter_read_display_output_copy (const MutterReadDisplayOutput* self,
                                      MutterReadDisplayOutput* dest);
void mutter_read_display_output_destroy (MutterReadDisplayOutput* self);
GType mutter_read_display_mode_get_type (void) G_GNUC_CONST;
MutterReadDisplayMode* mutter_read_display_mode_dup (const MutterReadDisplayMode* self);
void mutter_read_display_mode_free (MutterReadDisplayMode* self);
GType mutter_write_display_crtc_get_type (void) G_GNUC_CONST;
MutterWriteDisplayCrtc* mutter_write_display_crtc_dup (const MutterWriteDisplayCrtc* self);
void mutter_write_display_crtc_free (MutterWriteDisplayCrtc* self);
void mutter_write_display_crtc_copy (const MutterWriteDisplayCrtc* self,
                                     MutterWriteDisplayCrtc* dest);
void mutter_write_display_crtc_destroy (MutterWriteDisplayCrtc* self);
GType mutter_write_display_output_get_type (void) G_GNUC_CONST;
MutterWriteDisplayOutput* mutter_write_display_output_dup (const MutterWriteDisplayOutput* self);
void mutter_write_display_output_free (MutterWriteDisplayOutput* self);
void mutter_write_display_output_copy (const MutterWriteDisplayOutput* self,
                                       MutterWriteDisplayOutput* dest);
void mutter_write_display_output_destroy (MutterWriteDisplayOutput* self);
GType mutter_read_monitor_get_type (void) G_GNUC_CONST;
GType mutter_read_monitor_info_get_type (void) G_GNUC_CONST;
MutterReadMonitorInfo* mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self);
void mutter_read_monitor_info_free (MutterReadMonitorInfo* self);
void mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                                    MutterReadMonitorInfo* dest);
void mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self);
GType mutter_read_monitor_mode_get_type (void) G_GNUC_CONST;
MutterReadMonitorMode* mutter_read_monitor_mode_dup (const MutterReadMonitorMode* self);
void mutter_read_monitor_mode_free (MutterReadMonitorMode* self);
void mutter_read_monitor_mode_copy (const MutterReadMonitorMode* self,
                                    MutterReadMonitorMode* dest);
void mutter_read_monitor_mode_destroy (MutterReadMonitorMode* self);
MutterReadMonitor* mutter_read_monitor_dup (const MutterReadMonitor* self);
void mutter_read_monitor_free (MutterReadMonitor* self);
void mutter_read_monitor_copy (const MutterReadMonitor* self,
                               MutterReadMonitor* dest);
void mutter_read_monitor_destroy (MutterReadMonitor* self);
GType mutter_read_logical_monitor_get_type (void) G_GNUC_CONST;
MutterReadLogicalMonitor* mutter_read_logical_monitor_dup (const MutterReadLogicalMonitor* self);
void mutter_read_logical_monitor_free (MutterReadLogicalMonitor* self);
void mutter_read_logical_monitor_copy (const MutterReadLogicalMonitor* self,
                                       MutterReadLogicalMonitor* dest);
void mutter_read_logical_monitor_destroy (MutterReadLogicalMonitor* self);
GType mutter_apply_method_get_type (void) G_GNUC_CONST;
GType mutter_write_logical_monitor_get_type (void) G_GNUC_CONST;
GType mutter_write_monitor_get_type (void) G_GNUC_CONST;
MutterWriteMonitor* mutter_write_monitor_dup (const MutterWriteMonitor* self);
void mutter_write_monitor_free (MutterWriteMonitor* self);
void mutter_write_monitor_copy (const MutterWriteMonitor* self,
                                MutterWriteMonitor* dest);
void mutter_write_monitor_destroy (MutterWriteMonitor* self);
MutterWriteLogicalMonitor* mutter_write_logical_monitor_dup (const MutterWriteLogicalMonitor* self);
void mutter_write_logical_monitor_free (MutterWriteLogicalMonitor* self);
void mutter_write_logical_monitor_copy (const MutterWriteLogicalMonitor* self,
                                        MutterWriteLogicalMonitor* dest);
void mutter_write_logical_monitor_destroy (MutterWriteLogicalMonitor* self);
GType mutter_display_config_interface_get_type (void) G_GNUC_CONST;
void mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                    guint* serial,
                                                    MutterReadDisplayCrtc** crtcs,
                                                    gint* crtcs_length1,
                                                    MutterReadDisplayOutput** outputs,
                                                    gint* outputs_length1,
                                                    MutterReadDisplayMode** modes,
                                                    gint* modes_length1,
                                                    gint* max_screen_width,
                                                    gint* max_screen_height,
                                                    GError** error);
void mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                          guint serial,
                                                          gboolean persistent,
                                                          MutterWriteDisplayCrtc* crtcs,
                                                          gint crtcs_length1,
                                                          MutterWriteDisplayOutput* outputs,
                                                          gint outputs_length1,
                                                          GError** error);
gint mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                       guint serial,
                                                       guint output,
                                                       gint value,
                                                       GError** error);
void mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     guint crtc,
                                                     guint** red,
                                                     gint* red_length1,
                                                     guint** green,
                                                     gint* green_length1,
                                                     guint** blue,
                                                     gint* blue_length1,
                                                     GError** error);
void mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     guint crtc,
                                                     guint* red,
                                                     gint red_length1,
                                                     guint* green,
                                                     gint green_length1,
                                                     guint* blue,
                                                     gint blue_length1,
                                                     GError** error);
void mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                        guint* serial,
                                                        MutterReadMonitor** monitors,
                                                        gint* monitors_length1,
                                                        MutterReadLogicalMonitor** logical_monitors,
                                                        gint* logical_monitors_length1,
                                                        GHashTable* * properties,
                                                        GError** error);
void mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                            guint serial,
                                                            MutterApplyMethod method,
                                                            MutterWriteLogicalMonitor* logical_monitors,
                                                            gint logical_monitors_length1,
                                                            GHashTable* properties,
                                                            GError** error);
gint mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self);
void mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                          gint value);
static void mutter_display_config_interface_proxy_g_signal (GDBusProxy* proxy,
                                                     const gchar* sender_name,
                                                     const gchar* signal_name,
                                                     GVariant* parameters);
static void _dbus_handle_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* self,
                                                                    GVariant* parameters);
static void mutter_display_config_interface_proxy_get_resources (MutterDisplayConfigInterface* self,
                                                          guint* serial,
                                                          MutterReadDisplayCrtc** crtcs,
                                                          gint* crtcs_length1,
                                                          MutterReadDisplayOutput** outputs,
                                                          gint* outputs_length1,
                                                          MutterReadDisplayMode** modes,
                                                          gint* modes_length1,
                                                          gint* max_screen_width,
                                                          gint* max_screen_height,
                                                          GError** error);
static void mutter_display_config_interface_proxy_apply_configuration (MutterDisplayConfigInterface* self,
                                                                guint serial,
                                                                gboolean persistent,
                                                                MutterWriteDisplayCrtc* crtcs,
                                                                gint crtcs_length1,
                                                                MutterWriteDisplayOutput* outputs,
                                                                gint outputs_length1,
                                                                GError** error);
static gint mutter_display_config_interface_proxy_change_backlight (MutterDisplayConfigInterface* self,
                                                             guint serial,
                                                             guint output,
                                                             gint value,
                                                             GError** error);
static void mutter_display_config_interface_proxy_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           guint crtc,
                                                           guint** red,
                                                           gint* red_length1,
                                                           guint** green,
                                                           gint* green_length1,
                                                           guint** blue,
                                                           gint* blue_length1,
                                                           GError** error);
static void mutter_display_config_interface_proxy_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           guint crtc,
                                                           guint* red,
                                                           gint red_length1,
                                                           guint* green,
                                                           gint green_length1,
                                                           guint* blue,
                                                           gint blue_length1,
                                                           GError** error);
static void mutter_display_config_interface_proxy_get_current_state (MutterDisplayConfigInterface* self,
                                                              guint* serial,
                                                              MutterReadMonitor** monitors,
                                                              gint* monitors_length1,
                                                              MutterReadLogicalMonitor** logical_monitors,
                                                              gint* logical_monitors_length1,
                                                              GHashTable* * properties,
                                                              GError** error);
static void mutter_display_config_interface_proxy_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                                  guint serial,
                                                                  MutterApplyMethod method,
                                                                  MutterWriteLogicalMonitor* logical_monitors,
                                                                  gint logical_monitors_length1,
                                                                  GHashTable* properties,
                                                                  GError** error);
static gint mutter_display_config_interface_dbus_proxy_get_power_save_mode (MutterDisplayConfigInterface* self);
static void mutter_display_config_interface_dbus_proxy_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                     gint value);
static void mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init (MutterDisplayConfigInterfaceIface* iface);
static void _vala_MutterReadDisplayCrtc_array_free (MutterReadDisplayCrtc * array,
                                             gint array_length);
static void _vala_MutterReadDisplayOutput_array_free (MutterReadDisplayOutput * array,
                                               gint array_length);
static void _dbus_mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _vala_MutterWriteDisplayCrtc_array_free (MutterWriteDisplayCrtc * array,
                                              gint array_length);
static void _vala_MutterWriteDisplayOutput_array_free (MutterWriteDisplayOutput * array,
                                                gint array_length);
static void _dbus_mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                                GVariant* _parameters_,
                                                                GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void _vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                         gint array_length);
static void _vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                                gint array_length);
static void _dbus_mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void _vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                                 gint array_length);
static void _dbus_mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                                  GVariant* _parameters_,
                                                                  GDBusMethodInvocation* invocation);
static void mutter_display_config_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* method_name,
                                                                 GVariant* parameters,
                                                                 GDBusMethodInvocation* invocation,
                                                                 gpointer user_data);
static GVariant* mutter_display_config_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* property_name,
                                                                       GError** error,
                                                                       gpointer user_data);
static GVariant* _dbus_mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self);
static gboolean mutter_display_config_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* property_name,
                                                                      GVariant* value,
                                                                      GError** error,
                                                                      gpointer user_data);
static void _dbus_mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                GVariant* _value);
static void _dbus_mutter_display_config_interface_monitors_changed (GObject* _sender,
                                                             gpointer* _data);
static void _mutter_display_config_interface_unregister_object (gpointer user_data);
gchar* display_transform_to_string (DisplayTransform self);
guint mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self);
static gdouble* _vala_array_dup1 (gdouble* self,
                           int length);
static void _vala_MutterReadMonitorMode_array_free (MutterReadMonitorMode * array,
                                             gint array_length);
static MutterReadMonitorMode* _vala_array_dup2 (MutterReadMonitorMode* self,
                                         int length);
static void _vala_MutterReadMonitorInfo_array_free (MutterReadMonitorInfo * array,
                                             gint array_length);
static MutterReadMonitorInfo* _vala_array_dup3 (MutterReadMonitorInfo* self,
                                         int length);
static void _vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                          gint array_length);
static MutterWriteMonitor* _vala_array_dup4 (MutterWriteMonitor* self,
                                      int length);
static DisplayTransform* _vala_array_dup5 (DisplayTransform* self,
                                    int length);
static guint* _vala_array_dup6 (guint* self,
                         int length);
static guint* _vala_array_dup7 (guint* self,
                         int length);
static guint* _vala_array_dup8 (guint* self,
                         int length);
static guint* _vala_array_dup9 (guint* self,
                         int length);

static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_crtcs = {-1, "crtcs", "a(uxiiiiiuaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_outputs = {-1, "outputs", "a(uxiausauaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_modes = {-1, "modes", "a(uxuudu)", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_width = {-1, "max_screen_width", "i", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_height = {-1, "max_screen_height", "i", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_resources_in[] = {NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_resources_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_resources_serial, &_mutter_display_config_interface_dbus_arg_info_get_resources_crtcs, &_mutter_display_config_interface_dbus_arg_info_get_resources_outputs, &_mutter_display_config_interface_dbus_arg_info_get_resources_modes, &_mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_width, &_mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_height, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_resources = {-1, "GetResources", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_resources_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_resources_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_persistent = {-1, "persistent", "b", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_crtcs = {-1, "crtcs", "a(uiiiuaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_outputs = {-1, "outputs", "a(ua{sv})", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_configuration_in[] = {&_mutter_display_config_interface_dbus_arg_info_apply_configuration_serial, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_persistent, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_crtcs, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_outputs, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_configuration_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_apply_configuration = {-1, "ApplyConfiguration", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_configuration_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_configuration_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_output = {-1, "output", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_value = {-1, "value", "i", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_result = {-1, "result", "i", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_change_backlight_in[] = {&_mutter_display_config_interface_dbus_arg_info_change_backlight_serial, &_mutter_display_config_interface_dbus_arg_info_change_backlight_output, &_mutter_display_config_interface_dbus_arg_info_change_backlight_value, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_change_backlight_out[] = {&_mutter_display_config_interface_dbus_arg_info_change_backlight_result, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_change_backlight = {-1, "ChangeBacklight", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_change_backlight_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_change_backlight_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_crtc = {-1, "crtc", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_red = {-1, "red", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_green = {-1, "green", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_blue = {-1, "blue", "au", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_in[] = {&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_serial, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_crtc, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_red, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_green, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_blue, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_crtc_gamma = {-1, "GetCrtcGamma", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_crtc = {-1, "crtc", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_red = {-1, "red", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_green = {-1, "green", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_blue = {-1, "blue", "au", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_in[] = {&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_serial, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_crtc, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_red, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_green, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_blue, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_set_crtc_gamma = {-1, "SetCrtcGamma", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_monitors = {-1, "monitors", "a((ssss)a(siiddada{sv})a{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_logical_monitors = {-1, "logical_monitors", "a(iiduba(ssss)a{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_properties = {-1, "properties", "a{sv}", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_current_state_in[] = {NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_current_state_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_current_state_serial, &_mutter_display_config_interface_dbus_arg_info_get_current_state_monitors, &_mutter_display_config_interface_dbus_arg_info_get_current_state_logical_monitors, &_mutter_display_config_interface_dbus_arg_info_get_current_state_properties, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_current_state = {-1, "GetCurrentState", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_current_state_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_current_state_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_method = {-1, "method", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_logical_monitors = {-1, "logical_monitors", "a(iiduba(ssa{sv}))", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_properties = {-1, "properties", "a{sv}", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_in[] = {&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_serial, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_method, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_logical_monitors, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_properties, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_apply_monitors_config = {-1, "ApplyMonitorsConfig", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_out), NULL};
static const GDBusMethodInfo * const _mutter_display_config_interface_dbus_method_info[] = {&_mutter_display_config_interface_dbus_method_info_get_resources, &_mutter_display_config_interface_dbus_method_info_apply_configuration, &_mutter_display_config_interface_dbus_method_info_change_backlight, &_mutter_display_config_interface_dbus_method_info_get_crtc_gamma, &_mutter_display_config_interface_dbus_method_info_set_crtc_gamma, &_mutter_display_config_interface_dbus_method_info_get_current_state, &_mutter_display_config_interface_dbus_method_info_apply_monitors_config, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_monitors_changed[] = {NULL};
static const GDBusSignalInfo _mutter_display_config_interface_dbus_signal_info_monitors_changed = {-1, "MonitorsChanged", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_monitors_changed), NULL};
static const GDBusSignalInfo * const _mutter_display_config_interface_dbus_signal_info[] = {&_mutter_display_config_interface_dbus_signal_info_monitors_changed, NULL};
static const GDBusPropertyInfo _mutter_display_config_interface_dbus_property_info_power_save_mode = {-1, "PowerSaveMode", "i", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _mutter_display_config_interface_dbus_property_info[] = {&_mutter_display_config_interface_dbus_property_info_power_save_mode, NULL};
static const GDBusInterfaceInfo _mutter_display_config_interface_dbus_interface_info = {-1, "org.gnome.Mutter.DisplayConfig", (GDBusMethodInfo **) (&_mutter_display_config_interface_dbus_method_info), (GDBusSignalInfo **) (&_mutter_display_config_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_mutter_display_config_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _mutter_display_config_interface_dbus_interface_vtable = {mutter_display_config_interface_dbus_interface_method_call, mutter_display_config_interface_dbus_interface_get_property, mutter_display_config_interface_dbus_interface_set_property};

void
mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                               guint* serial,
                                               MutterReadDisplayCrtc** crtcs,
                                               gint* crtcs_length1,
                                               MutterReadDisplayOutput** outputs,
                                               gint* outputs_length1,
                                               MutterReadDisplayMode** modes,
                                               gint* modes_length1,
                                               gint* max_screen_width,
                                               gint* max_screen_height,
                                               GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->get_resources (self, serial, crtcs, crtcs_length1, outputs, outputs_length1, modes, modes_length1, max_screen_width, max_screen_height, error);
}

void
mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     gboolean persistent,
                                                     MutterWriteDisplayCrtc* crtcs,
                                                     gint crtcs_length1,
                                                     MutterWriteDisplayOutput* outputs,
                                                     gint outputs_length1,
                                                     GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->apply_configuration (self, serial, persistent, crtcs, crtcs_length1, outputs, outputs_length1, error);
}

gint
mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                  guint serial,
                                                  guint output,
                                                  gint value,
                                                  GError** error)
{
	g_return_val_if_fail (self != NULL, 0);
	return MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->change_backlight (self, serial, output, value, error);
}

void
mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                guint serial,
                                                guint crtc,
                                                guint** red,
                                                gint* red_length1,
                                                guint** green,
                                                gint* green_length1,
                                                guint** blue,
                                                gint* blue_length1,
                                                GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->get_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, error);
}

void
mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                guint serial,
                                                guint crtc,
                                                guint* red,
                                                gint red_length1,
                                                guint* green,
                                                gint green_length1,
                                                guint* blue,
                                                gint blue_length1,
                                                GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->set_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, error);
}

void
mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                   guint* serial,
                                                   MutterReadMonitor** monitors,
                                                   gint* monitors_length1,
                                                   MutterReadLogicalMonitor** logical_monitors,
                                                   gint* logical_monitors_length1,
                                                   GHashTable* * properties,
                                                   GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->get_current_state (self, serial, monitors, monitors_length1, logical_monitors, logical_monitors_length1, properties, error);
}

void
mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                       guint serial,
                                                       MutterApplyMethod method,
                                                       MutterWriteLogicalMonitor* logical_monitors,
                                                       gint logical_monitors_length1,
                                                       GHashTable* properties,
                                                       GError** error)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->apply_monitors_config (self, serial, method, logical_monitors, logical_monitors_length1, properties, error);
}

gint
mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->get_power_save_mode (self);
}

void
mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                     gint value)
{
	g_return_if_fail (self != NULL);
	MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self)->set_power_save_mode (self, value);
}

static void
mutter_display_config_interface_default_init (MutterDisplayConfigInterfaceIface * iface,
                                              gpointer iface_data)
{
	mutter_display_config_interface_signals[MUTTER_DISPLAY_CONFIG_INTERFACE_MONITORS_CHANGED_SIGNAL] = g_signal_new ("monitors-changed", TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

GType
mutter_display_config_interface_get_type (void)
{
	static volatile gsize mutter_display_config_interface_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_display_config_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MutterDisplayConfigInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mutter_display_config_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType mutter_display_config_interface_type_id;
		mutter_display_config_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MutterDisplayConfigInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (mutter_display_config_interface_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) mutter_display_config_interface_proxy_get_type);
		g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.Mutter.DisplayConfig");
		g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_mutter_display_config_interface_dbus_interface_info));
		g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mutter_display_config_interface_register_object);
		g_once_init_leave (&mutter_display_config_interface_type_id__volatile, mutter_display_config_interface_type_id);
	}
	return mutter_display_config_interface_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (MutterDisplayConfigInterfaceProxy, mutter_display_config_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init) )
static void
mutter_display_config_interface_proxy_class_init (MutterDisplayConfigInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = mutter_display_config_interface_proxy_g_signal;
}

static void
_dbus_handle_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* self,
                                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "monitors-changed");
}

static void
mutter_display_config_interface_proxy_g_signal (GDBusProxy* proxy,
                                                const gchar* sender_name,
                                                const gchar* signal_name,
                                                GVariant* parameters)
{
	if (strcmp (signal_name, "MonitorsChanged") == 0) {
		_dbus_handle_mutter_display_config_interface_monitors_changed ((MutterDisplayConfigInterface*) proxy, parameters);
	}
}

static void
mutter_display_config_interface_proxy_init (MutterDisplayConfigInterfaceProxy* self)
{
}

static void
mutter_display_config_interface_proxy_get_resources (MutterDisplayConfigInterface* self,
                                                     guint* serial,
                                                     MutterReadDisplayCrtc** crtcs,
                                                     gint* crtcs_length1,
                                                     MutterReadDisplayOutput** outputs,
                                                     gint* outputs_length1,
                                                     MutterReadDisplayMode** modes,
                                                     gint* modes_length1,
                                                     gint* max_screen_width,
                                                     gint* max_screen_height,
                                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint _vala_serial = 0U;
	GVariant* _tmp3_;
	MutterReadDisplayCrtc* _vala_crtcs = NULL;
	gint _vala_crtcs_length1;
	GVariant* _tmp4_;
	MutterReadDisplayCrtc* _tmp5_;
	gint _tmp5__length;
	gint _tmp5__size;
	gint _tmp5__length1;
	GVariantIter _tmp6_;
	GVariant* _tmp7_;
	MutterReadDisplayOutput* _vala_outputs = NULL;
	gint _vala_outputs_length1;
	GVariant* _tmp27_;
	MutterReadDisplayOutput* _tmp28_;
	gint _tmp28__length;
	gint _tmp28__size;
	gint _tmp28__length1;
	GVariantIter _tmp29_;
	GVariant* _tmp30_;
	MutterReadDisplayMode* _vala_modes = NULL;
	gint _vala_modes_length1;
	GVariant* _tmp54_;
	MutterReadDisplayMode* _tmp55_;
	gint _tmp55__length;
	gint _tmp55__size;
	gint _tmp55__length1;
	GVariantIter _tmp56_;
	GVariant* _tmp57_;
	gint _vala_max_screen_width = 0;
	GVariant* _tmp66_;
	gint _vala_max_screen_height = 0;
	GVariant* _tmp67_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetResources");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp3_ = g_variant_iter_next_value (&_reply_iter);
	_vala_serial = g_variant_get_uint32 (_tmp3_);
	g_variant_unref (_tmp3_);
	*serial = _vala_serial;
	_vala_crtcs_length1 = 0;
	_tmp4_ = g_variant_iter_next_value (&_reply_iter);
	_tmp5_ = g_new (MutterReadDisplayCrtc, 5);
	_tmp5__length = 0;
	_tmp5__size = 4;
	_tmp5__length1 = 0;
	g_variant_iter_init (&_tmp6_, _tmp4_);
	for (; (_tmp7_ = g_variant_iter_next_value (&_tmp6_)) != NULL; _tmp5__length1++) {
		MutterReadDisplayCrtc _tmp8_;
		GVariantIter _tmp9_;
		GVariant* _tmp10_;
		GVariant* _tmp11_;
		GVariant* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		GVariant* _tmp15_;
		GVariant* _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		DisplayTransform* _tmp19_;
		gint _tmp19__length;
		gint _tmp19__size;
		gint _tmp19__length1;
		GVariantIter _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		GHashTable* _tmp23_;
		GVariantIter _tmp24_;
		GVariant* _tmp25_;
		GVariant* _tmp26_;
		if (_tmp5__size == _tmp5__length) {
			_tmp5__size = 2 * _tmp5__size;
			_tmp5_ = g_renew (MutterReadDisplayCrtc, _tmp5_, _tmp5__size + 1);
		}
		g_variant_iter_init (&_tmp9_, _tmp7_);
		_tmp10_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.id = g_variant_get_uint32 (_tmp10_);
		g_variant_unref (_tmp10_);
		_tmp11_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.winsys_id = g_variant_get_int64 (_tmp11_);
		g_variant_unref (_tmp11_);
		_tmp12_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.x = g_variant_get_int32 (_tmp12_);
		g_variant_unref (_tmp12_);
		_tmp13_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.y = g_variant_get_int32 (_tmp13_);
		g_variant_unref (_tmp13_);
		_tmp14_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.width = g_variant_get_int32 (_tmp14_);
		g_variant_unref (_tmp14_);
		_tmp15_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.height = g_variant_get_int32 (_tmp15_);
		g_variant_unref (_tmp15_);
		_tmp16_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.current_mode = g_variant_get_int32 (_tmp16_);
		g_variant_unref (_tmp16_);
		_tmp17_ = g_variant_iter_next_value (&_tmp9_);
		_tmp8_.current_transform = g_variant_get_uint32 (_tmp17_);
		g_variant_unref (_tmp17_);
		_tmp18_ = g_variant_iter_next_value (&_tmp9_);
		_tmp19_ = g_new (DisplayTransform, 5);
		_tmp19__length = 0;
		_tmp19__size = 4;
		_tmp19__length1 = 0;
		g_variant_iter_init (&_tmp20_, _tmp18_);
		for (; (_tmp21_ = g_variant_iter_next_value (&_tmp20_)) != NULL; _tmp19__length1++) {
			if (_tmp19__size == _tmp19__length) {
				_tmp19__size = 2 * _tmp19__size;
				_tmp19_ = g_renew (DisplayTransform, _tmp19_, _tmp19__size + 1);
			}
			_tmp19_[_tmp19__length++] = g_variant_get_uint32 (_tmp21_);
			g_variant_unref (_tmp21_);
		}
		_tmp8_.transforms_length1 = _tmp19__length1;
		_tmp8_.transforms = _tmp19_;
		g_variant_unref (_tmp18_);
		_tmp22_ = g_variant_iter_next_value (&_tmp9_);
		_tmp23_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp24_, _tmp22_);
		while (g_variant_iter_loop (&_tmp24_, "{?*}", &_tmp25_, &_tmp26_)) {
			g_hash_table_insert (_tmp23_, g_variant_dup_string (_tmp25_, NULL), g_variant_get_variant (_tmp26_));
		}
		_tmp8_.properties = _tmp23_;
		g_variant_unref (_tmp22_);
		_tmp5_[_tmp5__length++] = _tmp8_;
		g_variant_unref (_tmp7_);
	}
	_vala_crtcs_length1 = _tmp5__length1;
	_vala_crtcs = _tmp5_;
	g_variant_unref (_tmp4_);
	*crtcs = _vala_crtcs;
	*crtcs_length1 = _vala_crtcs_length1;
	_vala_outputs_length1 = 0;
	_tmp27_ = g_variant_iter_next_value (&_reply_iter);
	_tmp28_ = g_new (MutterReadDisplayOutput, 5);
	_tmp28__length = 0;
	_tmp28__size = 4;
	_tmp28__length1 = 0;
	g_variant_iter_init (&_tmp29_, _tmp27_);
	for (; (_tmp30_ = g_variant_iter_next_value (&_tmp29_)) != NULL; _tmp28__length1++) {
		MutterReadDisplayOutput _tmp31_;
		GVariantIter _tmp32_;
		GVariant* _tmp33_;
		GVariant* _tmp34_;
		GVariant* _tmp35_;
		GVariant* _tmp36_;
		guint* _tmp37_;
		gint _tmp37__length;
		gint _tmp37__size;
		gint _tmp37__length1;
		GVariantIter _tmp38_;
		GVariant* _tmp39_;
		GVariant* _tmp40_;
		GVariant* _tmp41_;
		guint* _tmp42_;
		gint _tmp42__length;
		gint _tmp42__size;
		gint _tmp42__length1;
		GVariantIter _tmp43_;
		GVariant* _tmp44_;
		GVariant* _tmp45_;
		guint* _tmp46_;
		gint _tmp46__length;
		gint _tmp46__size;
		gint _tmp46__length1;
		GVariantIter _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GHashTable* _tmp50_;
		GVariantIter _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		if (_tmp28__size == _tmp28__length) {
			_tmp28__size = 2 * _tmp28__size;
			_tmp28_ = g_renew (MutterReadDisplayOutput, _tmp28_, _tmp28__size + 1);
		}
		g_variant_iter_init (&_tmp32_, _tmp30_);
		_tmp33_ = g_variant_iter_next_value (&_tmp32_);
		_tmp31_.id = g_variant_get_uint32 (_tmp33_);
		g_variant_unref (_tmp33_);
		_tmp34_ = g_variant_iter_next_value (&_tmp32_);
		_tmp31_.winsys_id = g_variant_get_int64 (_tmp34_);
		g_variant_unref (_tmp34_);
		_tmp35_ = g_variant_iter_next_value (&_tmp32_);
		_tmp31_.current_crtc = g_variant_get_int32 (_tmp35_);
		g_variant_unref (_tmp35_);
		_tmp36_ = g_variant_iter_next_value (&_tmp32_);
		_tmp37_ = g_new (guint, 5);
		_tmp37__length = 0;
		_tmp37__size = 4;
		_tmp37__length1 = 0;
		g_variant_iter_init (&_tmp38_, _tmp36_);
		for (; (_tmp39_ = g_variant_iter_next_value (&_tmp38_)) != NULL; _tmp37__length1++) {
			if (_tmp37__size == _tmp37__length) {
				_tmp37__size = 2 * _tmp37__size;
				_tmp37_ = g_renew (guint, _tmp37_, _tmp37__size + 1);
			}
			_tmp37_[_tmp37__length++] = g_variant_get_uint32 (_tmp39_);
			g_variant_unref (_tmp39_);
		}
		_tmp31_.possible_crtcs_length1 = _tmp37__length1;
		_tmp31_.possible_crtcs = _tmp37_;
		g_variant_unref (_tmp36_);
		_tmp40_ = g_variant_iter_next_value (&_tmp32_);
		_tmp31_.connector_name = g_variant_dup_string (_tmp40_, NULL);
		g_variant_unref (_tmp40_);
		_tmp41_ = g_variant_iter_next_value (&_tmp32_);
		_tmp42_ = g_new (guint, 5);
		_tmp42__length = 0;
		_tmp42__size = 4;
		_tmp42__length1 = 0;
		g_variant_iter_init (&_tmp43_, _tmp41_);
		for (; (_tmp44_ = g_variant_iter_next_value (&_tmp43_)) != NULL; _tmp42__length1++) {
			if (_tmp42__size == _tmp42__length) {
				_tmp42__size = 2 * _tmp42__size;
				_tmp42_ = g_renew (guint, _tmp42_, _tmp42__size + 1);
			}
			_tmp42_[_tmp42__length++] = g_variant_get_uint32 (_tmp44_);
			g_variant_unref (_tmp44_);
		}
		_tmp31_.modes_length1 = _tmp42__length1;
		_tmp31_.modes = _tmp42_;
		g_variant_unref (_tmp41_);
		_tmp45_ = g_variant_iter_next_value (&_tmp32_);
		_tmp46_ = g_new (guint, 5);
		_tmp46__length = 0;
		_tmp46__size = 4;
		_tmp46__length1 = 0;
		g_variant_iter_init (&_tmp47_, _tmp45_);
		for (; (_tmp48_ = g_variant_iter_next_value (&_tmp47_)) != NULL; _tmp46__length1++) {
			if (_tmp46__size == _tmp46__length) {
				_tmp46__size = 2 * _tmp46__size;
				_tmp46_ = g_renew (guint, _tmp46_, _tmp46__size + 1);
			}
			_tmp46_[_tmp46__length++] = g_variant_get_uint32 (_tmp48_);
			g_variant_unref (_tmp48_);
		}
		_tmp31_.clones_length1 = _tmp46__length1;
		_tmp31_.clones = _tmp46_;
		g_variant_unref (_tmp45_);
		_tmp49_ = g_variant_iter_next_value (&_tmp32_);
		_tmp50_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp51_, _tmp49_);
		while (g_variant_iter_loop (&_tmp51_, "{?*}", &_tmp52_, &_tmp53_)) {
			g_hash_table_insert (_tmp50_, g_variant_dup_string (_tmp52_, NULL), g_variant_get_variant (_tmp53_));
		}
		_tmp31_.properties = _tmp50_;
		g_variant_unref (_tmp49_);
		_tmp28_[_tmp28__length++] = _tmp31_;
		g_variant_unref (_tmp30_);
	}
	_vala_outputs_length1 = _tmp28__length1;
	_vala_outputs = _tmp28_;
	g_variant_unref (_tmp27_);
	*outputs = _vala_outputs;
	*outputs_length1 = _vala_outputs_length1;
	_vala_modes_length1 = 0;
	_tmp54_ = g_variant_iter_next_value (&_reply_iter);
	_tmp55_ = g_new (MutterReadDisplayMode, 5);
	_tmp55__length = 0;
	_tmp55__size = 4;
	_tmp55__length1 = 0;
	g_variant_iter_init (&_tmp56_, _tmp54_);
	for (; (_tmp57_ = g_variant_iter_next_value (&_tmp56_)) != NULL; _tmp55__length1++) {
		MutterReadDisplayMode _tmp58_;
		GVariantIter _tmp59_;
		GVariant* _tmp60_;
		GVariant* _tmp61_;
		GVariant* _tmp62_;
		GVariant* _tmp63_;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		if (_tmp55__size == _tmp55__length) {
			_tmp55__size = 2 * _tmp55__size;
			_tmp55_ = g_renew (MutterReadDisplayMode, _tmp55_, _tmp55__size + 1);
		}
		g_variant_iter_init (&_tmp59_, _tmp57_);
		_tmp60_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.id = g_variant_get_uint32 (_tmp60_);
		g_variant_unref (_tmp60_);
		_tmp61_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.winsys_id = g_variant_get_int64 (_tmp61_);
		g_variant_unref (_tmp61_);
		_tmp62_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.width = g_variant_get_uint32 (_tmp62_);
		g_variant_unref (_tmp62_);
		_tmp63_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.height = g_variant_get_uint32 (_tmp63_);
		g_variant_unref (_tmp63_);
		_tmp64_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.frequency = g_variant_get_double (_tmp64_);
		g_variant_unref (_tmp64_);
		_tmp65_ = g_variant_iter_next_value (&_tmp59_);
		_tmp58_.flags = g_variant_get_uint32 (_tmp65_);
		g_variant_unref (_tmp65_);
		_tmp55_[_tmp55__length++] = _tmp58_;
		g_variant_unref (_tmp57_);
	}
	_vala_modes_length1 = _tmp55__length1;
	_vala_modes = _tmp55_;
	g_variant_unref (_tmp54_);
	*modes = _vala_modes;
	*modes_length1 = _vala_modes_length1;
	_tmp66_ = g_variant_iter_next_value (&_reply_iter);
	_vala_max_screen_width = g_variant_get_int32 (_tmp66_);
	g_variant_unref (_tmp66_);
	*max_screen_width = _vala_max_screen_width;
	_tmp67_ = g_variant_iter_next_value (&_reply_iter);
	_vala_max_screen_height = g_variant_get_int32 (_tmp67_);
	g_variant_unref (_tmp67_);
	*max_screen_height = _vala_max_screen_height;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_apply_configuration (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           gboolean persistent,
                                                           MutterWriteDisplayCrtc* crtcs,
                                                           gint crtcs_length1,
                                                           MutterWriteDisplayOutput* outputs,
                                                           gint outputs_length1,
                                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	MutterWriteDisplayCrtc* _tmp68_;
	GVariantBuilder _tmp69_;
	gint _tmp70_;
	MutterWriteDisplayOutput* _tmp79_;
	GVariantBuilder _tmp80_;
	gint _tmp81_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ApplyConfiguration");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (persistent));
	_tmp68_ = crtcs;
	g_variant_builder_init (&_tmp69_, G_VARIANT_TYPE ("a(uiiiuaua{sv})"));
	for (_tmp70_ = 0; _tmp70_ < crtcs_length1; _tmp70_++) {
		GVariantBuilder _tmp71_;
		guint* _tmp72_;
		GVariantBuilder _tmp73_;
		gint _tmp74_;
		GVariantBuilder _tmp75_;
		GHashTableIter _tmp76_;
		gpointer _tmp77_;
		gpointer _tmp78_;
		g_variant_builder_init (&_tmp71_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp71_, g_variant_new_uint32 ((*_tmp68_).id));
		g_variant_builder_add_value (&_tmp71_, g_variant_new_int32 ((*_tmp68_).new_mode));
		g_variant_builder_add_value (&_tmp71_, g_variant_new_int32 ((*_tmp68_).x));
		g_variant_builder_add_value (&_tmp71_, g_variant_new_int32 ((*_tmp68_).y));
		g_variant_builder_add_value (&_tmp71_, g_variant_new_uint32 ((*_tmp68_).transform));
		_tmp72_ = (*_tmp68_).outputs;
		g_variant_builder_init (&_tmp73_, G_VARIANT_TYPE ("au"));
		for (_tmp74_ = 0; _tmp74_ < (*_tmp68_).outputs_length1; _tmp74_++) {
			g_variant_builder_add_value (&_tmp73_, g_variant_new_uint32 (*_tmp72_));
			_tmp72_++;
		}
		g_variant_builder_add_value (&_tmp71_, g_variant_builder_end (&_tmp73_));
		g_hash_table_iter_init (&_tmp76_, (*_tmp68_).properties);
		g_variant_builder_init (&_tmp75_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp76_, &_tmp77_, &_tmp78_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp77_;
			_value = (GVariant*) _tmp78_;
			g_variant_builder_add (&_tmp75_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp71_, g_variant_builder_end (&_tmp75_));
		g_variant_builder_add_value (&_tmp69_, g_variant_builder_end (&_tmp71_));
		_tmp68_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp69_));
	_tmp79_ = outputs;
	g_variant_builder_init (&_tmp80_, G_VARIANT_TYPE ("a(ua{sv})"));
	for (_tmp81_ = 0; _tmp81_ < outputs_length1; _tmp81_++) {
		GVariantBuilder _tmp82_;
		GVariantBuilder _tmp83_;
		GHashTableIter _tmp84_;
		gpointer _tmp85_;
		gpointer _tmp86_;
		g_variant_builder_init (&_tmp82_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp82_, g_variant_new_uint32 ((*_tmp79_).id));
		g_hash_table_iter_init (&_tmp84_, (*_tmp79_).properties);
		g_variant_builder_init (&_tmp83_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp84_, &_tmp85_, &_tmp86_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp85_;
			_value = (GVariant*) _tmp86_;
			g_variant_builder_add (&_tmp83_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp82_, g_variant_builder_end (&_tmp83_));
		g_variant_builder_add_value (&_tmp80_, g_variant_builder_end (&_tmp82_));
		_tmp79_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp80_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gint
mutter_display_config_interface_proxy_change_backlight (MutterDisplayConfigInterface* self,
                                                        guint serial,
                                                        guint output,
                                                        gint value,
                                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint _result = 0;
	GVariant* _tmp89_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ChangeBacklight");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (output));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gint _tmp87_ = 0;
		return _tmp87_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gint _tmp88_ = 0;
		g_object_unref (_reply_message);
		return _tmp88_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp89_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_int32 (_tmp89_);
	g_variant_unref (_tmp89_);
	g_object_unref (_reply_message);
	return _result;
}

static void
mutter_display_config_interface_proxy_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      guint serial,
                                                      guint crtc,
                                                      guint** red,
                                                      gint* red_length1,
                                                      guint** green,
                                                      gint* green_length1,
                                                      guint** blue,
                                                      gint* blue_length1,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint* _vala_red = NULL;
	gint _vala_red_length1;
	GVariant* _tmp90_;
	guint* _tmp91_;
	gint _tmp91__length;
	gint _tmp91__size;
	gint _tmp91__length1;
	GVariantIter _tmp92_;
	GVariant* _tmp93_;
	guint* _vala_green = NULL;
	gint _vala_green_length1;
	GVariant* _tmp94_;
	guint* _tmp95_;
	gint _tmp95__length;
	gint _tmp95__size;
	gint _tmp95__length1;
	GVariantIter _tmp96_;
	GVariant* _tmp97_;
	guint* _vala_blue = NULL;
	gint _vala_blue_length1;
	GVariant* _tmp98_;
	guint* _tmp99_;
	gint _tmp99__length;
	gint _tmp99__size;
	gint _tmp99__length1;
	GVariantIter _tmp100_;
	GVariant* _tmp101_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetCrtcGamma");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (crtc));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_red_length1 = 0;
	_tmp90_ = g_variant_iter_next_value (&_reply_iter);
	_tmp91_ = g_new (guint, 5);
	_tmp91__length = 0;
	_tmp91__size = 4;
	_tmp91__length1 = 0;
	g_variant_iter_init (&_tmp92_, _tmp90_);
	for (; (_tmp93_ = g_variant_iter_next_value (&_tmp92_)) != NULL; _tmp91__length1++) {
		if (_tmp91__size == _tmp91__length) {
			_tmp91__size = 2 * _tmp91__size;
			_tmp91_ = g_renew (guint, _tmp91_, _tmp91__size + 1);
		}
		_tmp91_[_tmp91__length++] = g_variant_get_uint32 (_tmp93_);
		g_variant_unref (_tmp93_);
	}
	_vala_red_length1 = _tmp91__length1;
	_vala_red = _tmp91_;
	g_variant_unref (_tmp90_);
	*red = _vala_red;
	*red_length1 = _vala_red_length1;
	_vala_green_length1 = 0;
	_tmp94_ = g_variant_iter_next_value (&_reply_iter);
	_tmp95_ = g_new (guint, 5);
	_tmp95__length = 0;
	_tmp95__size = 4;
	_tmp95__length1 = 0;
	g_variant_iter_init (&_tmp96_, _tmp94_);
	for (; (_tmp97_ = g_variant_iter_next_value (&_tmp96_)) != NULL; _tmp95__length1++) {
		if (_tmp95__size == _tmp95__length) {
			_tmp95__size = 2 * _tmp95__size;
			_tmp95_ = g_renew (guint, _tmp95_, _tmp95__size + 1);
		}
		_tmp95_[_tmp95__length++] = g_variant_get_uint32 (_tmp97_);
		g_variant_unref (_tmp97_);
	}
	_vala_green_length1 = _tmp95__length1;
	_vala_green = _tmp95_;
	g_variant_unref (_tmp94_);
	*green = _vala_green;
	*green_length1 = _vala_green_length1;
	_vala_blue_length1 = 0;
	_tmp98_ = g_variant_iter_next_value (&_reply_iter);
	_tmp99_ = g_new (guint, 5);
	_tmp99__length = 0;
	_tmp99__size = 4;
	_tmp99__length1 = 0;
	g_variant_iter_init (&_tmp100_, _tmp98_);
	for (; (_tmp101_ = g_variant_iter_next_value (&_tmp100_)) != NULL; _tmp99__length1++) {
		if (_tmp99__size == _tmp99__length) {
			_tmp99__size = 2 * _tmp99__size;
			_tmp99_ = g_renew (guint, _tmp99_, _tmp99__size + 1);
		}
		_tmp99_[_tmp99__length++] = g_variant_get_uint32 (_tmp101_);
		g_variant_unref (_tmp101_);
	}
	_vala_blue_length1 = _tmp99__length1;
	_vala_blue = _tmp99_;
	g_variant_unref (_tmp98_);
	*blue = _vala_blue;
	*blue_length1 = _vala_blue_length1;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      guint serial,
                                                      guint crtc,
                                                      guint* red,
                                                      gint red_length1,
                                                      guint* green,
                                                      gint green_length1,
                                                      guint* blue,
                                                      gint blue_length1,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	guint* _tmp102_;
	GVariantBuilder _tmp103_;
	gint _tmp104_;
	guint* _tmp105_;
	GVariantBuilder _tmp106_;
	gint _tmp107_;
	guint* _tmp108_;
	GVariantBuilder _tmp109_;
	gint _tmp110_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "SetCrtcGamma");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (crtc));
	_tmp102_ = red;
	g_variant_builder_init (&_tmp103_, G_VARIANT_TYPE ("au"));
	for (_tmp104_ = 0; _tmp104_ < red_length1; _tmp104_++) {
		g_variant_builder_add_value (&_tmp103_, g_variant_new_uint32 (*_tmp102_));
		_tmp102_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp103_));
	_tmp105_ = green;
	g_variant_builder_init (&_tmp106_, G_VARIANT_TYPE ("au"));
	for (_tmp107_ = 0; _tmp107_ < green_length1; _tmp107_++) {
		g_variant_builder_add_value (&_tmp106_, g_variant_new_uint32 (*_tmp105_));
		_tmp105_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp106_));
	_tmp108_ = blue;
	g_variant_builder_init (&_tmp109_, G_VARIANT_TYPE ("au"));
	for (_tmp110_ = 0; _tmp110_ < blue_length1; _tmp110_++) {
		g_variant_builder_add_value (&_tmp109_, g_variant_new_uint32 (*_tmp108_));
		_tmp108_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp109_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_get_current_state (MutterDisplayConfigInterface* self,
                                                         guint* serial,
                                                         MutterReadMonitor** monitors,
                                                         gint* monitors_length1,
                                                         MutterReadLogicalMonitor** logical_monitors,
                                                         gint* logical_monitors_length1,
                                                         GHashTable* * properties,
                                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint _vala_serial = 0U;
	GVariant* _tmp111_;
	MutterReadMonitor* _vala_monitors = NULL;
	gint _vala_monitors_length1;
	GVariant* _tmp112_;
	MutterReadMonitor* _tmp113_;
	gint _tmp113__length;
	gint _tmp113__size;
	gint _tmp113__length1;
	GVariantIter _tmp114_;
	GVariant* _tmp115_;
	MutterReadLogicalMonitor* _vala_logical_monitors = NULL;
	gint _vala_logical_monitors_length1;
	GVariant* _tmp150_;
	MutterReadLogicalMonitor* _tmp151_;
	gint _tmp151__length;
	gint _tmp151__size;
	gint _tmp151__length1;
	GVariantIter _tmp152_;
	GVariant* _tmp153_;
	GHashTable* _vala_properties = NULL;
	GVariant* _tmp176_;
	GHashTable* _tmp177_;
	GVariantIter _tmp178_;
	GVariant* _tmp179_;
	GVariant* _tmp180_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetCurrentState");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp111_ = g_variant_iter_next_value (&_reply_iter);
	_vala_serial = g_variant_get_uint32 (_tmp111_);
	g_variant_unref (_tmp111_);
	*serial = _vala_serial;
	_vala_monitors_length1 = 0;
	_tmp112_ = g_variant_iter_next_value (&_reply_iter);
	_tmp113_ = g_new (MutterReadMonitor, 5);
	_tmp113__length = 0;
	_tmp113__size = 4;
	_tmp113__length1 = 0;
	g_variant_iter_init (&_tmp114_, _tmp112_);
	for (; (_tmp115_ = g_variant_iter_next_value (&_tmp114_)) != NULL; _tmp113__length1++) {
		MutterReadMonitor _tmp116_;
		GVariantIter _tmp117_;
		GVariant* _tmp118_;
		MutterReadMonitorInfo _tmp119_;
		GVariantIter _tmp120_;
		GVariant* _tmp121_;
		GVariant* _tmp122_;
		GVariant* _tmp123_;
		GVariant* _tmp124_;
		GVariant* _tmp125_;
		MutterReadMonitorMode* _tmp126_;
		gint _tmp126__length;
		gint _tmp126__size;
		gint _tmp126__length1;
		GVariantIter _tmp127_;
		GVariant* _tmp128_;
		GVariant* _tmp145_;
		GHashTable* _tmp146_;
		GVariantIter _tmp147_;
		GVariant* _tmp148_;
		GVariant* _tmp149_;
		if (_tmp113__size == _tmp113__length) {
			_tmp113__size = 2 * _tmp113__size;
			_tmp113_ = g_renew (MutterReadMonitor, _tmp113_, _tmp113__size + 1);
		}
		g_variant_iter_init (&_tmp117_, _tmp115_);
		_tmp118_ = g_variant_iter_next_value (&_tmp117_);
		g_variant_iter_init (&_tmp120_, _tmp118_);
		_tmp121_ = g_variant_iter_next_value (&_tmp120_);
		_tmp119_.connector = g_variant_dup_string (_tmp121_, NULL);
		g_variant_unref (_tmp121_);
		_tmp122_ = g_variant_iter_next_value (&_tmp120_);
		_tmp119_.vendor = g_variant_dup_string (_tmp122_, NULL);
		g_variant_unref (_tmp122_);
		_tmp123_ = g_variant_iter_next_value (&_tmp120_);
		_tmp119_.product = g_variant_dup_string (_tmp123_, NULL);
		g_variant_unref (_tmp123_);
		_tmp124_ = g_variant_iter_next_value (&_tmp120_);
		_tmp119_.serial = g_variant_dup_string (_tmp124_, NULL);
		g_variant_unref (_tmp124_);
		_tmp116_.monitor = _tmp119_;
		g_variant_unref (_tmp118_);
		_tmp125_ = g_variant_iter_next_value (&_tmp117_);
		_tmp126_ = g_new (MutterReadMonitorMode, 5);
		_tmp126__length = 0;
		_tmp126__size = 4;
		_tmp126__length1 = 0;
		g_variant_iter_init (&_tmp127_, _tmp125_);
		for (; (_tmp128_ = g_variant_iter_next_value (&_tmp127_)) != NULL; _tmp126__length1++) {
			MutterReadMonitorMode _tmp129_;
			GVariantIter _tmp130_;
			GVariant* _tmp131_;
			GVariant* _tmp132_;
			GVariant* _tmp133_;
			GVariant* _tmp134_;
			GVariant* _tmp135_;
			GVariant* _tmp136_;
			gdouble* _tmp137_;
			gint _tmp137__length;
			gint _tmp137__size;
			gint _tmp137__length1;
			GVariantIter _tmp138_;
			GVariant* _tmp139_;
			GVariant* _tmp140_;
			GHashTable* _tmp141_;
			GVariantIter _tmp142_;
			GVariant* _tmp143_;
			GVariant* _tmp144_;
			if (_tmp126__size == _tmp126__length) {
				_tmp126__size = 2 * _tmp126__size;
				_tmp126_ = g_renew (MutterReadMonitorMode, _tmp126_, _tmp126__size + 1);
			}
			g_variant_iter_init (&_tmp130_, _tmp128_);
			_tmp131_ = g_variant_iter_next_value (&_tmp130_);
			_tmp129_.id = g_variant_dup_string (_tmp131_, NULL);
			g_variant_unref (_tmp131_);
			_tmp132_ = g_variant_iter_next_value (&_tmp130_);
			_tmp129_.width = g_variant_get_int32 (_tmp132_);
			g_variant_unref (_tmp132_);
			_tmp133_ = g_variant_iter_next_value (&_tmp130_);
			_tmp129_.height = g_variant_get_int32 (_tmp133_);
			g_variant_unref (_tmp133_);
			_tmp134_ = g_variant_iter_next_value (&_tmp130_);
			_tmp129_.frequency = g_variant_get_double (_tmp134_);
			g_variant_unref (_tmp134_);
			_tmp135_ = g_variant_iter_next_value (&_tmp130_);
			_tmp129_.preferred_scale = g_variant_get_double (_tmp135_);
			g_variant_unref (_tmp135_);
			_tmp136_ = g_variant_iter_next_value (&_tmp130_);
			_tmp137_ = g_new (gdouble, 5);
			_tmp137__length = 0;
			_tmp137__size = 4;
			_tmp137__length1 = 0;
			g_variant_iter_init (&_tmp138_, _tmp136_);
			for (; (_tmp139_ = g_variant_iter_next_value (&_tmp138_)) != NULL; _tmp137__length1++) {
				if (_tmp137__size == _tmp137__length) {
					_tmp137__size = 2 * _tmp137__size;
					_tmp137_ = g_renew (gdouble, _tmp137_, _tmp137__size + 1);
				}
				_tmp137_[_tmp137__length++] = g_variant_get_double (_tmp139_);
				g_variant_unref (_tmp139_);
			}
			_tmp129_.supported_scales_length1 = _tmp137__length1;
			_tmp129_.supported_scales = _tmp137_;
			g_variant_unref (_tmp136_);
			_tmp140_ = g_variant_iter_next_value (&_tmp130_);
			_tmp141_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp142_, _tmp140_);
			while (g_variant_iter_loop (&_tmp142_, "{?*}", &_tmp143_, &_tmp144_)) {
				g_hash_table_insert (_tmp141_, g_variant_dup_string (_tmp143_, NULL), g_variant_get_variant (_tmp144_));
			}
			_tmp129_.properties = _tmp141_;
			g_variant_unref (_tmp140_);
			_tmp126_[_tmp126__length++] = _tmp129_;
			g_variant_unref (_tmp128_);
		}
		_tmp116_.modes_length1 = _tmp126__length1;
		_tmp116_.modes = _tmp126_;
		g_variant_unref (_tmp125_);
		_tmp145_ = g_variant_iter_next_value (&_tmp117_);
		_tmp146_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp147_, _tmp145_);
		while (g_variant_iter_loop (&_tmp147_, "{?*}", &_tmp148_, &_tmp149_)) {
			g_hash_table_insert (_tmp146_, g_variant_dup_string (_tmp148_, NULL), g_variant_get_variant (_tmp149_));
		}
		_tmp116_.properties = _tmp146_;
		g_variant_unref (_tmp145_);
		_tmp113_[_tmp113__length++] = _tmp116_;
		g_variant_unref (_tmp115_);
	}
	_vala_monitors_length1 = _tmp113__length1;
	_vala_monitors = _tmp113_;
	g_variant_unref (_tmp112_);
	*monitors = _vala_monitors;
	*monitors_length1 = _vala_monitors_length1;
	_vala_logical_monitors_length1 = 0;
	_tmp150_ = g_variant_iter_next_value (&_reply_iter);
	_tmp151_ = g_new (MutterReadLogicalMonitor, 5);
	_tmp151__length = 0;
	_tmp151__size = 4;
	_tmp151__length1 = 0;
	g_variant_iter_init (&_tmp152_, _tmp150_);
	for (; (_tmp153_ = g_variant_iter_next_value (&_tmp152_)) != NULL; _tmp151__length1++) {
		MutterReadLogicalMonitor _tmp154_;
		GVariantIter _tmp155_;
		GVariant* _tmp156_;
		GVariant* _tmp157_;
		GVariant* _tmp158_;
		GVariant* _tmp159_;
		GVariant* _tmp160_;
		GVariant* _tmp161_;
		MutterReadMonitorInfo* _tmp162_;
		gint _tmp162__length;
		gint _tmp162__size;
		gint _tmp162__length1;
		GVariantIter _tmp163_;
		GVariant* _tmp164_;
		GVariant* _tmp171_;
		GHashTable* _tmp172_;
		GVariantIter _tmp173_;
		GVariant* _tmp174_;
		GVariant* _tmp175_;
		if (_tmp151__size == _tmp151__length) {
			_tmp151__size = 2 * _tmp151__size;
			_tmp151_ = g_renew (MutterReadLogicalMonitor, _tmp151_, _tmp151__size + 1);
		}
		g_variant_iter_init (&_tmp155_, _tmp153_);
		_tmp156_ = g_variant_iter_next_value (&_tmp155_);
		_tmp154_.x = g_variant_get_int32 (_tmp156_);
		g_variant_unref (_tmp156_);
		_tmp157_ = g_variant_iter_next_value (&_tmp155_);
		_tmp154_.y = g_variant_get_int32 (_tmp157_);
		g_variant_unref (_tmp157_);
		_tmp158_ = g_variant_iter_next_value (&_tmp155_);
		_tmp154_.scale = g_variant_get_double (_tmp158_);
		g_variant_unref (_tmp158_);
		_tmp159_ = g_variant_iter_next_value (&_tmp155_);
		_tmp154_.transform = g_variant_get_uint32 (_tmp159_);
		g_variant_unref (_tmp159_);
		_tmp160_ = g_variant_iter_next_value (&_tmp155_);
		_tmp154_.primary = g_variant_get_boolean (_tmp160_);
		g_variant_unref (_tmp160_);
		_tmp161_ = g_variant_iter_next_value (&_tmp155_);
		_tmp162_ = g_new (MutterReadMonitorInfo, 5);
		_tmp162__length = 0;
		_tmp162__size = 4;
		_tmp162__length1 = 0;
		g_variant_iter_init (&_tmp163_, _tmp161_);
		for (; (_tmp164_ = g_variant_iter_next_value (&_tmp163_)) != NULL; _tmp162__length1++) {
			MutterReadMonitorInfo _tmp165_;
			GVariantIter _tmp166_;
			GVariant* _tmp167_;
			GVariant* _tmp168_;
			GVariant* _tmp169_;
			GVariant* _tmp170_;
			if (_tmp162__size == _tmp162__length) {
				_tmp162__size = 2 * _tmp162__size;
				_tmp162_ = g_renew (MutterReadMonitorInfo, _tmp162_, _tmp162__size + 1);
			}
			g_variant_iter_init (&_tmp166_, _tmp164_);
			_tmp167_ = g_variant_iter_next_value (&_tmp166_);
			_tmp165_.connector = g_variant_dup_string (_tmp167_, NULL);
			g_variant_unref (_tmp167_);
			_tmp168_ = g_variant_iter_next_value (&_tmp166_);
			_tmp165_.vendor = g_variant_dup_string (_tmp168_, NULL);
			g_variant_unref (_tmp168_);
			_tmp169_ = g_variant_iter_next_value (&_tmp166_);
			_tmp165_.product = g_variant_dup_string (_tmp169_, NULL);
			g_variant_unref (_tmp169_);
			_tmp170_ = g_variant_iter_next_value (&_tmp166_);
			_tmp165_.serial = g_variant_dup_string (_tmp170_, NULL);
			g_variant_unref (_tmp170_);
			_tmp162_[_tmp162__length++] = _tmp165_;
			g_variant_unref (_tmp164_);
		}
		_tmp154_.monitors_length1 = _tmp162__length1;
		_tmp154_.monitors = _tmp162_;
		g_variant_unref (_tmp161_);
		_tmp171_ = g_variant_iter_next_value (&_tmp155_);
		_tmp172_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp173_, _tmp171_);
		while (g_variant_iter_loop (&_tmp173_, "{?*}", &_tmp174_, &_tmp175_)) {
			g_hash_table_insert (_tmp172_, g_variant_dup_string (_tmp174_, NULL), g_variant_get_variant (_tmp175_));
		}
		_tmp154_.properties = _tmp172_;
		g_variant_unref (_tmp171_);
		_tmp151_[_tmp151__length++] = _tmp154_;
		g_variant_unref (_tmp153_);
	}
	_vala_logical_monitors_length1 = _tmp151__length1;
	_vala_logical_monitors = _tmp151_;
	g_variant_unref (_tmp150_);
	*logical_monitors = _vala_logical_monitors;
	*logical_monitors_length1 = _vala_logical_monitors_length1;
	_tmp176_ = g_variant_iter_next_value (&_reply_iter);
	_tmp177_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp178_, _tmp176_);
	while (g_variant_iter_loop (&_tmp178_, "{?*}", &_tmp179_, &_tmp180_)) {
		g_hash_table_insert (_tmp177_, g_variant_dup_string (_tmp179_, NULL), g_variant_get_variant (_tmp180_));
	}
	_vala_properties = _tmp177_;
	g_variant_unref (_tmp176_);
	*properties = _vala_properties;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                             guint serial,
                                                             MutterApplyMethod method,
                                                             MutterWriteLogicalMonitor* logical_monitors,
                                                             gint logical_monitors_length1,
                                                             GHashTable* properties,
                                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	MutterWriteLogicalMonitor* _tmp181_;
	GVariantBuilder _tmp182_;
	gint _tmp183_;
	GVariantBuilder _tmp193_;
	GHashTableIter _tmp194_;
	gpointer _tmp195_;
	gpointer _tmp196_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ApplyMonitorsConfig");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (method));
	_tmp181_ = logical_monitors;
	g_variant_builder_init (&_tmp182_, G_VARIANT_TYPE ("a(iiduba(ssa{sv}))"));
	for (_tmp183_ = 0; _tmp183_ < logical_monitors_length1; _tmp183_++) {
		GVariantBuilder _tmp184_;
		MutterWriteMonitor* _tmp185_;
		GVariantBuilder _tmp186_;
		gint _tmp187_;
		g_variant_builder_init (&_tmp184_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp184_, g_variant_new_int32 ((*_tmp181_).x));
		g_variant_builder_add_value (&_tmp184_, g_variant_new_int32 ((*_tmp181_).y));
		g_variant_builder_add_value (&_tmp184_, g_variant_new_double ((*_tmp181_).scale));
		g_variant_builder_add_value (&_tmp184_, g_variant_new_uint32 ((*_tmp181_).transform));
		g_variant_builder_add_value (&_tmp184_, g_variant_new_boolean ((*_tmp181_).primary));
		_tmp185_ = (*_tmp181_).monitors;
		g_variant_builder_init (&_tmp186_, G_VARIANT_TYPE ("a(ssa{sv})"));
		for (_tmp187_ = 0; _tmp187_ < (*_tmp181_).monitors_length1; _tmp187_++) {
			GVariantBuilder _tmp188_;
			GVariantBuilder _tmp189_;
			GHashTableIter _tmp190_;
			gpointer _tmp191_;
			gpointer _tmp192_;
			g_variant_builder_init (&_tmp188_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp188_, g_variant_new_string ((*_tmp185_).connector));
			g_variant_builder_add_value (&_tmp188_, g_variant_new_string ((*_tmp185_).monitor_mode));
			g_hash_table_iter_init (&_tmp190_, (*_tmp185_).properties);
			g_variant_builder_init (&_tmp189_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp190_, &_tmp191_, &_tmp192_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp191_;
				_value = (GVariant*) _tmp192_;
				g_variant_builder_add (&_tmp189_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp188_, g_variant_builder_end (&_tmp189_));
			g_variant_builder_add_value (&_tmp186_, g_variant_builder_end (&_tmp188_));
			_tmp185_++;
		}
		g_variant_builder_add_value (&_tmp184_, g_variant_builder_end (&_tmp186_));
		g_variant_builder_add_value (&_tmp182_, g_variant_builder_end (&_tmp184_));
		_tmp181_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp182_));
	g_hash_table_iter_init (&_tmp194_, properties);
	g_variant_builder_init (&_tmp193_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp194_, &_tmp195_, &_tmp196_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp195_;
		_value = (GVariant*) _tmp196_;
		g_variant_builder_add (&_tmp193_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp193_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gint
mutter_display_config_interface_dbus_proxy_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	GVariant *_inner_reply;
	gint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PowerSaveMode");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.Mutter.DisplayConfig"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSaveMode"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint _tmp197_ = 0;
			return _tmp197_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
mutter_display_config_interface_dbus_proxy_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                gint value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.Mutter.DisplayConfig"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSaveMode"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static void
mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init (MutterDisplayConfigInterfaceIface* iface)
{
	iface->get_resources = mutter_display_config_interface_proxy_get_resources;
	iface->apply_configuration = mutter_display_config_interface_proxy_apply_configuration;
	iface->change_backlight = mutter_display_config_interface_proxy_change_backlight;
	iface->get_crtc_gamma = mutter_display_config_interface_proxy_get_crtc_gamma;
	iface->set_crtc_gamma = mutter_display_config_interface_proxy_set_crtc_gamma;
	iface->get_current_state = mutter_display_config_interface_proxy_get_current_state;
	iface->apply_monitors_config = mutter_display_config_interface_proxy_apply_monitors_config;
	iface->get_power_save_mode = mutter_display_config_interface_dbus_proxy_get_power_save_mode;
	iface->set_power_save_mode = mutter_display_config_interface_dbus_proxy_set_power_save_mode;
}

static void
_vala_MutterReadDisplayCrtc_array_free (MutterReadDisplayCrtc * array,
                                        gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_display_crtc_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterReadDisplayOutput_array_free (MutterReadDisplayOutput * array,
                                          gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_display_output_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint serial = 0U;
	MutterReadDisplayCrtc* crtcs = NULL;
	gint crtcs_length1 = 0;
	MutterReadDisplayCrtc* _tmp198_;
	GVariantBuilder _tmp199_;
	gint _tmp200_;
	MutterReadDisplayOutput* outputs = NULL;
	gint outputs_length1 = 0;
	MutterReadDisplayOutput* _tmp209_;
	GVariantBuilder _tmp210_;
	gint _tmp211_;
	MutterReadDisplayMode* modes = NULL;
	gint modes_length1 = 0;
	MutterReadDisplayMode* _tmp226_;
	GVariantBuilder _tmp227_;
	gint _tmp228_;
	gint max_screen_width = 0;
	gint max_screen_height = 0;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mutter_display_config_interface_get_resources (self, &serial, &crtcs, &crtcs_length1, &outputs, &outputs_length1, &modes, &modes_length1, &max_screen_width, &max_screen_height, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (serial));
	_tmp198_ = crtcs;
	g_variant_builder_init (&_tmp199_, G_VARIANT_TYPE ("a(uxiiiiiuaua{sv})"));
	for (_tmp200_ = 0; _tmp200_ < crtcs_length1; _tmp200_++) {
		GVariantBuilder _tmp201_;
		DisplayTransform* _tmp202_;
		GVariantBuilder _tmp203_;
		gint _tmp204_;
		GVariantBuilder _tmp205_;
		GHashTableIter _tmp206_;
		gpointer _tmp207_;
		gpointer _tmp208_;
		g_variant_builder_init (&_tmp201_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp201_, g_variant_new_uint32 ((*_tmp198_).id));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int64 ((*_tmp198_).winsys_id));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int32 ((*_tmp198_).x));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int32 ((*_tmp198_).y));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int32 ((*_tmp198_).width));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int32 ((*_tmp198_).height));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_int32 ((*_tmp198_).current_mode));
		g_variant_builder_add_value (&_tmp201_, g_variant_new_uint32 ((*_tmp198_).current_transform));
		_tmp202_ = (*_tmp198_).transforms;
		g_variant_builder_init (&_tmp203_, G_VARIANT_TYPE ("au"));
		for (_tmp204_ = 0; _tmp204_ < (*_tmp198_).transforms_length1; _tmp204_++) {
			g_variant_builder_add_value (&_tmp203_, g_variant_new_uint32 (*_tmp202_));
			_tmp202_++;
		}
		g_variant_builder_add_value (&_tmp201_, g_variant_builder_end (&_tmp203_));
		g_hash_table_iter_init (&_tmp206_, (*_tmp198_).properties);
		g_variant_builder_init (&_tmp205_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp206_, &_tmp207_, &_tmp208_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp207_;
			_value = (GVariant*) _tmp208_;
			g_variant_builder_add (&_tmp205_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp201_, g_variant_builder_end (&_tmp205_));
		g_variant_builder_add_value (&_tmp199_, g_variant_builder_end (&_tmp201_));
		_tmp198_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp199_));
	_tmp209_ = outputs;
	g_variant_builder_init (&_tmp210_, G_VARIANT_TYPE ("a(uxiausauaua{sv})"));
	for (_tmp211_ = 0; _tmp211_ < outputs_length1; _tmp211_++) {
		GVariantBuilder _tmp212_;
		guint* _tmp213_;
		GVariantBuilder _tmp214_;
		gint _tmp215_;
		guint* _tmp216_;
		GVariantBuilder _tmp217_;
		gint _tmp218_;
		guint* _tmp219_;
		GVariantBuilder _tmp220_;
		gint _tmp221_;
		GVariantBuilder _tmp222_;
		GHashTableIter _tmp223_;
		gpointer _tmp224_;
		gpointer _tmp225_;
		g_variant_builder_init (&_tmp212_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp212_, g_variant_new_uint32 ((*_tmp209_).id));
		g_variant_builder_add_value (&_tmp212_, g_variant_new_int64 ((*_tmp209_).winsys_id));
		g_variant_builder_add_value (&_tmp212_, g_variant_new_int32 ((*_tmp209_).current_crtc));
		_tmp213_ = (*_tmp209_).possible_crtcs;
		g_variant_builder_init (&_tmp214_, G_VARIANT_TYPE ("au"));
		for (_tmp215_ = 0; _tmp215_ < (*_tmp209_).possible_crtcs_length1; _tmp215_++) {
			g_variant_builder_add_value (&_tmp214_, g_variant_new_uint32 (*_tmp213_));
			_tmp213_++;
		}
		g_variant_builder_add_value (&_tmp212_, g_variant_builder_end (&_tmp214_));
		g_variant_builder_add_value (&_tmp212_, g_variant_new_string ((*_tmp209_).connector_name));
		_tmp216_ = (*_tmp209_).modes;
		g_variant_builder_init (&_tmp217_, G_VARIANT_TYPE ("au"));
		for (_tmp218_ = 0; _tmp218_ < (*_tmp209_).modes_length1; _tmp218_++) {
			g_variant_builder_add_value (&_tmp217_, g_variant_new_uint32 (*_tmp216_));
			_tmp216_++;
		}
		g_variant_builder_add_value (&_tmp212_, g_variant_builder_end (&_tmp217_));
		_tmp219_ = (*_tmp209_).clones;
		g_variant_builder_init (&_tmp220_, G_VARIANT_TYPE ("au"));
		for (_tmp221_ = 0; _tmp221_ < (*_tmp209_).clones_length1; _tmp221_++) {
			g_variant_builder_add_value (&_tmp220_, g_variant_new_uint32 (*_tmp219_));
			_tmp219_++;
		}
		g_variant_builder_add_value (&_tmp212_, g_variant_builder_end (&_tmp220_));
		g_hash_table_iter_init (&_tmp223_, (*_tmp209_).properties);
		g_variant_builder_init (&_tmp222_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp223_, &_tmp224_, &_tmp225_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp224_;
			_value = (GVariant*) _tmp225_;
			g_variant_builder_add (&_tmp222_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp212_, g_variant_builder_end (&_tmp222_));
		g_variant_builder_add_value (&_tmp210_, g_variant_builder_end (&_tmp212_));
		_tmp209_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp210_));
	_tmp226_ = modes;
	g_variant_builder_init (&_tmp227_, G_VARIANT_TYPE ("a(uxuudu)"));
	for (_tmp228_ = 0; _tmp228_ < modes_length1; _tmp228_++) {
		GVariantBuilder _tmp229_;
		g_variant_builder_init (&_tmp229_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp229_, g_variant_new_uint32 ((*_tmp226_).id));
		g_variant_builder_add_value (&_tmp229_, g_variant_new_int64 ((*_tmp226_).winsys_id));
		g_variant_builder_add_value (&_tmp229_, g_variant_new_uint32 ((*_tmp226_).width));
		g_variant_builder_add_value (&_tmp229_, g_variant_new_uint32 ((*_tmp226_).height));
		g_variant_builder_add_value (&_tmp229_, g_variant_new_double ((*_tmp226_).frequency));
		g_variant_builder_add_value (&_tmp229_, g_variant_new_uint32 ((*_tmp226_).flags));
		g_variant_builder_add_value (&_tmp227_, g_variant_builder_end (&_tmp229_));
		_tmp226_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp227_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (max_screen_width));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (max_screen_height));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	crtcs = (_vala_MutterReadDisplayCrtc_array_free (crtcs, crtcs_length1), NULL);
	outputs = (_vala_MutterReadDisplayOutput_array_free (outputs, outputs_length1), NULL);
	modes = (g_free (modes), NULL);
}

static void
_vala_MutterWriteDisplayCrtc_array_free (MutterWriteDisplayCrtc * array,
                                         gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_display_crtc_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterWriteDisplayOutput_array_free (MutterWriteDisplayOutput * array,
                                           gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_display_output_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp230_;
	gboolean persistent = FALSE;
	GVariant* _tmp231_;
	MutterWriteDisplayCrtc* crtcs = NULL;
	gint crtcs_length1 = 0;
	GVariant* _tmp232_;
	MutterWriteDisplayCrtc* _tmp233_;
	gint _tmp233__length;
	gint _tmp233__size;
	gint _tmp233__length1;
	GVariantIter _tmp234_;
	GVariant* _tmp235_;
	MutterWriteDisplayOutput* outputs = NULL;
	gint outputs_length1 = 0;
	GVariant* _tmp252_;
	MutterWriteDisplayOutput* _tmp253_;
	gint _tmp253__length;
	gint _tmp253__size;
	gint _tmp253__length1;
	GVariantIter _tmp254_;
	GVariant* _tmp255_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp230_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp230_);
	g_variant_unref (_tmp230_);
	_tmp231_ = g_variant_iter_next_value (&_arguments_iter);
	persistent = g_variant_get_boolean (_tmp231_);
	g_variant_unref (_tmp231_);
	_tmp232_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp233_ = g_new (MutterWriteDisplayCrtc, 5);
	_tmp233__length = 0;
	_tmp233__size = 4;
	_tmp233__length1 = 0;
	g_variant_iter_init (&_tmp234_, _tmp232_);
	for (; (_tmp235_ = g_variant_iter_next_value (&_tmp234_)) != NULL; _tmp233__length1++) {
		MutterWriteDisplayCrtc _tmp236_;
		GVariantIter _tmp237_;
		GVariant* _tmp238_;
		GVariant* _tmp239_;
		GVariant* _tmp240_;
		GVariant* _tmp241_;
		GVariant* _tmp242_;
		GVariant* _tmp243_;
		guint* _tmp244_;
		gint _tmp244__length;
		gint _tmp244__size;
		gint _tmp244__length1;
		GVariantIter _tmp245_;
		GVariant* _tmp246_;
		GVariant* _tmp247_;
		GHashTable* _tmp248_;
		GVariantIter _tmp249_;
		GVariant* _tmp250_;
		GVariant* _tmp251_;
		if (_tmp233__size == _tmp233__length) {
			_tmp233__size = 2 * _tmp233__size;
			_tmp233_ = g_renew (MutterWriteDisplayCrtc, _tmp233_, _tmp233__size + 1);
		}
		g_variant_iter_init (&_tmp237_, _tmp235_);
		_tmp238_ = g_variant_iter_next_value (&_tmp237_);
		_tmp236_.id = g_variant_get_uint32 (_tmp238_);
		g_variant_unref (_tmp238_);
		_tmp239_ = g_variant_iter_next_value (&_tmp237_);
		_tmp236_.new_mode = g_variant_get_int32 (_tmp239_);
		g_variant_unref (_tmp239_);
		_tmp240_ = g_variant_iter_next_value (&_tmp237_);
		_tmp236_.x = g_variant_get_int32 (_tmp240_);
		g_variant_unref (_tmp240_);
		_tmp241_ = g_variant_iter_next_value (&_tmp237_);
		_tmp236_.y = g_variant_get_int32 (_tmp241_);
		g_variant_unref (_tmp241_);
		_tmp242_ = g_variant_iter_next_value (&_tmp237_);
		_tmp236_.transform = g_variant_get_uint32 (_tmp242_);
		g_variant_unref (_tmp242_);
		_tmp243_ = g_variant_iter_next_value (&_tmp237_);
		_tmp244_ = g_new (guint, 5);
		_tmp244__length = 0;
		_tmp244__size = 4;
		_tmp244__length1 = 0;
		g_variant_iter_init (&_tmp245_, _tmp243_);
		for (; (_tmp246_ = g_variant_iter_next_value (&_tmp245_)) != NULL; _tmp244__length1++) {
			if (_tmp244__size == _tmp244__length) {
				_tmp244__size = 2 * _tmp244__size;
				_tmp244_ = g_renew (guint, _tmp244_, _tmp244__size + 1);
			}
			_tmp244_[_tmp244__length++] = g_variant_get_uint32 (_tmp246_);
			g_variant_unref (_tmp246_);
		}
		_tmp236_.outputs_length1 = _tmp244__length1;
		_tmp236_.outputs = _tmp244_;
		g_variant_unref (_tmp243_);
		_tmp247_ = g_variant_iter_next_value (&_tmp237_);
		_tmp248_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp249_, _tmp247_);
		while (g_variant_iter_loop (&_tmp249_, "{?*}", &_tmp250_, &_tmp251_)) {
			g_hash_table_insert (_tmp248_, g_variant_dup_string (_tmp250_, NULL), g_variant_get_variant (_tmp251_));
		}
		_tmp236_.properties = _tmp248_;
		g_variant_unref (_tmp247_);
		_tmp233_[_tmp233__length++] = _tmp236_;
		g_variant_unref (_tmp235_);
	}
	crtcs_length1 = _tmp233__length1;
	crtcs = _tmp233_;
	g_variant_unref (_tmp232_);
	_tmp252_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp253_ = g_new (MutterWriteDisplayOutput, 5);
	_tmp253__length = 0;
	_tmp253__size = 4;
	_tmp253__length1 = 0;
	g_variant_iter_init (&_tmp254_, _tmp252_);
	for (; (_tmp255_ = g_variant_iter_next_value (&_tmp254_)) != NULL; _tmp253__length1++) {
		MutterWriteDisplayOutput _tmp256_;
		GVariantIter _tmp257_;
		GVariant* _tmp258_;
		GVariant* _tmp259_;
		GHashTable* _tmp260_;
		GVariantIter _tmp261_;
		GVariant* _tmp262_;
		GVariant* _tmp263_;
		if (_tmp253__size == _tmp253__length) {
			_tmp253__size = 2 * _tmp253__size;
			_tmp253_ = g_renew (MutterWriteDisplayOutput, _tmp253_, _tmp253__size + 1);
		}
		g_variant_iter_init (&_tmp257_, _tmp255_);
		_tmp258_ = g_variant_iter_next_value (&_tmp257_);
		_tmp256_.id = g_variant_get_uint32 (_tmp258_);
		g_variant_unref (_tmp258_);
		_tmp259_ = g_variant_iter_next_value (&_tmp257_);
		_tmp260_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp261_, _tmp259_);
		while (g_variant_iter_loop (&_tmp261_, "{?*}", &_tmp262_, &_tmp263_)) {
			g_hash_table_insert (_tmp260_, g_variant_dup_string (_tmp262_, NULL), g_variant_get_variant (_tmp263_));
		}
		_tmp256_.properties = _tmp260_;
		g_variant_unref (_tmp259_);
		_tmp253_[_tmp253__length++] = _tmp256_;
		g_variant_unref (_tmp255_);
	}
	outputs_length1 = _tmp253__length1;
	outputs = _tmp253_;
	g_variant_unref (_tmp252_);
	mutter_display_config_interface_apply_configuration (self, serial, persistent, crtcs, crtcs_length1, outputs, outputs_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	crtcs = (_vala_MutterWriteDisplayCrtc_array_free (crtcs, crtcs_length1), NULL);
	outputs = (_vala_MutterWriteDisplayOutput_array_free (outputs, outputs_length1), NULL);
}

static void
_dbus_mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp264_;
	guint output = 0U;
	GVariant* _tmp265_;
	gint value = 0;
	GVariant* _tmp266_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp264_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp264_);
	g_variant_unref (_tmp264_);
	_tmp265_ = g_variant_iter_next_value (&_arguments_iter);
	output = g_variant_get_uint32 (_tmp265_);
	g_variant_unref (_tmp265_);
	_tmp266_ = g_variant_iter_next_value (&_arguments_iter);
	value = g_variant_get_int32 (_tmp266_);
	g_variant_unref (_tmp266_);
	result = mutter_display_config_interface_change_backlight (self, serial, output, value, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp267_;
	guint crtc = 0U;
	GVariant* _tmp268_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* red = NULL;
	gint red_length1 = 0;
	guint* _tmp269_;
	GVariantBuilder _tmp270_;
	gint _tmp271_;
	guint* green = NULL;
	gint green_length1 = 0;
	guint* _tmp272_;
	GVariantBuilder _tmp273_;
	gint _tmp274_;
	guint* blue = NULL;
	gint blue_length1 = 0;
	guint* _tmp275_;
	GVariantBuilder _tmp276_;
	gint _tmp277_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp267_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp267_);
	g_variant_unref (_tmp267_);
	_tmp268_ = g_variant_iter_next_value (&_arguments_iter);
	crtc = g_variant_get_uint32 (_tmp268_);
	g_variant_unref (_tmp268_);
	mutter_display_config_interface_get_crtc_gamma (self, serial, crtc, &red, &red_length1, &green, &green_length1, &blue, &blue_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp269_ = red;
	g_variant_builder_init (&_tmp270_, G_VARIANT_TYPE ("au"));
	for (_tmp271_ = 0; _tmp271_ < red_length1; _tmp271_++) {
		g_variant_builder_add_value (&_tmp270_, g_variant_new_uint32 (*_tmp269_));
		_tmp269_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp270_));
	_tmp272_ = green;
	g_variant_builder_init (&_tmp273_, G_VARIANT_TYPE ("au"));
	for (_tmp274_ = 0; _tmp274_ < green_length1; _tmp274_++) {
		g_variant_builder_add_value (&_tmp273_, g_variant_new_uint32 (*_tmp272_));
		_tmp272_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp273_));
	_tmp275_ = blue;
	g_variant_builder_init (&_tmp276_, G_VARIANT_TYPE ("au"));
	for (_tmp277_ = 0; _tmp277_ < blue_length1; _tmp277_++) {
		g_variant_builder_add_value (&_tmp276_, g_variant_new_uint32 (*_tmp275_));
		_tmp275_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp276_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	red = (g_free (red), NULL);
	green = (g_free (green), NULL);
	blue = (g_free (blue), NULL);
}

static void
_dbus_mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp278_;
	guint crtc = 0U;
	GVariant* _tmp279_;
	guint* red = NULL;
	gint red_length1 = 0;
	GVariant* _tmp280_;
	guint* _tmp281_;
	gint _tmp281__length;
	gint _tmp281__size;
	gint _tmp281__length1;
	GVariantIter _tmp282_;
	GVariant* _tmp283_;
	guint* green = NULL;
	gint green_length1 = 0;
	GVariant* _tmp284_;
	guint* _tmp285_;
	gint _tmp285__length;
	gint _tmp285__size;
	gint _tmp285__length1;
	GVariantIter _tmp286_;
	GVariant* _tmp287_;
	guint* blue = NULL;
	gint blue_length1 = 0;
	GVariant* _tmp288_;
	guint* _tmp289_;
	gint _tmp289__length;
	gint _tmp289__size;
	gint _tmp289__length1;
	GVariantIter _tmp290_;
	GVariant* _tmp291_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp278_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp278_);
	g_variant_unref (_tmp278_);
	_tmp279_ = g_variant_iter_next_value (&_arguments_iter);
	crtc = g_variant_get_uint32 (_tmp279_);
	g_variant_unref (_tmp279_);
	_tmp280_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp281_ = g_new (guint, 5);
	_tmp281__length = 0;
	_tmp281__size = 4;
	_tmp281__length1 = 0;
	g_variant_iter_init (&_tmp282_, _tmp280_);
	for (; (_tmp283_ = g_variant_iter_next_value (&_tmp282_)) != NULL; _tmp281__length1++) {
		if (_tmp281__size == _tmp281__length) {
			_tmp281__size = 2 * _tmp281__size;
			_tmp281_ = g_renew (guint, _tmp281_, _tmp281__size + 1);
		}
		_tmp281_[_tmp281__length++] = g_variant_get_uint32 (_tmp283_);
		g_variant_unref (_tmp283_);
	}
	red_length1 = _tmp281__length1;
	red = _tmp281_;
	g_variant_unref (_tmp280_);
	_tmp284_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp285_ = g_new (guint, 5);
	_tmp285__length = 0;
	_tmp285__size = 4;
	_tmp285__length1 = 0;
	g_variant_iter_init (&_tmp286_, _tmp284_);
	for (; (_tmp287_ = g_variant_iter_next_value (&_tmp286_)) != NULL; _tmp285__length1++) {
		if (_tmp285__size == _tmp285__length) {
			_tmp285__size = 2 * _tmp285__size;
			_tmp285_ = g_renew (guint, _tmp285_, _tmp285__size + 1);
		}
		_tmp285_[_tmp285__length++] = g_variant_get_uint32 (_tmp287_);
		g_variant_unref (_tmp287_);
	}
	green_length1 = _tmp285__length1;
	green = _tmp285_;
	g_variant_unref (_tmp284_);
	_tmp288_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp289_ = g_new (guint, 5);
	_tmp289__length = 0;
	_tmp289__size = 4;
	_tmp289__length1 = 0;
	g_variant_iter_init (&_tmp290_, _tmp288_);
	for (; (_tmp291_ = g_variant_iter_next_value (&_tmp290_)) != NULL; _tmp289__length1++) {
		if (_tmp289__size == _tmp289__length) {
			_tmp289__size = 2 * _tmp289__size;
			_tmp289_ = g_renew (guint, _tmp289_, _tmp289__size + 1);
		}
		_tmp289_[_tmp289__length++] = g_variant_get_uint32 (_tmp291_);
		g_variant_unref (_tmp291_);
	}
	blue_length1 = _tmp289__length1;
	blue = _tmp289_;
	g_variant_unref (_tmp288_);
	mutter_display_config_interface_set_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	red = (g_free (red), NULL);
	green = (g_free (green), NULL);
	blue = (g_free (blue), NULL);
}

static void
_vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                    gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                           gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint serial = 0U;
	MutterReadMonitor* monitors = NULL;
	gint monitors_length1 = 0;
	MutterReadMonitor* _tmp292_;
	GVariantBuilder _tmp293_;
	gint _tmp294_;
	MutterReadLogicalMonitor* logical_monitors = NULL;
	gint logical_monitors_length1 = 0;
	MutterReadLogicalMonitor* _tmp312_;
	GVariantBuilder _tmp313_;
	gint _tmp314_;
	GHashTable* properties = NULL;
	GVariantBuilder _tmp324_;
	GHashTableIter _tmp325_;
	gpointer _tmp326_;
	gpointer _tmp327_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mutter_display_config_interface_get_current_state (self, &serial, &monitors, &monitors_length1, &logical_monitors, &logical_monitors_length1, &properties, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (serial));
	_tmp292_ = monitors;
	g_variant_builder_init (&_tmp293_, G_VARIANT_TYPE ("a((ssss)a(siiddada{sv})a{sv})"));
	for (_tmp294_ = 0; _tmp294_ < monitors_length1; _tmp294_++) {
		GVariantBuilder _tmp295_;
		GVariantBuilder _tmp296_;
		MutterReadMonitorMode* _tmp297_;
		GVariantBuilder _tmp298_;
		gint _tmp299_;
		GVariantBuilder _tmp308_;
		GHashTableIter _tmp309_;
		gpointer _tmp310_;
		gpointer _tmp311_;
		g_variant_builder_init (&_tmp295_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_init (&_tmp296_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp296_, g_variant_new_string ((*_tmp292_).monitor.connector));
		g_variant_builder_add_value (&_tmp296_, g_variant_new_string ((*_tmp292_).monitor.vendor));
		g_variant_builder_add_value (&_tmp296_, g_variant_new_string ((*_tmp292_).monitor.product));
		g_variant_builder_add_value (&_tmp296_, g_variant_new_string ((*_tmp292_).monitor.serial));
		g_variant_builder_add_value (&_tmp295_, g_variant_builder_end (&_tmp296_));
		_tmp297_ = (*_tmp292_).modes;
		g_variant_builder_init (&_tmp298_, G_VARIANT_TYPE ("a(siiddada{sv})"));
		for (_tmp299_ = 0; _tmp299_ < (*_tmp292_).modes_length1; _tmp299_++) {
			GVariantBuilder _tmp300_;
			gdouble* _tmp301_;
			GVariantBuilder _tmp302_;
			gint _tmp303_;
			GVariantBuilder _tmp304_;
			GHashTableIter _tmp305_;
			gpointer _tmp306_;
			gpointer _tmp307_;
			g_variant_builder_init (&_tmp300_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp300_, g_variant_new_string ((*_tmp297_).id));
			g_variant_builder_add_value (&_tmp300_, g_variant_new_int32 ((*_tmp297_).width));
			g_variant_builder_add_value (&_tmp300_, g_variant_new_int32 ((*_tmp297_).height));
			g_variant_builder_add_value (&_tmp300_, g_variant_new_double ((*_tmp297_).frequency));
			g_variant_builder_add_value (&_tmp300_, g_variant_new_double ((*_tmp297_).preferred_scale));
			_tmp301_ = (*_tmp297_).supported_scales;
			g_variant_builder_init (&_tmp302_, G_VARIANT_TYPE ("ad"));
			for (_tmp303_ = 0; _tmp303_ < (*_tmp297_).supported_scales_length1; _tmp303_++) {
				g_variant_builder_add_value (&_tmp302_, g_variant_new_double (*_tmp301_));
				_tmp301_++;
			}
			g_variant_builder_add_value (&_tmp300_, g_variant_builder_end (&_tmp302_));
			g_hash_table_iter_init (&_tmp305_, (*_tmp297_).properties);
			g_variant_builder_init (&_tmp304_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp305_, &_tmp306_, &_tmp307_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp306_;
				_value = (GVariant*) _tmp307_;
				g_variant_builder_add (&_tmp304_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp300_, g_variant_builder_end (&_tmp304_));
			g_variant_builder_add_value (&_tmp298_, g_variant_builder_end (&_tmp300_));
			_tmp297_++;
		}
		g_variant_builder_add_value (&_tmp295_, g_variant_builder_end (&_tmp298_));
		g_hash_table_iter_init (&_tmp309_, (*_tmp292_).properties);
		g_variant_builder_init (&_tmp308_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp309_, &_tmp310_, &_tmp311_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp310_;
			_value = (GVariant*) _tmp311_;
			g_variant_builder_add (&_tmp308_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp295_, g_variant_builder_end (&_tmp308_));
		g_variant_builder_add_value (&_tmp293_, g_variant_builder_end (&_tmp295_));
		_tmp292_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp293_));
	_tmp312_ = logical_monitors;
	g_variant_builder_init (&_tmp313_, G_VARIANT_TYPE ("a(iiduba(ssss)a{sv})"));
	for (_tmp314_ = 0; _tmp314_ < logical_monitors_length1; _tmp314_++) {
		GVariantBuilder _tmp315_;
		MutterReadMonitorInfo* _tmp316_;
		GVariantBuilder _tmp317_;
		gint _tmp318_;
		GVariantBuilder _tmp320_;
		GHashTableIter _tmp321_;
		gpointer _tmp322_;
		gpointer _tmp323_;
		g_variant_builder_init (&_tmp315_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp315_, g_variant_new_int32 ((*_tmp312_).x));
		g_variant_builder_add_value (&_tmp315_, g_variant_new_int32 ((*_tmp312_).y));
		g_variant_builder_add_value (&_tmp315_, g_variant_new_double ((*_tmp312_).scale));
		g_variant_builder_add_value (&_tmp315_, g_variant_new_uint32 ((*_tmp312_).transform));
		g_variant_builder_add_value (&_tmp315_, g_variant_new_boolean ((*_tmp312_).primary));
		_tmp316_ = (*_tmp312_).monitors;
		g_variant_builder_init (&_tmp317_, G_VARIANT_TYPE ("a(ssss)"));
		for (_tmp318_ = 0; _tmp318_ < (*_tmp312_).monitors_length1; _tmp318_++) {
			GVariantBuilder _tmp319_;
			g_variant_builder_init (&_tmp319_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp319_, g_variant_new_string ((*_tmp316_).connector));
			g_variant_builder_add_value (&_tmp319_, g_variant_new_string ((*_tmp316_).vendor));
			g_variant_builder_add_value (&_tmp319_, g_variant_new_string ((*_tmp316_).product));
			g_variant_builder_add_value (&_tmp319_, g_variant_new_string ((*_tmp316_).serial));
			g_variant_builder_add_value (&_tmp317_, g_variant_builder_end (&_tmp319_));
			_tmp316_++;
		}
		g_variant_builder_add_value (&_tmp315_, g_variant_builder_end (&_tmp317_));
		g_hash_table_iter_init (&_tmp321_, (*_tmp312_).properties);
		g_variant_builder_init (&_tmp320_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp321_, &_tmp322_, &_tmp323_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp322_;
			_value = (GVariant*) _tmp323_;
			g_variant_builder_add (&_tmp320_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp315_, g_variant_builder_end (&_tmp320_));
		g_variant_builder_add_value (&_tmp313_, g_variant_builder_end (&_tmp315_));
		_tmp312_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp313_));
	g_hash_table_iter_init (&_tmp325_, properties);
	g_variant_builder_init (&_tmp324_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp325_, &_tmp326_, &_tmp327_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp326_;
		_value = (GVariant*) _tmp327_;
		g_variant_builder_add (&_tmp324_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp324_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	monitors = (_vala_MutterReadMonitor_array_free (monitors, monitors_length1), NULL);
	logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
	_g_hash_table_unref0 (properties);
}

static void
_vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                            gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp328_;
	MutterApplyMethod method = 0;
	GVariant* _tmp329_;
	MutterWriteLogicalMonitor* logical_monitors = NULL;
	gint logical_monitors_length1 = 0;
	GVariant* _tmp330_;
	MutterWriteLogicalMonitor* _tmp331_;
	gint _tmp331__length;
	gint _tmp331__size;
	gint _tmp331__length1;
	GVariantIter _tmp332_;
	GVariant* _tmp333_;
	GHashTable* properties = NULL;
	GVariant* _tmp354_;
	GHashTable* _tmp355_;
	GVariantIter _tmp356_;
	GVariant* _tmp357_;
	GVariant* _tmp358_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp328_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp328_);
	g_variant_unref (_tmp328_);
	_tmp329_ = g_variant_iter_next_value (&_arguments_iter);
	method = g_variant_get_uint32 (_tmp329_);
	g_variant_unref (_tmp329_);
	_tmp330_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp331_ = g_new (MutterWriteLogicalMonitor, 5);
	_tmp331__length = 0;
	_tmp331__size = 4;
	_tmp331__length1 = 0;
	g_variant_iter_init (&_tmp332_, _tmp330_);
	for (; (_tmp333_ = g_variant_iter_next_value (&_tmp332_)) != NULL; _tmp331__length1++) {
		MutterWriteLogicalMonitor _tmp334_;
		GVariantIter _tmp335_;
		GVariant* _tmp336_;
		GVariant* _tmp337_;
		GVariant* _tmp338_;
		GVariant* _tmp339_;
		GVariant* _tmp340_;
		GVariant* _tmp341_;
		MutterWriteMonitor* _tmp342_;
		gint _tmp342__length;
		gint _tmp342__size;
		gint _tmp342__length1;
		GVariantIter _tmp343_;
		GVariant* _tmp344_;
		if (_tmp331__size == _tmp331__length) {
			_tmp331__size = 2 * _tmp331__size;
			_tmp331_ = g_renew (MutterWriteLogicalMonitor, _tmp331_, _tmp331__size + 1);
		}
		g_variant_iter_init (&_tmp335_, _tmp333_);
		_tmp336_ = g_variant_iter_next_value (&_tmp335_);
		_tmp334_.x = g_variant_get_int32 (_tmp336_);
		g_variant_unref (_tmp336_);
		_tmp337_ = g_variant_iter_next_value (&_tmp335_);
		_tmp334_.y = g_variant_get_int32 (_tmp337_);
		g_variant_unref (_tmp337_);
		_tmp338_ = g_variant_iter_next_value (&_tmp335_);
		_tmp334_.scale = g_variant_get_double (_tmp338_);
		g_variant_unref (_tmp338_);
		_tmp339_ = g_variant_iter_next_value (&_tmp335_);
		_tmp334_.transform = g_variant_get_uint32 (_tmp339_);
		g_variant_unref (_tmp339_);
		_tmp340_ = g_variant_iter_next_value (&_tmp335_);
		_tmp334_.primary = g_variant_get_boolean (_tmp340_);
		g_variant_unref (_tmp340_);
		_tmp341_ = g_variant_iter_next_value (&_tmp335_);
		_tmp342_ = g_new (MutterWriteMonitor, 5);
		_tmp342__length = 0;
		_tmp342__size = 4;
		_tmp342__length1 = 0;
		g_variant_iter_init (&_tmp343_, _tmp341_);
		for (; (_tmp344_ = g_variant_iter_next_value (&_tmp343_)) != NULL; _tmp342__length1++) {
			MutterWriteMonitor _tmp345_;
			GVariantIter _tmp346_;
			GVariant* _tmp347_;
			GVariant* _tmp348_;
			GVariant* _tmp349_;
			GHashTable* _tmp350_;
			GVariantIter _tmp351_;
			GVariant* _tmp352_;
			GVariant* _tmp353_;
			if (_tmp342__size == _tmp342__length) {
				_tmp342__size = 2 * _tmp342__size;
				_tmp342_ = g_renew (MutterWriteMonitor, _tmp342_, _tmp342__size + 1);
			}
			g_variant_iter_init (&_tmp346_, _tmp344_);
			_tmp347_ = g_variant_iter_next_value (&_tmp346_);
			_tmp345_.connector = g_variant_dup_string (_tmp347_, NULL);
			g_variant_unref (_tmp347_);
			_tmp348_ = g_variant_iter_next_value (&_tmp346_);
			_tmp345_.monitor_mode = g_variant_dup_string (_tmp348_, NULL);
			g_variant_unref (_tmp348_);
			_tmp349_ = g_variant_iter_next_value (&_tmp346_);
			_tmp350_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp351_, _tmp349_);
			while (g_variant_iter_loop (&_tmp351_, "{?*}", &_tmp352_, &_tmp353_)) {
				g_hash_table_insert (_tmp350_, g_variant_dup_string (_tmp352_, NULL), g_variant_get_variant (_tmp353_));
			}
			_tmp345_.properties = _tmp350_;
			g_variant_unref (_tmp349_);
			_tmp342_[_tmp342__length++] = _tmp345_;
			g_variant_unref (_tmp344_);
		}
		_tmp334_.monitors_length1 = _tmp342__length1;
		_tmp334_.monitors = _tmp342_;
		g_variant_unref (_tmp341_);
		_tmp331_[_tmp331__length++] = _tmp334_;
		g_variant_unref (_tmp333_);
	}
	logical_monitors_length1 = _tmp331__length1;
	logical_monitors = _tmp331_;
	g_variant_unref (_tmp330_);
	_tmp354_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp355_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp356_, _tmp354_);
	while (g_variant_iter_loop (&_tmp356_, "{?*}", &_tmp357_, &_tmp358_)) {
		g_hash_table_insert (_tmp355_, g_variant_dup_string (_tmp357_, NULL), g_variant_get_variant (_tmp358_));
	}
	properties = _tmp355_;
	g_variant_unref (_tmp354_);
	mutter_display_config_interface_apply_monitors_config (self, serial, method, logical_monitors, logical_monitors_length1, properties, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
	_g_hash_table_unref0 (properties);
}

static void
mutter_display_config_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* method_name,
                                                            GVariant* parameters,
                                                            GDBusMethodInvocation* invocation,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetResources") == 0) {
		_dbus_mutter_display_config_interface_get_resources (object, parameters, invocation);
	} else if (strcmp (method_name, "ApplyConfiguration") == 0) {
		_dbus_mutter_display_config_interface_apply_configuration (object, parameters, invocation);
	} else if (strcmp (method_name, "ChangeBacklight") == 0) {
		_dbus_mutter_display_config_interface_change_backlight (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCrtcGamma") == 0) {
		_dbus_mutter_display_config_interface_get_crtc_gamma (object, parameters, invocation);
	} else if (strcmp (method_name, "SetCrtcGamma") == 0) {
		_dbus_mutter_display_config_interface_set_crtc_gamma (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCurrentState") == 0) {
		_dbus_mutter_display_config_interface_get_current_state (object, parameters, invocation);
	} else if (strcmp (method_name, "ApplyMonitorsConfig") == 0) {
		_dbus_mutter_display_config_interface_apply_monitors_config (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	gint result;
	GVariant* _reply;
	result = mutter_display_config_interface_get_power_save_mode (self);
	_reply = g_variant_new_int32 (result);
	return _reply;
}

static GVariant*
mutter_display_config_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PowerSaveMode") == 0) {
		return _dbus_mutter_display_config_interface_get_power_save_mode (object);
	}
	return NULL;
}

static void
_dbus_mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                           GVariant* _value)
{
	gint value = 0;
	value = g_variant_get_int32 (_value);
	mutter_display_config_interface_set_power_save_mode (self, value);
}

static gboolean
mutter_display_config_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GVariant* value,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PowerSaveMode") == 0) {
		_dbus_mutter_display_config_interface_set_power_save_mode (object, value);
		return TRUE;
	}
	return FALSE;
}

static void
_dbus_mutter_display_config_interface_monitors_changed (GObject* _sender,
                                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Mutter.DisplayConfig", "MonitorsChanged", _arguments, NULL);
}

guint
mutter_display_config_interface_register_object (gpointer object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mutter_display_config_interface_dbus_interface_info), &_mutter_display_config_interface_dbus_interface_vtable, data, _mutter_display_config_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "monitors-changed", (GCallback) _dbus_mutter_display_config_interface_monitors_changed, data);
	return result;
}

static void
_mutter_display_config_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mutter_display_config_interface_monitors_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

GType
mutter_apply_method_get_type (void)
{
	static volatile gsize mutter_apply_method_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_apply_method_type_id__volatile)) {
		static const GEnumValue values[] = {{MUTTER_APPLY_METHOD_VERIFY, "MUTTER_APPLY_METHOD_VERIFY", "verify"}, {MUTTER_APPLY_METHOD_TEMPORARY, "MUTTER_APPLY_METHOD_TEMPORARY", "temporary"}, {MUTTER_APPLY_METHOD_PERSISTENT, "MUTTER_APPLY_METHOD_PERSISTENT", "persistent"}, {0, NULL, NULL}};
		GType mutter_apply_method_type_id;
		mutter_apply_method_type_id = g_enum_register_static ("MutterApplyMethod", values);
		g_once_init_leave (&mutter_apply_method_type_id__volatile, mutter_apply_method_type_id);
	}
	return mutter_apply_method_type_id__volatile;
}

gchar*
display_transform_to_string (DisplayTransform self)
{
	gchar* result = NULL;
	switch (self) {
		case DISPLAY_TRANSFORM_ROTATION_90:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Clockwise"));
			result = _tmp0_;
			return result;
		}
		case DISPLAY_TRANSFORM_ROTATION_180:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Upside-down"));
			result = _tmp1_;
			return result;
		}
		case DISPLAY_TRANSFORM_ROTATION_270:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Counterclockwise"));
			result = _tmp2_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Flipped"));
			result = _tmp3_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_90:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Flipped Clockwise"));
			result = _tmp4_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_180:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Flipped Upside-down"));
			result = _tmp5_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_270:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Flipped Counterclockwise"));
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("None"));
			result = _tmp7_;
			return result;
		}
	}
}

GType
display_transform_get_type (void)
{
	static volatile gsize display_transform_type_id__volatile = 0;
	if (g_once_init_enter (&display_transform_type_id__volatile)) {
		static const GEnumValue values[] = {{DISPLAY_TRANSFORM_NORMAL, "DISPLAY_TRANSFORM_NORMAL", "normal"}, {DISPLAY_TRANSFORM_ROTATION_90, "DISPLAY_TRANSFORM_ROTATION_90", "rotation-90"}, {DISPLAY_TRANSFORM_ROTATION_180, "DISPLAY_TRANSFORM_ROTATION_180", "rotation-180"}, {DISPLAY_TRANSFORM_ROTATION_270, "DISPLAY_TRANSFORM_ROTATION_270", "rotation-270"}, {DISPLAY_TRANSFORM_FLIPPED, "DISPLAY_TRANSFORM_FLIPPED", "flipped"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_90, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_90", "flipped-rotation-90"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_180, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_180", "flipped-rotation-180"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_270, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_270", "flipped-rotation-270"}, {0, NULL, NULL}};
		GType display_transform_type_id;
		display_transform_type_id = g_enum_register_static ("DisplayTransform", values);
		g_once_init_leave (&display_transform_type_id__volatile, display_transform_type_id);
	}
	return display_transform_type_id__volatile;
}

guint
mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self)
{
	guint result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	guint _tmp10_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = (*self).connector;
	_tmp1_ = (*self).vendor;
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = (*self).product;
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = (*self).serial;
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_str_hash (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	result = _tmp10_;
	return result;
}

void
mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                               MutterReadMonitorInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	_tmp0_ = (*self).connector;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).connector);
	(*dest).connector = _tmp1_;
	_tmp2_ = (*self).vendor;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).vendor);
	(*dest).vendor = _tmp3_;
	_tmp4_ = (*self).product;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).product);
	(*dest).product = _tmp5_;
	_tmp6_ = (*self).serial;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).serial);
	(*dest).serial = _tmp7_;
}

void
mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self)
{
	_g_free0 ((*self).connector);
	_g_free0 ((*self).vendor);
	_g_free0 ((*self).product);
	_g_free0 ((*self).serial);
}

MutterReadMonitorInfo*
mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self)
{
	MutterReadMonitorInfo* dup;
	dup = g_new0 (MutterReadMonitorInfo, 1);
	mutter_read_monitor_info_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_info_free (MutterReadMonitorInfo* self)
{
	mutter_read_monitor_info_destroy (self);
	g_free (self);
}

GType
mutter_read_monitor_info_get_type (void)
{
	static volatile gsize mutter_read_monitor_info_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_monitor_info_type_id__volatile)) {
		GType mutter_read_monitor_info_type_id;
		mutter_read_monitor_info_type_id = g_boxed_type_register_static ("MutterReadMonitorInfo", (GBoxedCopyFunc) mutter_read_monitor_info_dup, (GBoxedFreeFunc) mutter_read_monitor_info_free);
		g_once_init_leave (&mutter_read_monitor_info_type_id__volatile, mutter_read_monitor_info_type_id);
	}
	return mutter_read_monitor_info_type_id__volatile;
}

static gdouble*
_vala_array_dup1 (gdouble* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gdouble));
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

void
mutter_read_monitor_mode_copy (const MutterReadMonitorMode* self,
                               MutterReadMonitorMode* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	_tmp0_ = (*self).id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).id);
	(*dest).id = _tmp1_;
	(*dest).width = (*self).width;
	(*dest).height = (*self).height;
	(*dest).frequency = (*self).frequency;
	(*dest).preferred_scale = (*self).preferred_scale;
	_tmp2_ = (*self).supported_scales;
	_tmp2__length1 = (*self).supported_scales_length1;
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _tmp2__length1) : ((gpointer) _tmp2_);
	_tmp3__length1 = _tmp2__length1;
	(*dest).supported_scales = (g_free ((*dest).supported_scales), NULL);
	(*dest).supported_scales = _tmp3_;
	(*dest).supported_scales_length1 = _tmp3__length1;
	_tmp4_ = (*self).properties;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp5_;
}

void
mutter_read_monitor_mode_destroy (MutterReadMonitorMode* self)
{
	_g_free0 ((*self).id);
	(*self).supported_scales = (g_free ((*self).supported_scales), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadMonitorMode*
mutter_read_monitor_mode_dup (const MutterReadMonitorMode* self)
{
	MutterReadMonitorMode* dup;
	dup = g_new0 (MutterReadMonitorMode, 1);
	mutter_read_monitor_mode_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_mode_free (MutterReadMonitorMode* self)
{
	mutter_read_monitor_mode_destroy (self);
	g_free (self);
}

GType
mutter_read_monitor_mode_get_type (void)
{
	static volatile gsize mutter_read_monitor_mode_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_monitor_mode_type_id__volatile)) {
		GType mutter_read_monitor_mode_type_id;
		mutter_read_monitor_mode_type_id = g_boxed_type_register_static ("MutterReadMonitorMode", (GBoxedCopyFunc) mutter_read_monitor_mode_dup, (GBoxedFreeFunc) mutter_read_monitor_mode_free);
		g_once_init_leave (&mutter_read_monitor_mode_type_id__volatile, mutter_read_monitor_mode_type_id);
	}
	return mutter_read_monitor_mode_type_id__volatile;
}

static void
_vala_MutterReadMonitorMode_array_free (MutterReadMonitorMode * array,
                                        gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_mode_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterReadMonitorMode*
_vala_array_dup2 (MutterReadMonitorMode* self,
                  int length)
{
	MutterReadMonitorMode* result;
	int i;
	result = g_new0 (MutterReadMonitorMode, length);
	for (i = 0; i < length; i++) {
		MutterReadMonitorMode _tmp0_;
		MutterReadMonitorMode _tmp1_ = {0};
		_tmp0_ = self[i];
		mutter_read_monitor_mode_copy (&_tmp0_, &_tmp1_);
		result[i] = _tmp1_;
	}
	return result;
}

void
mutter_read_monitor_copy (const MutterReadMonitor* self,
                          MutterReadMonitor* dest)
{
	MutterReadMonitorInfo _tmp0_;
	MutterReadMonitorInfo _tmp1_;
	MutterReadMonitorInfo _tmp2_ = {0};
	MutterReadMonitorMode* _tmp3_;
	gint _tmp3__length1;
	MutterReadMonitorMode* _tmp4_;
	gint _tmp4__length1;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	_tmp0_ = (*self).monitor;
	_tmp1_ = _tmp0_;
	mutter_read_monitor_info_copy (&_tmp1_, &_tmp2_);
	mutter_read_monitor_info_destroy (&(*dest).monitor);
	(*dest).monitor = _tmp2_;
	_tmp3_ = (*self).modes;
	_tmp3__length1 = (*self).modes_length1;
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup2 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
	_tmp4__length1 = _tmp3__length1;
	(*dest).modes = (_vala_MutterReadMonitorMode_array_free ((*dest).modes, (*dest).modes_length1), NULL);
	(*dest).modes = _tmp4_;
	(*dest).modes_length1 = _tmp4__length1;
	_tmp5_ = (*self).properties;
	_tmp6_ = _g_hash_table_ref0 (_tmp5_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp6_;
}

void
mutter_read_monitor_destroy (MutterReadMonitor* self)
{
	mutter_read_monitor_info_destroy (&(*self).monitor);
	(*self).modes = (_vala_MutterReadMonitorMode_array_free ((*self).modes, (*self).modes_length1), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadMonitor*
mutter_read_monitor_dup (const MutterReadMonitor* self)
{
	MutterReadMonitor* dup;
	dup = g_new0 (MutterReadMonitor, 1);
	mutter_read_monitor_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_free (MutterReadMonitor* self)
{
	mutter_read_monitor_destroy (self);
	g_free (self);
}

GType
mutter_read_monitor_get_type (void)
{
	static volatile gsize mutter_read_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_monitor_type_id__volatile)) {
		GType mutter_read_monitor_type_id;
		mutter_read_monitor_type_id = g_boxed_type_register_static ("MutterReadMonitor", (GBoxedCopyFunc) mutter_read_monitor_dup, (GBoxedFreeFunc) mutter_read_monitor_free);
		g_once_init_leave (&mutter_read_monitor_type_id__volatile, mutter_read_monitor_type_id);
	}
	return mutter_read_monitor_type_id__volatile;
}

static void
_vala_MutterReadMonitorInfo_array_free (MutterReadMonitorInfo * array,
                                        gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterReadMonitorInfo*
_vala_array_dup3 (MutterReadMonitorInfo* self,
                  int length)
{
	MutterReadMonitorInfo* result;
	int i;
	result = g_new0 (MutterReadMonitorInfo, length);
	for (i = 0; i < length; i++) {
		MutterReadMonitorInfo _tmp0_;
		MutterReadMonitorInfo _tmp1_ = {0};
		_tmp0_ = self[i];
		mutter_read_monitor_info_copy (&_tmp0_, &_tmp1_);
		result[i] = _tmp1_;
	}
	return result;
}

void
mutter_read_logical_monitor_copy (const MutterReadLogicalMonitor* self,
                                  MutterReadLogicalMonitor* dest)
{
	DisplayTransform _tmp0_;
	MutterReadMonitorInfo* _tmp1_;
	gint _tmp1__length1;
	MutterReadMonitorInfo* _tmp2_;
	gint _tmp2__length1;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).scale = (*self).scale;
	_tmp0_ = (*self).transform;
	(*dest).transform = _tmp0_;
	(*dest).primary = (*self).primary;
	_tmp1_ = (*self).monitors;
	_tmp1__length1 = (*self).monitors_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	(*dest).monitors = (_vala_MutterReadMonitorInfo_array_free ((*dest).monitors, (*dest).monitors_length1), NULL);
	(*dest).monitors = _tmp2_;
	(*dest).monitors_length1 = _tmp2__length1;
	_tmp3_ = (*self).properties;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp4_;
}

void
mutter_read_logical_monitor_destroy (MutterReadLogicalMonitor* self)
{
	(*self).monitors = (_vala_MutterReadMonitorInfo_array_free ((*self).monitors, (*self).monitors_length1), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadLogicalMonitor*
mutter_read_logical_monitor_dup (const MutterReadLogicalMonitor* self)
{
	MutterReadLogicalMonitor* dup;
	dup = g_new0 (MutterReadLogicalMonitor, 1);
	mutter_read_logical_monitor_copy (self, dup);
	return dup;
}

void
mutter_read_logical_monitor_free (MutterReadLogicalMonitor* self)
{
	mutter_read_logical_monitor_destroy (self);
	g_free (self);
}

GType
mutter_read_logical_monitor_get_type (void)
{
	static volatile gsize mutter_read_logical_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_logical_monitor_type_id__volatile)) {
		GType mutter_read_logical_monitor_type_id;
		mutter_read_logical_monitor_type_id = g_boxed_type_register_static ("MutterReadLogicalMonitor", (GBoxedCopyFunc) mutter_read_logical_monitor_dup, (GBoxedFreeFunc) mutter_read_logical_monitor_free);
		g_once_init_leave (&mutter_read_logical_monitor_type_id__volatile, mutter_read_logical_monitor_type_id);
	}
	return mutter_read_logical_monitor_type_id__volatile;
}

void
mutter_write_monitor_copy (const MutterWriteMonitor* self,
                           MutterWriteMonitor* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	_tmp0_ = (*self).connector;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).connector);
	(*dest).connector = _tmp1_;
	_tmp2_ = (*self).monitor_mode;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).monitor_mode);
	(*dest).monitor_mode = _tmp3_;
	_tmp4_ = (*self).properties;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp5_;
}

void
mutter_write_monitor_destroy (MutterWriteMonitor* self)
{
	_g_free0 ((*self).connector);
	_g_free0 ((*self).monitor_mode);
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteMonitor*
mutter_write_monitor_dup (const MutterWriteMonitor* self)
{
	MutterWriteMonitor* dup;
	dup = g_new0 (MutterWriteMonitor, 1);
	mutter_write_monitor_copy (self, dup);
	return dup;
}

void
mutter_write_monitor_free (MutterWriteMonitor* self)
{
	mutter_write_monitor_destroy (self);
	g_free (self);
}

GType
mutter_write_monitor_get_type (void)
{
	static volatile gsize mutter_write_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_write_monitor_type_id__volatile)) {
		GType mutter_write_monitor_type_id;
		mutter_write_monitor_type_id = g_boxed_type_register_static ("MutterWriteMonitor", (GBoxedCopyFunc) mutter_write_monitor_dup, (GBoxedFreeFunc) mutter_write_monitor_free);
		g_once_init_leave (&mutter_write_monitor_type_id__volatile, mutter_write_monitor_type_id);
	}
	return mutter_write_monitor_type_id__volatile;
}

static void
_vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                     gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterWriteMonitor*
_vala_array_dup4 (MutterWriteMonitor* self,
                  int length)
{
	MutterWriteMonitor* result;
	int i;
	result = g_new0 (MutterWriteMonitor, length);
	for (i = 0; i < length; i++) {
		MutterWriteMonitor _tmp0_;
		MutterWriteMonitor _tmp1_ = {0};
		_tmp0_ = self[i];
		mutter_write_monitor_copy (&_tmp0_, &_tmp1_);
		result[i] = _tmp1_;
	}
	return result;
}

void
mutter_write_logical_monitor_copy (const MutterWriteLogicalMonitor* self,
                                   MutterWriteLogicalMonitor* dest)
{
	DisplayTransform _tmp0_;
	MutterWriteMonitor* _tmp1_;
	gint _tmp1__length1;
	MutterWriteMonitor* _tmp2_;
	gint _tmp2__length1;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).scale = (*self).scale;
	_tmp0_ = (*self).transform;
	(*dest).transform = _tmp0_;
	(*dest).primary = (*self).primary;
	_tmp1_ = (*self).monitors;
	_tmp1__length1 = (*self).monitors_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup4 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	(*dest).monitors = (_vala_MutterWriteMonitor_array_free ((*dest).monitors, (*dest).monitors_length1), NULL);
	(*dest).monitors = _tmp2_;
	(*dest).monitors_length1 = _tmp2__length1;
}

void
mutter_write_logical_monitor_destroy (MutterWriteLogicalMonitor* self)
{
	(*self).monitors = (_vala_MutterWriteMonitor_array_free ((*self).monitors, (*self).monitors_length1), NULL);
}

MutterWriteLogicalMonitor*
mutter_write_logical_monitor_dup (const MutterWriteLogicalMonitor* self)
{
	MutterWriteLogicalMonitor* dup;
	dup = g_new0 (MutterWriteLogicalMonitor, 1);
	mutter_write_logical_monitor_copy (self, dup);
	return dup;
}

void
mutter_write_logical_monitor_free (MutterWriteLogicalMonitor* self)
{
	mutter_write_logical_monitor_destroy (self);
	g_free (self);
}

GType
mutter_write_logical_monitor_get_type (void)
{
	static volatile gsize mutter_write_logical_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_write_logical_monitor_type_id__volatile)) {
		GType mutter_write_logical_monitor_type_id;
		mutter_write_logical_monitor_type_id = g_boxed_type_register_static ("MutterWriteLogicalMonitor", (GBoxedCopyFunc) mutter_write_logical_monitor_dup, (GBoxedFreeFunc) mutter_write_logical_monitor_free);
		g_once_init_leave (&mutter_write_logical_monitor_type_id__volatile, mutter_write_logical_monitor_type_id);
	}
	return mutter_write_logical_monitor_type_id__volatile;
}

static DisplayTransform*
_vala_array_dup5 (DisplayTransform* self,
                  int length)
{
	return g_memdup (self, length * sizeof (DisplayTransform));
}

void
mutter_read_display_crtc_copy (const MutterReadDisplayCrtc* self,
                               MutterReadDisplayCrtc* dest)
{
	DisplayTransform _tmp0_;
	DisplayTransform* _tmp1_;
	gint _tmp1__length1;
	DisplayTransform* _tmp2_;
	gint _tmp2__length1;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	(*dest).id = (*self).id;
	(*dest).winsys_id = (*self).winsys_id;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).width = (*self).width;
	(*dest).height = (*self).height;
	(*dest).current_mode = (*self).current_mode;
	_tmp0_ = (*self).current_transform;
	(*dest).current_transform = _tmp0_;
	_tmp1_ = (*self).transforms;
	_tmp1__length1 = (*self).transforms_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup5 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	(*dest).transforms = (g_free ((*dest).transforms), NULL);
	(*dest).transforms = _tmp2_;
	(*dest).transforms_length1 = _tmp2__length1;
	_tmp3_ = (*self).properties;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp4_;
}

void
mutter_read_display_crtc_destroy (MutterReadDisplayCrtc* self)
{
	(*self).transforms = (g_free ((*self).transforms), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadDisplayCrtc*
mutter_read_display_crtc_dup (const MutterReadDisplayCrtc* self)
{
	MutterReadDisplayCrtc* dup;
	dup = g_new0 (MutterReadDisplayCrtc, 1);
	mutter_read_display_crtc_copy (self, dup);
	return dup;
}

void
mutter_read_display_crtc_free (MutterReadDisplayCrtc* self)
{
	mutter_read_display_crtc_destroy (self);
	g_free (self);
}

GType
mutter_read_display_crtc_get_type (void)
{
	static volatile gsize mutter_read_display_crtc_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_display_crtc_type_id__volatile)) {
		GType mutter_read_display_crtc_type_id;
		mutter_read_display_crtc_type_id = g_boxed_type_register_static ("MutterReadDisplayCrtc", (GBoxedCopyFunc) mutter_read_display_crtc_dup, (GBoxedFreeFunc) mutter_read_display_crtc_free);
		g_once_init_leave (&mutter_read_display_crtc_type_id__volatile, mutter_read_display_crtc_type_id);
	}
	return mutter_read_display_crtc_type_id__volatile;
}

static guint*
_vala_array_dup6 (guint* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint));
}

void
mutter_write_display_crtc_copy (const MutterWriteDisplayCrtc* self,
                                MutterWriteDisplayCrtc* dest)
{
	DisplayTransform _tmp0_;
	guint* _tmp1_;
	gint _tmp1__length1;
	guint* _tmp2_;
	gint _tmp2__length1;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	(*dest).id = (*self).id;
	(*dest).new_mode = (*self).new_mode;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	_tmp0_ = (*self).transform;
	(*dest).transform = _tmp0_;
	_tmp1_ = (*self).outputs;
	_tmp1__length1 = (*self).outputs_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup6 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	(*dest).outputs = (g_free ((*dest).outputs), NULL);
	(*dest).outputs = _tmp2_;
	(*dest).outputs_length1 = _tmp2__length1;
	_tmp3_ = (*self).properties;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp4_;
}

void
mutter_write_display_crtc_destroy (MutterWriteDisplayCrtc* self)
{
	(*self).outputs = (g_free ((*self).outputs), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteDisplayCrtc*
mutter_write_display_crtc_dup (const MutterWriteDisplayCrtc* self)
{
	MutterWriteDisplayCrtc* dup;
	dup = g_new0 (MutterWriteDisplayCrtc, 1);
	mutter_write_display_crtc_copy (self, dup);
	return dup;
}

void
mutter_write_display_crtc_free (MutterWriteDisplayCrtc* self)
{
	mutter_write_display_crtc_destroy (self);
	g_free (self);
}

GType
mutter_write_display_crtc_get_type (void)
{
	static volatile gsize mutter_write_display_crtc_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_write_display_crtc_type_id__volatile)) {
		GType mutter_write_display_crtc_type_id;
		mutter_write_display_crtc_type_id = g_boxed_type_register_static ("MutterWriteDisplayCrtc", (GBoxedCopyFunc) mutter_write_display_crtc_dup, (GBoxedFreeFunc) mutter_write_display_crtc_free);
		g_once_init_leave (&mutter_write_display_crtc_type_id__volatile, mutter_write_display_crtc_type_id);
	}
	return mutter_write_display_crtc_type_id__volatile;
}

static guint*
_vala_array_dup7 (guint* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint));
}

static guint*
_vala_array_dup8 (guint* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint));
}

static guint*
_vala_array_dup9 (guint* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint));
}

void
mutter_read_display_output_copy (const MutterReadDisplayOutput* self,
                                 MutterReadDisplayOutput* dest)
{
	guint* _tmp0_;
	gint _tmp0__length1;
	guint* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	guint* _tmp4_;
	gint _tmp4__length1;
	guint* _tmp5_;
	gint _tmp5__length1;
	guint* _tmp6_;
	gint _tmp6__length1;
	guint* _tmp7_;
	gint _tmp7__length1;
	GHashTable* _tmp8_;
	GHashTable* _tmp9_;
	(*dest).id = (*self).id;
	(*dest).winsys_id = (*self).winsys_id;
	(*dest).current_crtc = (*self).current_crtc;
	_tmp0_ = (*self).possible_crtcs;
	_tmp0__length1 = (*self).possible_crtcs_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup7 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	(*dest).possible_crtcs = (g_free ((*dest).possible_crtcs), NULL);
	(*dest).possible_crtcs = _tmp1_;
	(*dest).possible_crtcs_length1 = _tmp1__length1;
	_tmp2_ = (*self).connector_name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).connector_name);
	(*dest).connector_name = _tmp3_;
	_tmp4_ = (*self).modes;
	_tmp4__length1 = (*self).modes_length1;
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup8 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
	_tmp5__length1 = _tmp4__length1;
	(*dest).modes = (g_free ((*dest).modes), NULL);
	(*dest).modes = _tmp5_;
	(*dest).modes_length1 = _tmp5__length1;
	_tmp6_ = (*self).clones;
	_tmp6__length1 = (*self).clones_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup9 (_tmp6_, _tmp6__length1) : ((gpointer) _tmp6_);
	_tmp7__length1 = _tmp6__length1;
	(*dest).clones = (g_free ((*dest).clones), NULL);
	(*dest).clones = _tmp7_;
	(*dest).clones_length1 = _tmp7__length1;
	_tmp8_ = (*self).properties;
	_tmp9_ = _g_hash_table_ref0 (_tmp8_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp9_;
}

void
mutter_read_display_output_destroy (MutterReadDisplayOutput* self)
{
	(*self).possible_crtcs = (g_free ((*self).possible_crtcs), NULL);
	_g_free0 ((*self).connector_name);
	(*self).modes = (g_free ((*self).modes), NULL);
	(*self).clones = (g_free ((*self).clones), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadDisplayOutput*
mutter_read_display_output_dup (const MutterReadDisplayOutput* self)
{
	MutterReadDisplayOutput* dup;
	dup = g_new0 (MutterReadDisplayOutput, 1);
	mutter_read_display_output_copy (self, dup);
	return dup;
}

void
mutter_read_display_output_free (MutterReadDisplayOutput* self)
{
	mutter_read_display_output_destroy (self);
	g_free (self);
}

GType
mutter_read_display_output_get_type (void)
{
	static volatile gsize mutter_read_display_output_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_display_output_type_id__volatile)) {
		GType mutter_read_display_output_type_id;
		mutter_read_display_output_type_id = g_boxed_type_register_static ("MutterReadDisplayOutput", (GBoxedCopyFunc) mutter_read_display_output_dup, (GBoxedFreeFunc) mutter_read_display_output_free);
		g_once_init_leave (&mutter_read_display_output_type_id__volatile, mutter_read_display_output_type_id);
	}
	return mutter_read_display_output_type_id__volatile;
}

void
mutter_write_display_output_copy (const MutterWriteDisplayOutput* self,
                                  MutterWriteDisplayOutput* dest)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	(*dest).id = (*self).id;
	_tmp0_ = (*self).properties;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp1_;
}

void
mutter_write_display_output_destroy (MutterWriteDisplayOutput* self)
{
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteDisplayOutput*
mutter_write_display_output_dup (const MutterWriteDisplayOutput* self)
{
	MutterWriteDisplayOutput* dup;
	dup = g_new0 (MutterWriteDisplayOutput, 1);
	mutter_write_display_output_copy (self, dup);
	return dup;
}

void
mutter_write_display_output_free (MutterWriteDisplayOutput* self)
{
	mutter_write_display_output_destroy (self);
	g_free (self);
}

GType
mutter_write_display_output_get_type (void)
{
	static volatile gsize mutter_write_display_output_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_write_display_output_type_id__volatile)) {
		GType mutter_write_display_output_type_id;
		mutter_write_display_output_type_id = g_boxed_type_register_static ("MutterWriteDisplayOutput", (GBoxedCopyFunc) mutter_write_display_output_dup, (GBoxedFreeFunc) mutter_write_display_output_free);
		g_once_init_leave (&mutter_write_display_output_type_id__volatile, mutter_write_display_output_type_id);
	}
	return mutter_write_display_output_type_id__volatile;
}

MutterReadDisplayMode*
mutter_read_display_mode_dup (const MutterReadDisplayMode* self)
{
	MutterReadDisplayMode* dup;
	dup = g_new0 (MutterReadDisplayMode, 1);
	memcpy (dup, self, sizeof (MutterReadDisplayMode));
	return dup;
}

void
mutter_read_display_mode_free (MutterReadDisplayMode* self)
{
	g_free (self);
}

GType
mutter_read_display_mode_get_type (void)
{
	static volatile gsize mutter_read_display_mode_type_id__volatile = 0;
	if (g_once_init_enter (&mutter_read_display_mode_type_id__volatile)) {
		GType mutter_read_display_mode_type_id;
		mutter_read_display_mode_type_id = g_boxed_type_register_static ("MutterReadDisplayMode", (GBoxedCopyFunc) mutter_read_display_mode_dup, (GBoxedFreeFunc) mutter_read_display_mode_free);
		g_once_init_leave (&mutter_read_display_mode_type_id__volatile, mutter_read_display_mode_type_id);
	}
	return mutter_read_display_mode_type_id__volatile;
}

