/* MonitorManager.c generated by valac 0.46.10, the Vala compiler
 * generated from MonitorManager.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define DISPLAY_TYPE_MONITOR_MANAGER (display_monitor_manager_get_type ())
#define DISPLAY_MONITOR_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager))
#define DISPLAY_MONITOR_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManagerClass))
#define DISPLAY_IS_MONITOR_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MANAGER))
#define DISPLAY_IS_MONITOR_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MANAGER))
#define DISPLAY_MONITOR_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManagerClass))

typedef struct _DisplayMonitorManager DisplayMonitorManager;
typedef struct _DisplayMonitorManagerClass DisplayMonitorManagerClass;
typedef struct _DisplayMonitorManagerPrivate DisplayMonitorManagerPrivate;

#define DISPLAY_TYPE_VIRTUAL_MONITOR (display_virtual_monitor_get_type ())
#define DISPLAY_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor))
#define DISPLAY_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))
#define DISPLAY_IS_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_IS_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_VIRTUAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))

typedef struct _DisplayVirtualMonitor DisplayVirtualMonitor;
typedef struct _DisplayVirtualMonitorClass DisplayVirtualMonitorClass;

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE (mutter_display_config_interface_get_type ())
#define MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterface))
#define IS_MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE))
#define MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterfaceIface))

typedef struct _MutterDisplayConfigInterface MutterDisplayConfigInterface;
typedef struct _MutterDisplayConfigInterfaceIface MutterDisplayConfigInterfaceIface;

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE_PROXY (mutter_display_config_interface_proxy_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_CRTC (mutter_read_display_crtc_get_type ())
typedef struct _MutterReadDisplayCrtc MutterReadDisplayCrtc;
typedef enum  {
	DISPLAY_TRANSFORM_NORMAL = 0,
	DISPLAY_TRANSFORM_ROTATION_90 = 1,
	DISPLAY_TRANSFORM_ROTATION_180 = 2,
	DISPLAY_TRANSFORM_ROTATION_270 = 3,
	DISPLAY_TRANSFORM_FLIPPED = 4,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_90 = 5,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_180 = 6,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_270 = 7
} DisplayTransform;

#define TYPE_DISPLAY_TRANSFORM (display_transform_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_OUTPUT (mutter_read_display_output_get_type ())
typedef struct _MutterReadDisplayOutput MutterReadDisplayOutput;

#define TYPE_MUTTER_READ_DISPLAY_MODE (mutter_read_display_mode_get_type ())
typedef struct _MutterReadDisplayMode MutterReadDisplayMode;

#define TYPE_MUTTER_WRITE_DISPLAY_CRTC (mutter_write_display_crtc_get_type ())
typedef struct _MutterWriteDisplayCrtc MutterWriteDisplayCrtc;

#define TYPE_MUTTER_WRITE_DISPLAY_OUTPUT (mutter_write_display_output_get_type ())
typedef struct _MutterWriteDisplayOutput MutterWriteDisplayOutput;

#define TYPE_MUTTER_READ_MONITOR (mutter_read_monitor_get_type ())
typedef struct _MutterReadMonitor MutterReadMonitor;

#define TYPE_MUTTER_READ_MONITOR_INFO (mutter_read_monitor_info_get_type ())
typedef struct _MutterReadMonitorInfo MutterReadMonitorInfo;

#define TYPE_MUTTER_READ_MONITOR_MODE (mutter_read_monitor_mode_get_type ())
typedef struct _MutterReadMonitorMode MutterReadMonitorMode;

#define TYPE_MUTTER_READ_LOGICAL_MONITOR (mutter_read_logical_monitor_get_type ())
typedef struct _MutterReadLogicalMonitor MutterReadLogicalMonitor;
typedef enum  {
	MUTTER_APPLY_METHOD_VERIFY = 0,
	MUTTER_APPLY_METHOD_TEMPORARY = 1,
	MUTTER_APPLY_METHOD_PERSISTENT = 2
} MutterApplyMethod;

#define TYPE_MUTTER_APPLY_METHOD (mutter_apply_method_get_type ())

#define TYPE_MUTTER_WRITE_LOGICAL_MONITOR (mutter_write_logical_monitor_get_type ())
typedef struct _MutterWriteLogicalMonitor MutterWriteLogicalMonitor;

#define TYPE_MUTTER_WRITE_MONITOR (mutter_write_monitor_get_type ())
typedef struct _MutterWriteMonitor MutterWriteMonitor;
enum  {
	DISPLAY_MONITOR_MANAGER_0_PROPERTY,
	DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY,
	DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY,
	DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY,
	DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_NUM_PROPERTIES
};
static GParamSpec* display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DisplayMonitorManager {
	GObject parent_instance;
	DisplayMonitorManagerPrivate * priv;
};

struct _DisplayMonitorManagerClass {
	GObjectClass parent_class;
};

struct _MutterReadDisplayCrtc {
	guint id;
	gint64 winsys_id;
	gint x;
	gint y;
	gint width;
	gint height;
	gint current_mode;
	DisplayTransform current_transform;
	DisplayTransform* transforms;
	gint transforms_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayOutput {
	guint id;
	gint64 winsys_id;
	gint current_crtc;
	guint* possible_crtcs;
	gint possible_crtcs_length1;
	gchar* connector_name;
	guint* modes;
	gint modes_length1;
	guint* clones;
	gint clones_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayMode {
	guint id;
	gint64 winsys_id;
	guint width;
	guint height;
	gdouble frequency;
	guint flags;
};

struct _MutterWriteDisplayCrtc {
	guint id;
	gint new_mode;
	gint x;
	gint y;
	DisplayTransform transform;
	guint* outputs;
	gint outputs_length1;
	GHashTable* properties;
};

struct _MutterWriteDisplayOutput {
	guint id;
	GHashTable* properties;
};

struct _MutterReadMonitorInfo {
	gchar* connector;
	gchar* vendor;
	gchar* product;
	gchar* serial;
};

struct _MutterReadMonitorMode {
	gchar* id;
	gint width;
	gint height;
	gdouble frequency;
	gdouble preferred_scale;
	gdouble* supported_scales;
	gint supported_scales_length1;
	GHashTable* properties;
};

struct _MutterReadMonitor {
	MutterReadMonitorInfo monitor;
	MutterReadMonitorMode* modes;
	gint modes_length1;
	GHashTable* properties;
};

struct _MutterReadLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterReadMonitorInfo* monitors;
	gint monitors_length1;
	GHashTable* properties;
};

struct _MutterWriteMonitor {
	gchar* connector;
	gchar* monitor_mode;
	GHashTable* properties;
};

struct _MutterWriteLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterWriteMonitor* monitors;
	gint monitors_length1;
};

struct _MutterDisplayConfigInterfaceIface {
	GTypeInterface parent_iface;
	void (*get_resources) (MutterDisplayConfigInterface* self, guint* serial, MutterReadDisplayCrtc** crtcs, gint* crtcs_length1, MutterReadDisplayOutput** outputs, gint* outputs_length1, MutterReadDisplayMode** modes, gint* modes_length1, gint* max_screen_width, gint* max_screen_height, GError** error);
	void (*apply_configuration) (MutterDisplayConfigInterface* self, guint serial, gboolean persistent, MutterWriteDisplayCrtc* crtcs, gint crtcs_length1, MutterWriteDisplayOutput* outputs, gint outputs_length1, GError** error);
	gint (*change_backlight) (MutterDisplayConfigInterface* self, guint serial, guint output, gint value, GError** error);
	void (*get_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint** red, gint* red_length1, guint** green, gint* green_length1, guint** blue, gint* blue_length1, GError** error);
	void (*set_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint* red, gint red_length1, guint* green, gint green_length1, guint* blue, gint blue_length1, GError** error);
	void (*get_current_state) (MutterDisplayConfigInterface* self, guint* serial, MutterReadMonitor** monitors, gint* monitors_length1, MutterReadLogicalMonitor** logical_monitors, gint* logical_monitors_length1, GHashTable* * properties, GError** error);
	void (*apply_monitors_config) (MutterDisplayConfigInterface* self, guint serial, MutterApplyMethod method, MutterWriteLogicalMonitor* logical_monitors, gint logical_monitors_length1, GHashTable* properties, GError** error);
	gint (*get_power_save_mode) (MutterDisplayConfigInterface* self);
	void (*set_power_save_mode) (MutterDisplayConfigInterface* self, gint value);
};

struct _DisplayMonitorManagerPrivate {
	GeeLinkedList* _virtual_monitors;
	GeeLinkedList* _monitors;
	gboolean _global_scale_required;
	gboolean _mirroring_supported;
	gint _max_width;
	gint _max_height;
	MutterDisplayConfigInterface* iface;
	guint current_serial;
};

static gint DisplayMonitorManager_private_offset;
static gpointer display_monitor_manager_parent_class = NULL;
static DisplayMonitorManager* display_monitor_manager_monitor_manager;
static DisplayMonitorManager* display_monitor_manager_monitor_manager = NULL;

GType display_monitor_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitorManager, g_object_unref)
GType display_virtual_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayVirtualMonitor, g_object_unref)
GType display_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitor, g_object_unref)
GType mutter_display_config_interface_proxy_get_type (void) G_GNUC_CONST;
guint mutter_display_config_interface_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
GType mutter_read_display_crtc_get_type (void) G_GNUC_CONST;
GType display_transform_get_type (void) G_GNUC_CONST;
MutterReadDisplayCrtc* mutter_read_display_crtc_dup (const MutterReadDisplayCrtc* self);
void mutter_read_display_crtc_free (MutterReadDisplayCrtc* self);
void mutter_read_display_crtc_copy (const MutterReadDisplayCrtc* self,
                                    MutterReadDisplayCrtc* dest);
void mutter_read_display_crtc_destroy (MutterReadDisplayCrtc* self);
GType mutter_read_display_output_get_type (void) G_GNUC_CONST;
MutterReadDisplayOutput* mutter_read_display_output_dup (const MutterReadDisplayOutput* self);
void mutter_read_display_output_free (MutterReadDisplayOutput* self);
void mutter_read_display_output_copy (const MutterReadDisplayOutput* self,
                                      MutterReadDisplayOutput* dest);
void mutter_read_display_output_destroy (MutterReadDisplayOutput* self);
GType mutter_read_display_mode_get_type (void) G_GNUC_CONST;
MutterReadDisplayMode* mutter_read_display_mode_dup (const MutterReadDisplayMode* self);
void mutter_read_display_mode_free (MutterReadDisplayMode* self);
GType mutter_write_display_crtc_get_type (void) G_GNUC_CONST;
MutterWriteDisplayCrtc* mutter_write_display_crtc_dup (const MutterWriteDisplayCrtc* self);
void mutter_write_display_crtc_free (MutterWriteDisplayCrtc* self);
void mutter_write_display_crtc_copy (const MutterWriteDisplayCrtc* self,
                                     MutterWriteDisplayCrtc* dest);
void mutter_write_display_crtc_destroy (MutterWriteDisplayCrtc* self);
GType mutter_write_display_output_get_type (void) G_GNUC_CONST;
MutterWriteDisplayOutput* mutter_write_display_output_dup (const MutterWriteDisplayOutput* self);
void mutter_write_display_output_free (MutterWriteDisplayOutput* self);
void mutter_write_display_output_copy (const MutterWriteDisplayOutput* self,
                                       MutterWriteDisplayOutput* dest);
void mutter_write_display_output_destroy (MutterWriteDisplayOutput* self);
GType mutter_read_monitor_get_type (void) G_GNUC_CONST;
GType mutter_read_monitor_info_get_type (void) G_GNUC_CONST;
MutterReadMonitorInfo* mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self);
void mutter_read_monitor_info_free (MutterReadMonitorInfo* self);
void mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                                    MutterReadMonitorInfo* dest);
void mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self);
GType mutter_read_monitor_mode_get_type (void) G_GNUC_CONST;
MutterReadMonitorMode* mutter_read_monitor_mode_dup (const MutterReadMonitorMode* self);
void mutter_read_monitor_mode_free (MutterReadMonitorMode* self);
void mutter_read_monitor_mode_copy (const MutterReadMonitorMode* self,
                                    MutterReadMonitorMode* dest);
void mutter_read_monitor_mode_destroy (MutterReadMonitorMode* self);
MutterReadMonitor* mutter_read_monitor_dup (const MutterReadMonitor* self);
void mutter_read_monitor_free (MutterReadMonitor* self);
void mutter_read_monitor_copy (const MutterReadMonitor* self,
                               MutterReadMonitor* dest);
void mutter_read_monitor_destroy (MutterReadMonitor* self);
GType mutter_read_logical_monitor_get_type (void) G_GNUC_CONST;
MutterReadLogicalMonitor* mutter_read_logical_monitor_dup (const MutterReadLogicalMonitor* self);
void mutter_read_logical_monitor_free (MutterReadLogicalMonitor* self);
void mutter_read_logical_monitor_copy (const MutterReadLogicalMonitor* self,
                                       MutterReadLogicalMonitor* dest);
void mutter_read_logical_monitor_destroy (MutterReadLogicalMonitor* self);
GType mutter_apply_method_get_type (void) G_GNUC_CONST;
GType mutter_write_logical_monitor_get_type (void) G_GNUC_CONST;
GType mutter_write_monitor_get_type (void) G_GNUC_CONST;
MutterWriteMonitor* mutter_write_monitor_dup (const MutterWriteMonitor* self);
void mutter_write_monitor_free (MutterWriteMonitor* self);
void mutter_write_monitor_copy (const MutterWriteMonitor* self,
                                MutterWriteMonitor* dest);
void mutter_write_monitor_destroy (MutterWriteMonitor* self);
MutterWriteLogicalMonitor* mutter_write_logical_monitor_dup (const MutterWriteLogicalMonitor* self);
void mutter_write_logical_monitor_free (MutterWriteLogicalMonitor* self);
void mutter_write_logical_monitor_copy (const MutterWriteLogicalMonitor* self,
                                        MutterWriteLogicalMonitor* dest);
void mutter_write_logical_monitor_destroy (MutterWriteLogicalMonitor* self);
GType mutter_display_config_interface_get_type (void) G_GNUC_CONST;
DisplayMonitorManager* display_monitor_manager_get_default (void);
static DisplayMonitorManager* display_monitor_manager_new (void);
static DisplayMonitorManager* display_monitor_manager_construct (GType object_type);
void display_monitor_manager_get_monitor_config (DisplayMonitorManager* self);
void mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                        guint* serial,
                                                        MutterReadMonitor** monitors,
                                                        gint* monitors_length1,
                                                        MutterReadLogicalMonitor** logical_monitors,
                                                        gint* logical_monitors_length1,
                                                        GHashTable* * properties,
                                                        GError** error);
static void _vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                         gint array_length);
static void _vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                                gint array_length);
static void display_monitor_manager_set_mirroring_supported (DisplayMonitorManager* self,
                                                      gboolean value);
static void display_monitor_manager_set_global_scale_required (DisplayMonitorManager* self,
                                                        gboolean value);
static void display_monitor_manager_set_max_width (DisplayMonitorManager* self,
                                            gint value);
static void display_monitor_manager_set_max_height (DisplayMonitorManager* self,
                                             gint value);
static DisplayMonitor* display_monitor_manager_get_monitor_by_hash (DisplayMonitorManager* self,
                                                             guint hash);
guint mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self);
DisplayMonitor* display_monitor_new (void);
DisplayMonitor* display_monitor_construct (GType object_type);
GeeLinkedList* display_monitor_manager_get_monitors (DisplayMonitorManager* self);
void display_monitor_set_connector (DisplayMonitor* self,
                                    const gchar* value);
void display_monitor_set_vendor (DisplayMonitor* self,
                                 const gchar* value);
void display_monitor_set_product (DisplayMonitor* self,
                                  const gchar* value);
void display_monitor_set_serial (DisplayMonitor* self,
                                 const gchar* value);
void display_monitor_set_display_name (DisplayMonitor* self,
                                       const gchar* value);
const gchar* display_monitor_get_connector (DisplayMonitor* self);
void display_monitor_set_is_builtin (DisplayMonitor* self,
                                     gboolean value);
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitorMode, g_object_unref)
DisplayMonitorMode* display_monitor_get_mode_by_id (DisplayMonitor* self,
                                                    const gchar* id);
DisplayMonitorMode* display_monitor_mode_new (void);
DisplayMonitorMode* display_monitor_mode_construct (GType object_type);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
void display_monitor_mode_set_id (DisplayMonitorMode* self,
                                  const gchar* value);
void display_monitor_mode_set_width (DisplayMonitorMode* self,
                                     gint value);
void display_monitor_mode_set_height (DisplayMonitorMode* self,
                                      gint value);
void display_monitor_mode_set_frequency (DisplayMonitorMode* self,
                                         gdouble value);
void display_monitor_mode_set_preferred_scale (DisplayMonitorMode* self,
                                               gdouble value);
void display_monitor_mode_set_supported_scales (DisplayMonitorMode* self,
                                                gdouble* value,
                                                gint value_length1);
void display_monitor_mode_set_is_preferred (DisplayMonitorMode* self,
                                            gboolean value);
void display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                          gboolean value);
gchar* display_virtual_monitor_generate_id_from_monitors (MutterReadMonitorInfo* infos,
                                                          gint infos_length1);
static DisplayVirtualMonitor* display_monitor_manager_get_virtual_monitor_by_id (DisplayMonitorManager* self,
                                                                          const gchar* id);
DisplayVirtualMonitor* display_virtual_monitor_new (void);
DisplayVirtualMonitor* display_virtual_monitor_construct (GType object_type);
static void display_monitor_manager_add_virtual_monitor (DisplayMonitorManager* self,
                                                  DisplayVirtualMonitor* virtual_monitor);
void display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                                    gint value);
void display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                                    gint value);
void display_virtual_monitor_set_current_x (DisplayVirtualMonitor* self,
                                            gint value);
void display_virtual_monitor_set_current_y (DisplayVirtualMonitor* self,
                                            gint value);
void display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                        gdouble value);
void display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                            DisplayTransform value);
void display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                          gboolean value);
static gboolean display_monitor_manager_compare_monitor_with_mutter_info (DisplayMonitor* monitor,
                                                                   MutterReadMonitorInfo* mutter_info);
GeeLinkedList* display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self);
void display_monitor_manager_set_monitor_config (DisplayMonitorManager* self);
GeeLinkedList* display_monitor_manager_get_virtual_monitors (DisplayMonitorManager* self);
void display_monitor_manager_get_mutter_logical_monitor (DisplayVirtualMonitor* virtual_monitor,
                                                         MutterWriteLogicalMonitor* result);
static void _vala_array_add1 (MutterWriteLogicalMonitor* * array,
                       int* length,
                       int* size,
                       const MutterWriteLogicalMonitor* value);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
void mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                            guint serial,
                                                            MutterApplyMethod method,
                                                            MutterWriteLogicalMonitor* logical_monitors,
                                                            gint logical_monitors_length1,
                                                            GHashTable* properties,
                                                            GError** error);
static void _vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                                 gint array_length);
gint display_virtual_monitor_get_x (DisplayVirtualMonitor* self);
gint display_virtual_monitor_get_y (DisplayVirtualMonitor* self);
gdouble display_virtual_monitor_get_scale (DisplayVirtualMonitor* self);
DisplayTransform display_virtual_monitor_get_transform (DisplayVirtualMonitor* self);
gboolean display_virtual_monitor_get_primary (DisplayVirtualMonitor* self);
DisplayMonitorMode* display_monitor_get_current_mode (DisplayMonitor* self);
const gchar* display_monitor_mode_get_id (DisplayMonitorMode* self);
static void _vala_array_add2 (MutterWriteMonitor* * array,
                       int* length,
                       int* size,
                       const MutterWriteMonitor* value);
static MutterWriteMonitor* _vala_array_dup11 (MutterWriteMonitor* self,
                                       int length);
static void _vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                          gint array_length);
void display_monitor_manager_enable_clone_mode (DisplayMonitorManager* self);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self);
gboolean display_monitor_mode_get_is_current (DisplayMonitorMode* self);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
void display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                               DisplayMonitorMode* current_mode);
void display_monitor_manager_set_scale_on_all_monitors (DisplayMonitorManager* self,
                                                        gdouble new_scale);
void display_monitor_manager_disable_clone_mode (DisplayMonitorManager* self);
DisplayMonitorMode* display_monitor_get_preferred_mode (DisplayMonitor* self);
gboolean display_monitor_manager_get_global_scale_required (DisplayMonitorManager* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    gint* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      int stack_length,
                                      const gdouble needle);
gdouble display_monitor_mode_get_preferred_scale (DisplayMonitorMode* self);
gchar* display_virtual_monitor_get_id (DisplayVirtualMonitor* self);
const gchar* display_monitor_get_vendor (DisplayMonitor* self);
const gchar* display_monitor_get_product (DisplayMonitor* self);
const gchar* display_monitor_get_serial (DisplayMonitor* self);
guint display_monitor_get_hash (DisplayMonitor* self);
static void display_monitor_manager_set_virtual_monitors (DisplayMonitorManager* self,
                                                   GeeLinkedList* value);
static void display_monitor_manager_set_monitors (DisplayMonitorManager* self,
                                           GeeLinkedList* value);
gboolean display_monitor_manager_get_mirroring_supported (DisplayMonitorManager* self);
gint display_monitor_manager_get_max_width (DisplayMonitorManager* self);
gint display_monitor_manager_get_max_height (DisplayMonitorManager* self);
gint display_monitor_manager_get_monitor_number (DisplayMonitorManager* self);
gint display_monitor_manager_get_virtual_monitor_number (DisplayMonitorManager* self);
gboolean display_monitor_manager_get_is_mirrored (DisplayMonitorManager* self);
static GObject * display_monitor_manager_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* _sender,
                                                                                                   gpointer self);
static void display_monitor_manager_finalize (GObject * obj);
static void _vala_display_monitor_manager_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_display_monitor_manager_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
display_monitor_manager_get_instance_private (DisplayMonitorManager* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayMonitorManager_private_offset);
}

DisplayMonitorManager*
display_monitor_manager_get_default (void)
{
	DisplayMonitorManager* _tmp0_;
	DisplayMonitorManager* _tmp2_;
	DisplayMonitorManager* result = NULL;
	_tmp0_ = display_monitor_manager_monitor_manager;
	if (_tmp0_ == NULL) {
		DisplayMonitorManager* _tmp1_;
		_tmp1_ = display_monitor_manager_new ();
		_g_object_unref0 (display_monitor_manager_monitor_manager);
		display_monitor_manager_monitor_manager = _tmp1_;
	}
	_tmp2_ = display_monitor_manager_monitor_manager;
	result = _tmp2_;
	return result;
}

static DisplayMonitorManager*
display_monitor_manager_construct (GType object_type)
{
	DisplayMonitorManager * self = NULL;
	self = (DisplayMonitorManager*) g_object_new (object_type, NULL);
	display_monitor_manager_get_monitor_config (self);
	return self;
}

static DisplayMonitorManager*
display_monitor_manager_new (void)
{
	return display_monitor_manager_construct (DISPLAY_TYPE_MONITOR_MANAGER);
}

static void
_vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                    gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                           gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
display_monitor_manager_get_monitor_config (DisplayMonitorManager* self)
{
	MutterReadMonitor* mutter_monitors = NULL;
	gint mutter_monitors_length1 = 0;
	gint _mutter_monitors_size_ = 0;
	MutterReadLogicalMonitor* mutter_logical_monitors = NULL;
	gint mutter_logical_monitors_length1 = 0;
	gint _mutter_logical_monitors_size_ = 0;
	GHashTable* properties = NULL;
	GVariant* supports_mirroring_variant = NULL;
	gconstpointer _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* global_scale_required_variant = NULL;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* max_screen_size_variant = NULL;
	gconstpointer _tmp17_;
	GVariant* _tmp18_;
	GVariant* _tmp19_;
	GeeLinkedList* monitors_with_changed_modes = NULL;
	GeeLinkedList* _tmp26_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		MutterDisplayConfigInterface* _tmp0_;
		guint _tmp1_ = 0U;
		MutterReadMonitor* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		MutterReadLogicalMonitor* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		GHashTable* _tmp6_ = NULL;
		_tmp0_ = self->priv->iface;
		mutter_display_config_interface_get_current_state (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_inner_error0_);
		self->priv->current_serial = _tmp1_;
		mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
		mutter_monitors = _tmp2_;
		mutter_monitors_length1 = _tmp3_;
		_mutter_monitors_size_ = mutter_monitors_length1;
		mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
		mutter_logical_monitors = _tmp4_;
		mutter_logical_monitors_length1 = _tmp5_;
		_mutter_logical_monitors_size_ = mutter_logical_monitors_length1;
		_g_hash_table_unref0 (properties);
		properties = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("MonitorManager.vala:82: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_hash_table_unref0 (properties);
		mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
		mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp9_ = g_hash_table_lookup (properties, "supports-mirroring");
	_tmp10_ = _g_variant_ref0 ((GVariant*) _tmp9_);
	supports_mirroring_variant = _tmp10_;
	_tmp11_ = supports_mirroring_variant;
	if (_tmp11_ != NULL) {
		GVariant* _tmp12_;
		_tmp12_ = supports_mirroring_variant;
		display_monitor_manager_set_mirroring_supported (self, g_variant_get_boolean (_tmp12_));
	} else {
		display_monitor_manager_set_mirroring_supported (self, TRUE);
	}
	_tmp13_ = g_hash_table_lookup (properties, "global-scale-required");
	_tmp14_ = _g_variant_ref0 ((GVariant*) _tmp13_);
	global_scale_required_variant = _tmp14_;
	_tmp15_ = global_scale_required_variant;
	if (_tmp15_ != NULL) {
		GVariant* _tmp16_;
		_tmp16_ = global_scale_required_variant;
		display_monitor_manager_set_global_scale_required (self, g_variant_get_boolean (_tmp16_));
	} else {
		display_monitor_manager_set_global_scale_required (self, FALSE);
	}
	_tmp17_ = g_hash_table_lookup (properties, "max-screen-size");
	_tmp18_ = _g_variant_ref0 ((GVariant*) _tmp17_);
	max_screen_size_variant = _tmp18_;
	_tmp19_ = max_screen_size_variant;
	if (_tmp19_ != NULL) {
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		GVariant* _tmp23_;
		GVariant* _tmp24_;
		GVariant* _tmp25_;
		_tmp20_ = max_screen_size_variant;
		_tmp21_ = g_variant_get_child_value (_tmp20_, (gsize) 0);
		_tmp22_ = _tmp21_;
		display_monitor_manager_set_max_width (self, (gint) g_variant_get_int32 (_tmp22_));
		_g_variant_unref0 (_tmp22_);
		_tmp23_ = max_screen_size_variant;
		_tmp24_ = g_variant_get_child_value (_tmp23_, (gsize) 1);
		_tmp25_ = _tmp24_;
		display_monitor_manager_set_max_height (self, (gint) g_variant_get_int32 (_tmp25_));
		_g_variant_unref0 (_tmp25_);
	} else {
		display_monitor_manager_set_max_width (self, G_MAXINT);
		display_monitor_manager_set_max_height (self, G_MAXINT);
	}
	_tmp26_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	monitors_with_changed_modes = _tmp26_;
	{
		MutterReadMonitor* mutter_monitor_collection = NULL;
		gint mutter_monitor_collection_length1 = 0;
		gint _mutter_monitor_collection_size_ = 0;
		gint mutter_monitor_it = 0;
		mutter_monitor_collection = mutter_monitors;
		mutter_monitor_collection_length1 = mutter_monitors_length1;
		for (mutter_monitor_it = 0; mutter_monitor_it < mutter_monitor_collection_length1; mutter_monitor_it = mutter_monitor_it + 1) {
			MutterReadMonitor _tmp27_;
			MutterReadMonitor _tmp28_ = {0};
			MutterReadMonitor mutter_monitor = {0};
			_tmp27_ = mutter_monitor_collection[mutter_monitor_it];
			mutter_read_monitor_copy (&_tmp27_, &_tmp28_);
			mutter_monitor = _tmp28_;
			{
				DisplayMonitor* monitor = NULL;
				MutterReadMonitor _tmp29_;
				MutterReadMonitorInfo _tmp30_;
				guint _tmp31_;
				guint _tmp32_;
				DisplayMonitor* _tmp33_;
				DisplayMonitor* _tmp34_;
				DisplayMonitor* _tmp40_;
				MutterReadMonitor _tmp41_;
				MutterReadMonitorInfo _tmp42_;
				const gchar* _tmp43_;
				DisplayMonitor* _tmp44_;
				MutterReadMonitor _tmp45_;
				MutterReadMonitorInfo _tmp46_;
				const gchar* _tmp47_;
				DisplayMonitor* _tmp48_;
				MutterReadMonitor _tmp49_;
				MutterReadMonitorInfo _tmp50_;
				const gchar* _tmp51_;
				DisplayMonitor* _tmp52_;
				MutterReadMonitor _tmp53_;
				MutterReadMonitorInfo _tmp54_;
				const gchar* _tmp55_;
				GVariant* display_name_variant = NULL;
				MutterReadMonitor _tmp56_;
				GHashTable* _tmp57_;
				gconstpointer _tmp58_;
				GVariant* _tmp59_;
				GVariant* _tmp60_;
				GVariant* is_builtin_variant = NULL;
				MutterReadMonitor _tmp68_;
				GHashTable* _tmp69_;
				gconstpointer _tmp70_;
				GVariant* _tmp71_;
				GVariant* _tmp72_;
				MutterReadMonitor _tmp76_;
				MutterReadMonitorMode* _tmp77_;
				gint _tmp77__length1;
				_tmp29_ = mutter_monitor;
				_tmp30_ = _tmp29_.monitor;
				_tmp31_ = mutter_read_monitor_info_get_hash (&_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = display_monitor_manager_get_monitor_by_hash (self, _tmp32_);
				monitor = _tmp33_;
				_tmp34_ = monitor;
				if (_tmp34_ == NULL) {
					DisplayMonitor* _tmp35_;
					GeeLinkedList* _tmp36_;
					DisplayMonitor* _tmp37_;
					_tmp35_ = display_monitor_new ();
					_g_object_unref0 (monitor);
					monitor = _tmp35_;
					_tmp36_ = self->priv->_monitors;
					_tmp37_ = monitor;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
				} else {
					GeeLinkedList* _tmp38_;
					DisplayMonitor* _tmp39_;
					_tmp38_ = monitors_with_changed_modes;
					_tmp39_ = monitor;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
				}
				_tmp40_ = monitor;
				_tmp41_ = mutter_monitor;
				_tmp42_ = _tmp41_.monitor;
				_tmp43_ = _tmp42_.connector;
				display_monitor_set_connector (_tmp40_, _tmp43_);
				_tmp44_ = monitor;
				_tmp45_ = mutter_monitor;
				_tmp46_ = _tmp45_.monitor;
				_tmp47_ = _tmp46_.vendor;
				display_monitor_set_vendor (_tmp44_, _tmp47_);
				_tmp48_ = monitor;
				_tmp49_ = mutter_monitor;
				_tmp50_ = _tmp49_.monitor;
				_tmp51_ = _tmp50_.product;
				display_monitor_set_product (_tmp48_, _tmp51_);
				_tmp52_ = monitor;
				_tmp53_ = mutter_monitor;
				_tmp54_ = _tmp53_.monitor;
				_tmp55_ = _tmp54_.serial;
				display_monitor_set_serial (_tmp52_, _tmp55_);
				_tmp56_ = mutter_monitor;
				_tmp57_ = _tmp56_.properties;
				_tmp58_ = g_hash_table_lookup (_tmp57_, "display-name");
				_tmp59_ = _g_variant_ref0 ((GVariant*) _tmp58_);
				display_name_variant = _tmp59_;
				_tmp60_ = display_name_variant;
				if (_tmp60_ != NULL) {
					DisplayMonitor* _tmp61_;
					GVariant* _tmp62_;
					const gchar* _tmp63_;
					_tmp61_ = monitor;
					_tmp62_ = display_name_variant;
					_tmp63_ = g_variant_get_string (_tmp62_, NULL);
					display_monitor_set_display_name (_tmp61_, _tmp63_);
				} else {
					DisplayMonitor* _tmp64_;
					DisplayMonitor* _tmp65_;
					const gchar* _tmp66_;
					const gchar* _tmp67_;
					_tmp64_ = monitor;
					_tmp65_ = monitor;
					_tmp66_ = display_monitor_get_connector (_tmp65_);
					_tmp67_ = _tmp66_;
					display_monitor_set_display_name (_tmp64_, _tmp67_);
				}
				_tmp68_ = mutter_monitor;
				_tmp69_ = _tmp68_.properties;
				_tmp70_ = g_hash_table_lookup (_tmp69_, "is-builtin");
				_tmp71_ = _g_variant_ref0 ((GVariant*) _tmp70_);
				is_builtin_variant = _tmp71_;
				_tmp72_ = is_builtin_variant;
				if (_tmp72_ != NULL) {
					DisplayMonitor* _tmp73_;
					GVariant* _tmp74_;
					_tmp73_ = monitor;
					_tmp74_ = is_builtin_variant;
					display_monitor_set_is_builtin (_tmp73_, g_variant_get_boolean (_tmp74_));
				} else {
					DisplayMonitor* _tmp75_;
					_tmp75_ = monitor;
					display_monitor_set_is_builtin (_tmp75_, FALSE);
				}
				_tmp76_ = mutter_monitor;
				_tmp77_ = _tmp76_.modes;
				_tmp77__length1 = _tmp76_.modes_length1;
				{
					MutterReadMonitorMode* mutter_mode_collection = NULL;
					gint mutter_mode_collection_length1 = 0;
					gint _mutter_mode_collection_size_ = 0;
					gint mutter_mode_it = 0;
					mutter_mode_collection = _tmp77_;
					mutter_mode_collection_length1 = _tmp77__length1;
					for (mutter_mode_it = 0; mutter_mode_it < mutter_mode_collection_length1; mutter_mode_it = mutter_mode_it + 1) {
						MutterReadMonitorMode _tmp78_;
						MutterReadMonitorMode _tmp79_ = {0};
						MutterReadMonitorMode mutter_mode = {0};
						_tmp78_ = mutter_mode_collection[mutter_mode_it];
						mutter_read_monitor_mode_copy (&_tmp78_, &_tmp79_);
						mutter_mode = _tmp79_;
						{
							DisplayMonitorMode* mode = NULL;
							DisplayMonitor* _tmp80_;
							MutterReadMonitorMode _tmp81_;
							const gchar* _tmp82_;
							DisplayMonitorMode* _tmp83_;
							DisplayMonitorMode* _tmp84_;
							DisplayMonitorMode* _tmp90_;
							MutterReadMonitorMode _tmp91_;
							const gchar* _tmp92_;
							DisplayMonitorMode* _tmp93_;
							MutterReadMonitorMode _tmp94_;
							DisplayMonitorMode* _tmp95_;
							MutterReadMonitorMode _tmp96_;
							DisplayMonitorMode* _tmp97_;
							MutterReadMonitorMode _tmp98_;
							DisplayMonitorMode* _tmp99_;
							MutterReadMonitorMode _tmp100_;
							DisplayMonitorMode* _tmp101_;
							MutterReadMonitorMode _tmp102_;
							gdouble* _tmp103_;
							gint _tmp103__length1;
							GVariant* is_preferred_variant = NULL;
							MutterReadMonitorMode _tmp104_;
							GHashTable* _tmp105_;
							gconstpointer _tmp106_;
							GVariant* _tmp107_;
							GVariant* _tmp108_;
							GVariant* is_current_variant = NULL;
							MutterReadMonitorMode _tmp112_;
							GHashTable* _tmp113_;
							gconstpointer _tmp114_;
							GVariant* _tmp115_;
							GVariant* _tmp116_;
							_tmp80_ = monitor;
							_tmp81_ = mutter_mode;
							_tmp82_ = _tmp81_.id;
							_tmp83_ = display_monitor_get_mode_by_id (_tmp80_, _tmp82_);
							mode = _tmp83_;
							_tmp84_ = mode;
							if (_tmp84_ == NULL) {
								DisplayMonitorMode* _tmp85_;
								DisplayMonitor* _tmp86_;
								GeeLinkedList* _tmp87_;
								GeeLinkedList* _tmp88_;
								DisplayMonitorMode* _tmp89_;
								_tmp85_ = display_monitor_mode_new ();
								_g_object_unref0 (mode);
								mode = _tmp85_;
								_tmp86_ = monitor;
								_tmp87_ = display_monitor_get_modes (_tmp86_);
								_tmp88_ = _tmp87_;
								_tmp89_ = mode;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp88_, _tmp89_);
							}
							_tmp90_ = mode;
							_tmp91_ = mutter_mode;
							_tmp92_ = _tmp91_.id;
							display_monitor_mode_set_id (_tmp90_, _tmp92_);
							_tmp93_ = mode;
							_tmp94_ = mutter_mode;
							display_monitor_mode_set_width (_tmp93_, _tmp94_.width);
							_tmp95_ = mode;
							_tmp96_ = mutter_mode;
							display_monitor_mode_set_height (_tmp95_, _tmp96_.height);
							_tmp97_ = mode;
							_tmp98_ = mutter_mode;
							display_monitor_mode_set_frequency (_tmp97_, _tmp98_.frequency);
							_tmp99_ = mode;
							_tmp100_ = mutter_mode;
							display_monitor_mode_set_preferred_scale (_tmp99_, _tmp100_.preferred_scale);
							_tmp101_ = mode;
							_tmp102_ = mutter_mode;
							_tmp103_ = _tmp102_.supported_scales;
							_tmp103__length1 = _tmp102_.supported_scales_length1;
							display_monitor_mode_set_supported_scales (_tmp101_, _tmp103_, _tmp103__length1);
							_tmp104_ = mutter_mode;
							_tmp105_ = _tmp104_.properties;
							_tmp106_ = g_hash_table_lookup (_tmp105_, "is-preferred");
							_tmp107_ = _g_variant_ref0 ((GVariant*) _tmp106_);
							is_preferred_variant = _tmp107_;
							_tmp108_ = is_preferred_variant;
							if (_tmp108_ != NULL) {
								DisplayMonitorMode* _tmp109_;
								GVariant* _tmp110_;
								_tmp109_ = mode;
								_tmp110_ = is_preferred_variant;
								display_monitor_mode_set_is_preferred (_tmp109_, g_variant_get_boolean (_tmp110_));
							} else {
								DisplayMonitorMode* _tmp111_;
								_tmp111_ = mode;
								display_monitor_mode_set_is_preferred (_tmp111_, FALSE);
							}
							_tmp112_ = mutter_mode;
							_tmp113_ = _tmp112_.properties;
							_tmp114_ = g_hash_table_lookup (_tmp113_, "is-current");
							_tmp115_ = _g_variant_ref0 ((GVariant*) _tmp114_);
							is_current_variant = _tmp115_;
							_tmp116_ = is_current_variant;
							if (_tmp116_ != NULL) {
								DisplayMonitorMode* _tmp117_;
								GVariant* _tmp118_;
								_tmp117_ = mode;
								_tmp118_ = is_current_variant;
								display_monitor_mode_set_is_current (_tmp117_, g_variant_get_boolean (_tmp118_));
							} else {
								DisplayMonitorMode* _tmp119_;
								_tmp119_ = mode;
								display_monitor_mode_set_is_current (_tmp119_, FALSE);
							}
							_g_variant_unref0 (is_current_variant);
							_g_variant_unref0 (is_preferred_variant);
							_g_object_unref0 (mode);
							mutter_read_monitor_mode_destroy (&mutter_mode);
						}
					}
				}
				_g_variant_unref0 (is_builtin_variant);
				_g_variant_unref0 (display_name_variant);
				_g_object_unref0 (monitor);
				mutter_read_monitor_destroy (&mutter_monitor);
			}
		}
	}
	{
		MutterReadLogicalMonitor* mutter_logical_monitor_collection = NULL;
		gint mutter_logical_monitor_collection_length1 = 0;
		gint _mutter_logical_monitor_collection_size_ = 0;
		gint mutter_logical_monitor_it = 0;
		mutter_logical_monitor_collection = mutter_logical_monitors;
		mutter_logical_monitor_collection_length1 = mutter_logical_monitors_length1;
		for (mutter_logical_monitor_it = 0; mutter_logical_monitor_it < mutter_logical_monitor_collection_length1; mutter_logical_monitor_it = mutter_logical_monitor_it + 1) {
			MutterReadLogicalMonitor _tmp120_;
			MutterReadLogicalMonitor _tmp121_ = {0};
			MutterReadLogicalMonitor mutter_logical_monitor = {0};
			_tmp120_ = mutter_logical_monitor_collection[mutter_logical_monitor_it];
			mutter_read_logical_monitor_copy (&_tmp120_, &_tmp121_);
			mutter_logical_monitor = _tmp121_;
			{
				gchar* monitors_id = NULL;
				MutterReadLogicalMonitor _tmp122_;
				MutterReadMonitorInfo* _tmp123_;
				gint _tmp123__length1;
				gchar* _tmp124_;
				DisplayVirtualMonitor* virtual_monitor = NULL;
				const gchar* _tmp125_;
				DisplayVirtualMonitor* _tmp126_;
				DisplayVirtualMonitor* _tmp127_;
				DisplayVirtualMonitor* _tmp130_;
				MutterReadLogicalMonitor _tmp131_;
				DisplayVirtualMonitor* _tmp132_;
				MutterReadLogicalMonitor _tmp133_;
				DisplayVirtualMonitor* _tmp134_;
				MutterReadLogicalMonitor _tmp135_;
				DisplayVirtualMonitor* _tmp136_;
				MutterReadLogicalMonitor _tmp137_;
				DisplayVirtualMonitor* _tmp138_;
				MutterReadLogicalMonitor _tmp139_;
				DisplayVirtualMonitor* _tmp140_;
				MutterReadLogicalMonitor _tmp141_;
				DisplayTransform _tmp142_;
				DisplayVirtualMonitor* _tmp143_;
				MutterReadLogicalMonitor _tmp144_;
				MutterReadLogicalMonitor _tmp145_;
				MutterReadMonitorInfo* _tmp146_;
				gint _tmp146__length1;
				_tmp122_ = mutter_logical_monitor;
				_tmp123_ = _tmp122_.monitors;
				_tmp123__length1 = _tmp122_.monitors_length1;
				_tmp124_ = display_virtual_monitor_generate_id_from_monitors (_tmp123_, (gint) _tmp123__length1);
				monitors_id = _tmp124_;
				_tmp125_ = monitors_id;
				_tmp126_ = display_monitor_manager_get_virtual_monitor_by_id (self, _tmp125_);
				virtual_monitor = _tmp126_;
				_tmp127_ = virtual_monitor;
				if (_tmp127_ == NULL) {
					DisplayVirtualMonitor* _tmp128_;
					DisplayVirtualMonitor* _tmp129_;
					_tmp128_ = display_virtual_monitor_new ();
					_g_object_unref0 (virtual_monitor);
					virtual_monitor = _tmp128_;
					_tmp129_ = virtual_monitor;
					display_monitor_manager_add_virtual_monitor (self, _tmp129_);
				}
				_tmp130_ = virtual_monitor;
				_tmp131_ = mutter_logical_monitor;
				display_virtual_monitor_set_x (_tmp130_, _tmp131_.x);
				_tmp132_ = virtual_monitor;
				_tmp133_ = mutter_logical_monitor;
				display_virtual_monitor_set_y (_tmp132_, _tmp133_.y);
				_tmp134_ = virtual_monitor;
				_tmp135_ = mutter_logical_monitor;
				display_virtual_monitor_set_current_x (_tmp134_, _tmp135_.x);
				_tmp136_ = virtual_monitor;
				_tmp137_ = mutter_logical_monitor;
				display_virtual_monitor_set_current_y (_tmp136_, _tmp137_.y);
				_tmp138_ = virtual_monitor;
				_tmp139_ = mutter_logical_monitor;
				display_virtual_monitor_set_scale (_tmp138_, _tmp139_.scale);
				_tmp140_ = virtual_monitor;
				_tmp141_ = mutter_logical_monitor;
				_tmp142_ = _tmp141_.transform;
				display_virtual_monitor_set_transform (_tmp140_, _tmp142_);
				_tmp143_ = virtual_monitor;
				_tmp144_ = mutter_logical_monitor;
				display_virtual_monitor_set_primary (_tmp143_, _tmp144_.primary);
				_tmp145_ = mutter_logical_monitor;
				_tmp146_ = _tmp145_.monitors;
				_tmp146__length1 = _tmp145_.monitors_length1;
				{
					MutterReadMonitorInfo* mutter_info_collection = NULL;
					gint mutter_info_collection_length1 = 0;
					gint _mutter_info_collection_size_ = 0;
					gint mutter_info_it = 0;
					mutter_info_collection = _tmp146_;
					mutter_info_collection_length1 = _tmp146__length1;
					for (mutter_info_it = 0; mutter_info_it < mutter_info_collection_length1; mutter_info_it = mutter_info_it + 1) {
						MutterReadMonitorInfo _tmp147_;
						MutterReadMonitorInfo _tmp148_ = {0};
						MutterReadMonitorInfo mutter_info = {0};
						_tmp147_ = mutter_info_collection[mutter_info_it];
						mutter_read_monitor_info_copy (&_tmp147_, &_tmp148_);
						mutter_info = _tmp148_;
						{
							{
								GeeLinkedList* _monitor_list = NULL;
								GeeLinkedList* _tmp149_;
								GeeLinkedList* _tmp150_;
								gint _monitor_size = 0;
								GeeLinkedList* _tmp151_;
								gint _tmp152_;
								gint _tmp153_;
								gint _monitor_index = 0;
								_tmp149_ = self->priv->_monitors;
								_tmp150_ = _g_object_ref0 (_tmp149_);
								_monitor_list = _tmp150_;
								_tmp151_ = _monitor_list;
								_tmp152_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp151_);
								_tmp153_ = _tmp152_;
								_monitor_size = _tmp153_;
								_monitor_index = -1;
								while (TRUE) {
									DisplayMonitor* monitor = NULL;
									GeeLinkedList* _tmp154_;
									gpointer _tmp155_;
									gboolean _tmp156_ = FALSE;
									DisplayMonitor* _tmp157_;
									MutterReadMonitorInfo _tmp158_;
									_monitor_index = _monitor_index + 1;
									if (!(_monitor_index < _monitor_size)) {
										break;
									}
									_tmp154_ = _monitor_list;
									_tmp155_ = gee_abstract_list_get ((GeeAbstractList*) _tmp154_, _monitor_index);
									monitor = (DisplayMonitor*) _tmp155_;
									_tmp157_ = monitor;
									_tmp158_ = mutter_info;
									if (display_monitor_manager_compare_monitor_with_mutter_info (_tmp157_, &_tmp158_)) {
										DisplayVirtualMonitor* _tmp159_;
										GeeLinkedList* _tmp160_;
										GeeLinkedList* _tmp161_;
										DisplayMonitor* _tmp162_;
										_tmp159_ = virtual_monitor;
										_tmp160_ = display_virtual_monitor_get_monitors (_tmp159_);
										_tmp161_ = _tmp160_;
										_tmp162_ = monitor;
										_tmp156_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp161_, _tmp162_);
									} else {
										_tmp156_ = FALSE;
									}
									if (_tmp156_) {
										DisplayVirtualMonitor* _tmp163_;
										GeeLinkedList* _tmp164_;
										GeeLinkedList* _tmp165_;
										DisplayMonitor* _tmp166_;
										GeeLinkedList* _tmp167_;
										DisplayMonitor* _tmp168_;
										_tmp163_ = virtual_monitor;
										_tmp164_ = display_virtual_monitor_get_monitors (_tmp163_);
										_tmp165_ = _tmp164_;
										_tmp166_ = monitor;
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp165_, _tmp166_);
										_tmp167_ = monitors_with_changed_modes;
										_tmp168_ = monitor;
										if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp167_, _tmp168_)) {
											DisplayVirtualMonitor* _tmp169_;
											_tmp169_ = virtual_monitor;
											g_signal_emit_by_name (_tmp169_, "modes-changed");
										}
										_g_object_unref0 (monitor);
										break;
									}
									_g_object_unref0 (monitor);
								}
								_g_object_unref0 (_monitor_list);
							}
							mutter_read_monitor_info_destroy (&mutter_info);
						}
					}
				}
				_g_object_unref0 (virtual_monitor);
				_g_free0 (monitors_id);
				mutter_read_logical_monitor_destroy (&mutter_logical_monitor);
			}
		}
	}
	_g_object_unref0 (monitors_with_changed_modes);
	_g_variant_unref0 (max_screen_size_variant);
	_g_variant_unref0 (global_scale_required_variant);
	_g_variant_unref0 (supports_mirroring_variant);
	_g_hash_table_unref0 (properties);
	mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
	mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
}

static void
_vala_array_add1 (MutterWriteLogicalMonitor* * array,
                  int* length,
                  int* size,
                  const MutterWriteLogicalMonitor* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MutterWriteLogicalMonitor, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_variant_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}

static void
_vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                            gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

void
display_monitor_manager_set_monitor_config (DisplayMonitorManager* self)
{
	MutterWriteLogicalMonitor* logical_monitors = NULL;
	MutterWriteLogicalMonitor* _tmp0_;
	gint logical_monitors_length1;
	gint _logical_monitors_size_;
	GHashTable* properties = NULL;
	GHashFunc _tmp11_;
	GEqualFunc _tmp12_;
	GHashTable* _tmp13_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (MutterWriteLogicalMonitor, 0);
	logical_monitors = _tmp0_;
	logical_monitors_length1 = 0;
	_logical_monitors_size_ = logical_monitors_length1;
	{
		GeeLinkedList* _virtual_monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _virtual_monitor_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _virtual_monitor_index = 0;
		_tmp1_ = self->priv->_virtual_monitors;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_virtual_monitor_list = _tmp2_;
		_tmp3_ = _virtual_monitor_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_virtual_monitor_size = _tmp5_;
		_virtual_monitor_index = -1;
		while (TRUE) {
			DisplayVirtualMonitor* virtual_monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			MutterWriteLogicalMonitor* _tmp8_;
			gint _tmp8__length1;
			DisplayVirtualMonitor* _tmp9_;
			MutterWriteLogicalMonitor _tmp10_ = {0};
			_virtual_monitor_index = _virtual_monitor_index + 1;
			if (!(_virtual_monitor_index < _virtual_monitor_size)) {
				break;
			}
			_tmp6_ = _virtual_monitor_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _virtual_monitor_index);
			virtual_monitor = (DisplayVirtualMonitor*) _tmp7_;
			_tmp8_ = logical_monitors;
			_tmp8__length1 = logical_monitors_length1;
			_tmp9_ = virtual_monitor;
			display_monitor_manager_get_mutter_logical_monitor (_tmp9_, &_tmp10_);
			_vala_array_add1 (&logical_monitors, &logical_monitors_length1, &_logical_monitors_size_, &_tmp10_);
			_g_object_unref0 (virtual_monitor);
		}
		_g_object_unref0 (_virtual_monitor_list);
	}
	_tmp11_ = g_str_hash;
	_tmp12_ = g_str_equal;
	_tmp13_ = g_hash_table_new_full (_tmp11_, _tmp12_, _g_free0_, _g_variant_unref0_);
	properties = _tmp13_;
	{
		MutterDisplayConfigInterface* _tmp14_;
		MutterWriteLogicalMonitor* _tmp15_;
		gint _tmp15__length1;
		_tmp14_ = self->priv->iface;
		_tmp15_ = logical_monitors;
		_tmp15__length1 = logical_monitors_length1;
		mutter_display_config_interface_apply_monitors_config (_tmp14_, self->priv->current_serial, MUTTER_APPLY_METHOD_PERSISTENT, _tmp15_, (gint) _tmp15__length1, properties, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_critical ("MonitorManager.vala:218: %s", _tmp17_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_hash_table_unref0 (properties);
		logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_hash_table_unref0 (properties);
	logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static void
_vala_array_add2 (MutterWriteMonitor* * array,
                  int* length,
                  int* size,
                  const MutterWriteMonitor* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MutterWriteMonitor, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static MutterWriteMonitor*
_vala_array_dup11 (MutterWriteMonitor* self,
                   int length)
{
	MutterWriteMonitor* result;
	int i;
	result = g_new0 (MutterWriteMonitor, length);
	for (i = 0; i < length; i++) {
		MutterWriteMonitor _tmp0_;
		MutterWriteMonitor _tmp1_ = {0};
		_tmp0_ = self[i];
		mutter_write_monitor_copy (&_tmp0_, &_tmp1_);
		result[i] = _tmp1_;
	}
	return result;
}

static void
_vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                     gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

void
display_monitor_manager_get_mutter_logical_monitor (DisplayVirtualMonitor* virtual_monitor,
                                                    MutterWriteLogicalMonitor* result)
{
	MutterWriteLogicalMonitor logical_monitor = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	DisplayTransform _tmp6_;
	DisplayTransform _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	MutterWriteLogicalMonitor _tmp10_ = {0};
	MutterWriteMonitor* mutter_monitors = NULL;
	MutterWriteMonitor* _tmp11_;
	gint mutter_monitors_length1;
	gint _mutter_monitors_size_;
	MutterWriteMonitor* _tmp42_;
	gint _tmp42__length1;
	MutterWriteMonitor* _tmp43_;
	gint _tmp43__length1;
	g_return_if_fail (virtual_monitor != NULL);
	_tmp0_ = display_virtual_monitor_get_x (virtual_monitor);
	_tmp1_ = _tmp0_;
	_tmp2_ = display_virtual_monitor_get_y (virtual_monitor);
	_tmp3_ = _tmp2_;
	_tmp4_ = display_virtual_monitor_get_scale (virtual_monitor);
	_tmp5_ = _tmp4_;
	_tmp6_ = display_virtual_monitor_get_transform (virtual_monitor);
	_tmp7_ = _tmp6_;
	_tmp8_ = display_virtual_monitor_get_primary (virtual_monitor);
	_tmp9_ = _tmp8_;
	memset (&_tmp10_, 0, sizeof (MutterWriteLogicalMonitor));
	_tmp10_.x = _tmp1_;
	_tmp10_.y = _tmp3_;
	_tmp10_.scale = _tmp5_;
	_tmp10_.transform = _tmp7_;
	_tmp10_.primary = _tmp9_;
	logical_monitor = _tmp10_;
	_tmp11_ = g_new0 (MutterWriteMonitor, 0);
	mutter_monitors = _tmp11_;
	mutter_monitors_length1 = 0;
	_mutter_monitors_size_ = mutter_monitors_length1;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp12_;
		GeeLinkedList* _tmp13_;
		GeeLinkedList* _tmp14_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _monitor_index = 0;
		_tmp12_ = display_virtual_monitor_get_monitors (virtual_monitor);
		_tmp13_ = _tmp12_;
		_tmp14_ = _g_object_ref0 (_tmp13_);
		_monitor_list = _tmp14_;
		_tmp15_ = _monitor_list;
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
		_tmp17_ = _tmp16_;
		_monitor_size = _tmp17_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp18_;
			gpointer _tmp19_;
			GHashTable* properties = NULL;
			GHashFunc _tmp20_;
			GEqualFunc _tmp21_;
			GHashTable* _tmp22_;
			MutterWriteMonitor mutter_monitor = {0};
			DisplayMonitor* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			DisplayMonitor* _tmp27_;
			DisplayMonitorMode* _tmp28_;
			DisplayMonitorMode* _tmp29_;
			DisplayMonitorMode* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			GHashTable* _tmp34_;
			GHashTable* _tmp35_;
			MutterWriteMonitor _tmp36_ = {0};
			MutterWriteMonitor _tmp37_;
			MutterWriteMonitor* _tmp38_;
			gint _tmp38__length1;
			MutterWriteMonitor _tmp39_;
			MutterWriteMonitor _tmp40_;
			MutterWriteMonitor _tmp41_ = {0};
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp18_ = _monitor_list;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp19_;
			_tmp20_ = g_str_hash;
			_tmp21_ = g_str_equal;
			_tmp22_ = g_hash_table_new_full (_tmp20_, _tmp21_, _g_free0_, _g_variant_unref0_);
			properties = _tmp22_;
			_tmp23_ = monitor;
			_tmp24_ = display_monitor_get_connector (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = monitor;
			_tmp28_ = display_monitor_get_current_mode (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = _tmp29_;
			_tmp31_ = display_monitor_mode_get_id (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = g_strdup (_tmp32_);
			_tmp34_ = properties;
			_tmp35_ = _g_hash_table_ref0 (_tmp34_);
			memset (&_tmp36_, 0, sizeof (MutterWriteMonitor));
			_g_free0 (_tmp36_.connector);
			_tmp36_.connector = _tmp26_;
			_g_free0 (_tmp36_.monitor_mode);
			_tmp36_.monitor_mode = _tmp33_;
			_g_hash_table_unref0 (_tmp36_.properties);
			_tmp36_.properties = _tmp35_;
			_tmp37_ = _tmp36_;
			_g_object_unref0 (_tmp30_);
			mutter_monitor = _tmp37_;
			_tmp38_ = mutter_monitors;
			_tmp38__length1 = mutter_monitors_length1;
			_tmp39_ = mutter_monitor;
			_tmp40_ = _tmp39_;
			mutter_write_monitor_copy (&_tmp40_, &_tmp41_);
			_vala_array_add2 (&mutter_monitors, &mutter_monitors_length1, &_mutter_monitors_size_, &_tmp41_);
			mutter_write_monitor_destroy (&mutter_monitor);
			_g_hash_table_unref0 (properties);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	_tmp42_ = mutter_monitors;
	_tmp42__length1 = mutter_monitors_length1;
	_tmp43_ = (_tmp42_ != NULL) ? _vala_array_dup11 (_tmp42_, _tmp42__length1) : ((gpointer) _tmp42_);
	_tmp43__length1 = _tmp42__length1;
	logical_monitor.monitors = (_vala_MutterWriteMonitor_array_free (logical_monitor.monitors, logical_monitor.monitors_length1), NULL);
	logical_monitor.monitors = _tmp43_;
	logical_monitor.monitors_length1 = _tmp43__length1;
	*result = logical_monitor;
	mutter_monitors = (_vala_MutterWriteMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
	return;
}

void
display_monitor_manager_enable_clone_mode (DisplayMonitorManager* self)
{
	DisplayVirtualMonitor* clone_virtual_monitor = NULL;
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	DisplayVirtualMonitor* _tmp2_;
	GeeLinkedList* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	GeeLinkedList* modes = NULL;
	DisplayVirtualMonitor* _tmp8_;
	GeeLinkedList* _tmp9_;
	DisplayMonitorMode* largest_mode_in_use = NULL;
	DisplayMonitorMode* largest_mode = NULL;
	GeeLinkedList* _tmp10_;
	gpointer _tmp11_;
	DisplayMonitorMode* _tmp45_;
	GeeLinkedList* _tmp50_;
	GeeLinkedList* _tmp51_;
	DisplayVirtualMonitor* _tmp52_;
	g_return_if_fail (self != NULL);
	_tmp0_ = display_virtual_monitor_new ();
	clone_virtual_monitor = _tmp0_;
	_tmp1_ = clone_virtual_monitor;
	display_virtual_monitor_set_primary (_tmp1_, TRUE);
	_tmp2_ = clone_virtual_monitor;
	_tmp3_ = self->priv->_monitors;
	display_virtual_monitor_set_scale (_tmp2_, display_utils_get_min_compatible_scale (_tmp3_));
	_tmp4_ = clone_virtual_monitor;
	_tmp5_ = display_virtual_monitor_get_monitors (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->_monitors;
	gee_collection_add_all ((GeeCollection*) _tmp6_, (GeeCollection*) _tmp7_);
	_tmp8_ = clone_virtual_monitor;
	_tmp9_ = display_virtual_monitor_get_available_modes (_tmp8_);
	modes = _tmp9_;
	largest_mode_in_use = NULL;
	_tmp10_ = modes;
	_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, 0);
	largest_mode = (DisplayMonitorMode*) _tmp11_;
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp12_;
		GeeLinkedList* _tmp13_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _mode_index = 0;
		_tmp12_ = modes;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_mode_list = _tmp13_;
		_tmp14_ = _mode_list;
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
		_tmp16_ = _tmp15_;
		_mode_size = _tmp16_;
		_mode_index = -1;
		while (TRUE) {
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp17_;
			gpointer _tmp18_;
			DisplayMonitorMode* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp21_;
			DisplayMonitorMode* _tmp33_;
			_mode_index = _mode_index + 1;
			if (!(_mode_index < _mode_size)) {
				break;
			}
			_tmp17_ = _mode_list;
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _mode_index);
			mode = (DisplayMonitorMode*) _tmp18_;
			_tmp19_ = mode;
			_tmp20_ = display_monitor_mode_get_is_current (_tmp19_);
			_tmp21_ = _tmp20_;
			if (_tmp21_) {
				DisplayMonitorMode* _tmp22_;
				_tmp22_ = largest_mode_in_use;
				if (_tmp22_ == NULL) {
					DisplayMonitorMode* _tmp23_;
					DisplayMonitorMode* _tmp24_;
					_tmp23_ = mode;
					_tmp24_ = _g_object_ref0 (_tmp23_);
					_g_object_unref0 (largest_mode_in_use);
					largest_mode_in_use = _tmp24_;
				} else {
					DisplayMonitorMode* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
					DisplayMonitorMode* _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
					_tmp25_ = largest_mode_in_use;
					_tmp26_ = display_monitor_mode_get_width (_tmp25_);
					_tmp27_ = _tmp26_;
					_tmp28_ = mode;
					_tmp29_ = display_monitor_mode_get_width (_tmp28_);
					_tmp30_ = _tmp29_;
					if (_tmp27_ < _tmp30_) {
						DisplayMonitorMode* _tmp31_;
						DisplayMonitorMode* _tmp32_;
						_tmp31_ = mode;
						_tmp32_ = _g_object_ref0 (_tmp31_);
						_g_object_unref0 (largest_mode_in_use);
						largest_mode_in_use = _tmp32_;
					}
				}
			}
			_tmp33_ = largest_mode_in_use;
			if (_tmp33_ == NULL) {
				DisplayMonitorMode* _tmp34_;
				_tmp34_ = largest_mode;
				if (_tmp34_ == NULL) {
					DisplayMonitorMode* _tmp35_;
					DisplayMonitorMode* _tmp36_;
					_tmp35_ = mode;
					_tmp36_ = _g_object_ref0 (_tmp35_);
					_g_object_unref0 (largest_mode);
					largest_mode = _tmp36_;
				} else {
					DisplayMonitorMode* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
					DisplayMonitorMode* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					_tmp37_ = largest_mode;
					_tmp38_ = display_monitor_mode_get_width (_tmp37_);
					_tmp39_ = _tmp38_;
					_tmp40_ = mode;
					_tmp41_ = display_monitor_mode_get_width (_tmp40_);
					_tmp42_ = _tmp41_;
					if (_tmp39_ < _tmp42_) {
						DisplayMonitorMode* _tmp43_;
						DisplayMonitorMode* _tmp44_;
						_tmp43_ = mode;
						_tmp44_ = _g_object_ref0 (_tmp43_);
						_g_object_unref0 (largest_mode);
						largest_mode = _tmp44_;
					}
				}
			}
			_g_object_unref0 (mode);
		}
		_g_object_unref0 (_mode_list);
	}
	_tmp45_ = largest_mode_in_use;
	if (_tmp45_ != NULL) {
		DisplayVirtualMonitor* _tmp46_;
		DisplayMonitorMode* _tmp47_;
		_tmp46_ = clone_virtual_monitor;
		_tmp47_ = largest_mode_in_use;
		display_virtual_monitor_set_current_mode (_tmp46_, _tmp47_);
	} else {
		DisplayVirtualMonitor* _tmp48_;
		DisplayMonitorMode* _tmp49_;
		_tmp48_ = clone_virtual_monitor;
		_tmp49_ = largest_mode;
		display_virtual_monitor_set_current_mode (_tmp48_, _tmp49_);
	}
	_tmp50_ = self->priv->_virtual_monitors;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp50_);
	_tmp51_ = self->priv->_virtual_monitors;
	_tmp52_ = clone_virtual_monitor;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
	g_object_notify ((GObject*) self, "virtual-monitor-number");
	g_object_notify ((GObject*) self, "is-mirrored");
	_g_object_unref0 (largest_mode);
	_g_object_unref0 (largest_mode_in_use);
	_g_object_unref0 (modes);
	_g_object_unref0 (clone_virtual_monitor);
}

void
display_monitor_manager_set_scale_on_all_monitors (DisplayMonitorManager* self,
                                                   gdouble new_scale)
{
	gdouble max_scale = 0.0;
	GeeLinkedList* _tmp0_;
	g_return_if_fail (self != NULL);
	if (new_scale <= 0.0) {
		return;
	}
	_tmp0_ = self->priv->_monitors;
	max_scale = display_utils_get_min_compatible_scale (_tmp0_);
	if (new_scale > max_scale) {
		return;
	}
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _monitor_index = 0;
		_tmp1_ = self->priv->_virtual_monitors;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_monitor_list = _tmp2_;
		_tmp3_ = _monitor_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_monitor_size = _tmp5_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayVirtualMonitor* monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayVirtualMonitor* _tmp8_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp6_ = _monitor_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _monitor_index);
			monitor = (DisplayVirtualMonitor*) _tmp7_;
			_tmp8_ = monitor;
			display_virtual_monitor_set_scale (_tmp8_, new_scale);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	display_monitor_manager_set_monitor_config (self);
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             int stack_length,
                             const gdouble needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

void
display_monitor_manager_disable_clone_mode (DisplayMonitorManager* self)
{
	gdouble max_scale = 0.0;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* new_virtual_monitors = NULL;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp62_;
	gpointer _tmp63_;
	DisplayVirtualMonitor* _tmp64_;
	GeeLinkedList* _tmp65_;
	GeeLinkedList* _tmp66_;
	GeeLinkedList* _tmp67_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_monitors;
	max_scale = display_utils_get_min_compatible_scale (_tmp0_);
	_tmp1_ = gee_linked_list_new (DISPLAY_TYPE_VIRTUAL_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_virtual_monitors = _tmp1_;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _monitor_index = 0;
		_tmp2_ = self->priv->_monitors;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_monitor_list = _tmp3_;
		_tmp4_ = _monitor_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_monitor_size = _tmp6_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayVirtualMonitor* single_virtual_monitor = NULL;
			DisplayVirtualMonitor* _tmp9_;
			DisplayMonitorMode* preferred_mode = NULL;
			DisplayMonitor* _tmp10_;
			DisplayMonitorMode* _tmp11_;
			DisplayMonitorMode* _tmp12_;
			DisplayMonitorMode* current_mode = NULL;
			DisplayMonitor* _tmp13_;
			DisplayMonitorMode* _tmp14_;
			DisplayMonitorMode* _tmp15_;
			gboolean _tmp16_;
			DisplayVirtualMonitor* _tmp56_;
			GeeLinkedList* _tmp57_;
			GeeLinkedList* _tmp58_;
			DisplayMonitor* _tmp59_;
			GeeLinkedList* _tmp60_;
			DisplayVirtualMonitor* _tmp61_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp7_ = _monitor_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp8_;
			_tmp9_ = display_virtual_monitor_new ();
			single_virtual_monitor = _tmp9_;
			_tmp10_ = monitor;
			_tmp11_ = display_monitor_get_preferred_mode (_tmp10_);
			_tmp12_ = _tmp11_;
			preferred_mode = _tmp12_;
			_tmp13_ = monitor;
			_tmp14_ = display_monitor_get_current_mode (_tmp13_);
			_tmp15_ = _tmp14_;
			current_mode = _tmp15_;
			_tmp16_ = self->priv->_global_scale_required;
			if (_tmp16_) {
				DisplayVirtualMonitor* _tmp17_;
				DisplayMonitorMode* _tmp18_;
				gdouble* _tmp19_;
				gint _tmp19__length1;
				gdouble* _tmp20_;
				gint _tmp20__length1;
				_tmp17_ = single_virtual_monitor;
				display_virtual_monitor_set_scale (_tmp17_, max_scale);
				_tmp18_ = preferred_mode;
				_tmp19_ = display_monitor_mode_get_supported_scales (_tmp18_, &_tmp19__length1);
				_tmp20_ = _tmp19_;
				_tmp20__length1 = _tmp19__length1;
				if (_vala_double_array_contains (_tmp20_, _tmp20__length1, max_scale)) {
					DisplayMonitorMode* _tmp21_;
					DisplayMonitorMode* _tmp22_;
					_tmp21_ = current_mode;
					display_monitor_mode_set_is_current (_tmp21_, FALSE);
					_tmp22_ = preferred_mode;
					display_monitor_mode_set_is_current (_tmp22_, TRUE);
				} else {
					DisplayMonitorMode* _tmp23_;
					gdouble* _tmp24_;
					gint _tmp24__length1;
					gdouble* _tmp25_;
					gint _tmp25__length1;
					_tmp23_ = current_mode;
					_tmp24_ = display_monitor_mode_get_supported_scales (_tmp23_, &_tmp24__length1);
					_tmp25_ = _tmp24_;
					_tmp25__length1 = _tmp24__length1;
					if (!_vala_double_array_contains (_tmp25_, _tmp25__length1, max_scale)) {
						DisplayMonitorMode* largest_mode = NULL;
						DisplayMonitorMode* _tmp48_;
						DisplayMonitorMode* _tmp49_;
						largest_mode = NULL;
						{
							GeeLinkedList* _mode_list = NULL;
							DisplayMonitor* _tmp26_;
							GeeLinkedList* _tmp27_;
							GeeLinkedList* _tmp28_;
							GeeLinkedList* _tmp29_;
							gint _mode_size = 0;
							GeeLinkedList* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _mode_index = 0;
							_tmp26_ = monitor;
							_tmp27_ = display_monitor_get_modes (_tmp26_);
							_tmp28_ = _tmp27_;
							_tmp29_ = _g_object_ref0 (_tmp28_);
							_mode_list = _tmp29_;
							_tmp30_ = _mode_list;
							_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
							_tmp32_ = _tmp31_;
							_mode_size = _tmp32_;
							_mode_index = -1;
							while (TRUE) {
								DisplayMonitorMode* mode = NULL;
								GeeLinkedList* _tmp33_;
								gpointer _tmp34_;
								DisplayMonitorMode* _tmp35_;
								gdouble* _tmp36_;
								gint _tmp36__length1;
								gdouble* _tmp37_;
								gint _tmp37__length1;
								_mode_index = _mode_index + 1;
								if (!(_mode_index < _mode_size)) {
									break;
								}
								_tmp33_ = _mode_list;
								_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _mode_index);
								mode = (DisplayMonitorMode*) _tmp34_;
								_tmp35_ = mode;
								_tmp36_ = display_monitor_mode_get_supported_scales (_tmp35_, &_tmp36__length1);
								_tmp37_ = _tmp36_;
								_tmp37__length1 = _tmp36__length1;
								if (_vala_double_array_contains (_tmp37_, _tmp37__length1, max_scale)) {
									gboolean _tmp38_ = FALSE;
									DisplayMonitorMode* _tmp39_;
									_tmp39_ = largest_mode;
									if (_tmp39_ == NULL) {
										_tmp38_ = TRUE;
									} else {
										DisplayMonitorMode* _tmp40_;
										gint _tmp41_;
										gint _tmp42_;
										DisplayMonitorMode* _tmp43_;
										gint _tmp44_;
										gint _tmp45_;
										_tmp40_ = mode;
										_tmp41_ = display_monitor_mode_get_width (_tmp40_);
										_tmp42_ = _tmp41_;
										_tmp43_ = largest_mode;
										_tmp44_ = display_monitor_mode_get_width (_tmp43_);
										_tmp45_ = _tmp44_;
										_tmp38_ = _tmp42_ > _tmp45_;
									}
									if (_tmp38_) {
										DisplayMonitorMode* _tmp46_;
										DisplayMonitorMode* _tmp47_;
										_tmp46_ = mode;
										_tmp47_ = _g_object_ref0 (_tmp46_);
										_g_object_unref0 (largest_mode);
										largest_mode = _tmp47_;
									}
								}
								_g_object_unref0 (mode);
							}
							_g_object_unref0 (_mode_list);
						}
						_tmp48_ = current_mode;
						display_monitor_mode_set_is_current (_tmp48_, FALSE);
						_tmp49_ = largest_mode;
						display_monitor_mode_set_is_current (_tmp49_, TRUE);
						_g_object_unref0 (largest_mode);
					}
				}
			} else {
				DisplayMonitorMode* _tmp50_;
				DisplayMonitorMode* _tmp51_;
				DisplayVirtualMonitor* _tmp52_;
				DisplayMonitorMode* _tmp53_;
				gdouble _tmp54_;
				gdouble _tmp55_;
				_tmp50_ = current_mode;
				display_monitor_mode_set_is_current (_tmp50_, FALSE);
				_tmp51_ = preferred_mode;
				display_monitor_mode_set_is_current (_tmp51_, TRUE);
				_tmp52_ = single_virtual_monitor;
				_tmp53_ = preferred_mode;
				_tmp54_ = display_monitor_mode_get_preferred_scale (_tmp53_);
				_tmp55_ = _tmp54_;
				display_virtual_monitor_set_scale (_tmp52_, _tmp55_);
			}
			_tmp56_ = single_virtual_monitor;
			_tmp57_ = display_virtual_monitor_get_monitors (_tmp56_);
			_tmp58_ = _tmp57_;
			_tmp59_ = monitor;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, _tmp59_);
			_tmp60_ = new_virtual_monitors;
			_tmp61_ = single_virtual_monitor;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, _tmp61_);
			_g_object_unref0 (current_mode);
			_g_object_unref0 (preferred_mode);
			_g_object_unref0 (single_virtual_monitor);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	_tmp62_ = new_virtual_monitors;
	_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _tmp62_, 0);
	_tmp64_ = (DisplayVirtualMonitor*) _tmp63_;
	display_virtual_monitor_set_primary (_tmp64_, TRUE);
	_g_object_unref0 (_tmp64_);
	_tmp65_ = self->priv->_virtual_monitors;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp65_);
	_tmp66_ = self->priv->_virtual_monitors;
	_tmp67_ = new_virtual_monitors;
	gee_collection_add_all ((GeeCollection*) _tmp66_, (GeeCollection*) _tmp67_);
	g_object_notify ((GObject*) self, "virtual-monitor-number");
	g_object_notify ((GObject*) self, "is-mirrored");
	_g_object_unref0 (new_virtual_monitors);
}

static void
display_monitor_manager_add_virtual_monitor (DisplayMonitorManager* self,
                                             DisplayVirtualMonitor* virtual_monitor)
{
	GeeLinkedList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (virtual_monitor != NULL);
	_tmp0_ = self->priv->_virtual_monitors;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, virtual_monitor);
	g_object_notify ((GObject*) self, "virtual-monitor-number");
}

static DisplayVirtualMonitor*
display_monitor_manager_get_virtual_monitor_by_id (DisplayMonitorManager* self,
                                                   const gchar* id)
{
	DisplayVirtualMonitor* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	{
		GeeLinkedList* _vm_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _vm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _vm_index = 0;
		_tmp0_ = self->priv->_virtual_monitors;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_vm_list = _tmp1_;
		_tmp2_ = _vm_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_vm_size = _tmp4_;
		_vm_index = -1;
		while (TRUE) {
			DisplayVirtualMonitor* vm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			DisplayVirtualMonitor* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gboolean _tmp11_;
			_vm_index = _vm_index + 1;
			if (!(_vm_index < _vm_size)) {
				break;
			}
			_tmp5_ = _vm_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _vm_index);
			vm = (DisplayVirtualMonitor*) _tmp6_;
			_tmp7_ = vm;
			_tmp8_ = display_virtual_monitor_get_id (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strcmp0 (_tmp10_, id) == 0;
			_g_free0 (_tmp10_);
			if (_tmp11_) {
				result = vm;
				_g_object_unref0 (_vm_list);
				return result;
			}
			_g_object_unref0 (vm);
		}
		_g_object_unref0 (_vm_list);
	}
	result = NULL;
	return result;
}

static gboolean
display_monitor_manager_compare_monitor_with_mutter_info (DisplayMonitor* monitor,
                                                          MutterReadMonitorInfo* mutter_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	MutterReadMonitorInfo _tmp5_;
	const gchar* _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (monitor != NULL, FALSE);
	g_return_val_if_fail (mutter_info != NULL, FALSE);
	_tmp3_ = display_monitor_get_connector (monitor);
	_tmp4_ = _tmp3_;
	_tmp5_ = *mutter_info;
	_tmp6_ = _tmp5_.connector;
	if (g_strcmp0 (_tmp4_, _tmp6_) == 0) {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		MutterReadMonitorInfo _tmp9_;
		const gchar* _tmp10_;
		_tmp7_ = display_monitor_get_vendor (monitor);
		_tmp8_ = _tmp7_;
		_tmp9_ = *mutter_info;
		_tmp10_ = _tmp9_.vendor;
		_tmp2_ = g_strcmp0 (_tmp8_, _tmp10_) == 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		MutterReadMonitorInfo _tmp13_;
		const gchar* _tmp14_;
		_tmp11_ = display_monitor_get_product (monitor);
		_tmp12_ = _tmp11_;
		_tmp13_ = *mutter_info;
		_tmp14_ = _tmp13_.product;
		_tmp1_ = g_strcmp0 (_tmp12_, _tmp14_) == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		MutterReadMonitorInfo _tmp17_;
		const gchar* _tmp18_;
		_tmp15_ = display_monitor_get_serial (monitor);
		_tmp16_ = _tmp15_;
		_tmp17_ = *mutter_info;
		_tmp18_ = _tmp17_.serial;
		_tmp0_ = g_strcmp0 (_tmp16_, _tmp18_) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static DisplayMonitor*
display_monitor_manager_get_monitor_by_hash (DisplayMonitorManager* self,
                                             guint hash)
{
	DisplayMonitor* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
		_tmp0_ = self->priv->_monitors;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_monitor_list = _tmp1_;
		_tmp2_ = _monitor_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			DisplayMonitor* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp5_ = _monitor_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp6_;
			_tmp7_ = monitor;
			_tmp8_ = display_monitor_get_hash (_tmp7_);
			_tmp9_ = _tmp8_;
			if (_tmp9_ == hash) {
				result = monitor;
				_g_object_unref0 (_monitor_list);
				return result;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = NULL;
	return result;
}

GeeLinkedList*
display_monitor_manager_get_virtual_monitors (DisplayMonitorManager* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_virtual_monitors;
	result = _tmp0_;
	return result;
}

static void
display_monitor_manager_set_virtual_monitors (DisplayMonitorManager* self,
                                              GeeLinkedList* value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_virtual_monitors (self) != value) {
		GeeLinkedList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_virtual_monitors);
		self->priv->_virtual_monitors = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY]);
	}
}

GeeLinkedList*
display_monitor_manager_get_monitors (DisplayMonitorManager* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_monitors;
	result = _tmp0_;
	return result;
}

static void
display_monitor_manager_set_monitors (DisplayMonitorManager* self,
                                      GeeLinkedList* value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_monitors (self) != value) {
		GeeLinkedList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_monitors);
		self->priv->_monitors = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY]);
	}
}

gboolean
display_monitor_manager_get_global_scale_required (DisplayMonitorManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_global_scale_required;
	return result;
}

static void
display_monitor_manager_set_global_scale_required (DisplayMonitorManager* self,
                                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_global_scale_required (self) != value) {
		self->priv->_global_scale_required = value;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY]);
	}
}

gboolean
display_monitor_manager_get_mirroring_supported (DisplayMonitorManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_mirroring_supported;
	return result;
}

static void
display_monitor_manager_set_mirroring_supported (DisplayMonitorManager* self,
                                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_mirroring_supported (self) != value) {
		self->priv->_mirroring_supported = value;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY]);
	}
}

gint
display_monitor_manager_get_max_width (DisplayMonitorManager* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_max_width;
	return result;
}

static void
display_monitor_manager_set_max_width (DisplayMonitorManager* self,
                                       gint value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_max_width (self) != value) {
		self->priv->_max_width = value;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY]);
	}
}

gint
display_monitor_manager_get_max_height (DisplayMonitorManager* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_max_height;
	return result;
}

static void
display_monitor_manager_set_max_height (DisplayMonitorManager* self,
                                        gint value)
{
	g_return_if_fail (self != NULL);
	if (display_monitor_manager_get_max_height (self) != value) {
		self->priv->_max_height = value;
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY]);
	}
}

gint
display_monitor_manager_get_monitor_number (DisplayMonitorManager* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_monitors;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gint
display_monitor_manager_get_virtual_monitor_number (DisplayMonitorManager* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_virtual_monitors;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gboolean
display_monitor_manager_get_is_mirrored (DisplayMonitorManager* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_virtual_monitors;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == 1) {
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = self->priv->_monitors;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ > 1;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
_display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* _sender,
                                                                                              gpointer self)
{
	display_monitor_manager_get_monitor_config ((DisplayMonitorManager*) self);
}

static GObject *
display_monitor_manager_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayMonitorManager * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (display_monitor_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	display_monitor_manager_set_monitors (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = gee_linked_list_new (DISPLAY_TYPE_VIRTUAL_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp3_ = _tmp2_;
	display_monitor_manager_set_virtual_monitors (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	{
		MutterDisplayConfigInterface* _tmp4_ = NULL;
		MutterDisplayConfigInterface* _tmp5_;
		MutterDisplayConfigInterface* _tmp6_;
		MutterDisplayConfigInterface* _tmp7_;
		_tmp5_ = (MutterDisplayConfigInterface*) g_initable_new (TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.Mutter.DisplayConfig", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/Mutter/DisplayConfig", "g-interface-name", "org.gnome.Mutter.DisplayConfig", "g-interface-info", g_type_get_qdata (TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
		_tmp4_ = (MutterDisplayConfigInterface*) _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch4_g_error;
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (self->priv->iface);
		self->priv->iface = _tmp6_;
		_tmp7_ = self->priv->iface;
		g_signal_connect_object (_tmp7_, "monitors-changed", (GCallback) _display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed, self, 0);
		_g_object_unref0 (_tmp4_);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_critical ("MonitorManager.vala:71: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	return obj;
}

static void
display_monitor_manager_class_init (DisplayMonitorManagerClass * klass,
                                    gpointer klass_data)
{
	display_monitor_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayMonitorManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_display_monitor_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_monitor_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_monitor_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_monitor_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY] = g_param_spec_object ("virtual-monitors", "virtual-monitors", "virtual-monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY] = g_param_spec_object ("monitors", "monitors", "monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY] = g_param_spec_boolean ("global-scale-required", "global-scale-required", "global-scale-required", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY] = g_param_spec_boolean ("mirroring-supported", "mirroring-supported", "mirroring-supported", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY] = g_param_spec_int ("max-width", "max-width", "max-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY] = g_param_spec_int ("max-height", "max-height", "max-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY] = g_param_spec_int ("monitor-number", "monitor-number", "monitor-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY] = g_param_spec_int ("virtual-monitor-number", "virtual-monitor-number", "virtual-monitor-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY] = g_param_spec_boolean ("is-mirrored", "is-mirrored", "is-mirrored", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
display_monitor_manager_instance_init (DisplayMonitorManager * self,
                                       gpointer klass)
{
	self->priv = display_monitor_manager_get_instance_private (self);
}

static void
display_monitor_manager_finalize (GObject * obj)
{
	DisplayMonitorManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
	_g_object_unref0 (self->priv->_virtual_monitors);
	_g_object_unref0 (self->priv->_monitors);
	_g_object_unref0 (self->priv->iface);
	G_OBJECT_CLASS (display_monitor_manager_parent_class)->finalize (obj);
}

GType
display_monitor_manager_get_type (void)
{
	static volatile gsize display_monitor_manager_type_id__volatile = 0;
	if (g_once_init_enter (&display_monitor_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DisplayMonitorManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_monitor_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayMonitorManager), 0, (GInstanceInitFunc) display_monitor_manager_instance_init, NULL };
		GType display_monitor_manager_type_id;
		display_monitor_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayMonitorManager", &g_define_type_info, 0);
		DisplayMonitorManager_private_offset = g_type_add_instance_private (display_monitor_manager_type_id, sizeof (DisplayMonitorManagerPrivate));
		g_once_init_leave (&display_monitor_manager_type_id__volatile, display_monitor_manager_type_id);
	}
	return display_monitor_manager_type_id__volatile;
}

static void
_vala_display_monitor_manager_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DisplayMonitorManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
	switch (property_id) {
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY:
		g_value_set_object (value, display_monitor_manager_get_virtual_monitors (self));
		break;
		case DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY:
		g_value_set_object (value, display_monitor_manager_get_monitors (self));
		break;
		case DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY:
		g_value_set_boolean (value, display_monitor_manager_get_global_scale_required (self));
		break;
		case DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY:
		g_value_set_boolean (value, display_monitor_manager_get_mirroring_supported (self));
		break;
		case DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY:
		g_value_set_int (value, display_monitor_manager_get_max_width (self));
		break;
		case DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY:
		g_value_set_int (value, display_monitor_manager_get_max_height (self));
		break;
		case DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY:
		g_value_set_int (value, display_monitor_manager_get_monitor_number (self));
		break;
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY:
		g_value_set_int (value, display_monitor_manager_get_virtual_monitor_number (self));
		break;
		case DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY:
		g_value_set_boolean (value, display_monitor_manager_get_is_mirrored (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_monitor_manager_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DisplayMonitorManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
	switch (property_id) {
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY:
		display_monitor_manager_set_virtual_monitors (self, g_value_get_object (value));
		break;
		case DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY:
		display_monitor_manager_set_monitors (self, g_value_get_object (value));
		break;
		case DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY:
		display_monitor_manager_set_global_scale_required (self, g_value_get_boolean (value));
		break;
		case DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY:
		display_monitor_manager_set_mirroring_supported (self, g_value_get_boolean (value));
		break;
		case DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY:
		display_monitor_manager_set_max_width (self, g_value_get_int (value));
		break;
		case DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY:
		display_monitor_manager_set_max_height (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

