/* Utils.c generated by valac 0.46.10, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;

gboolean display_utils_has_touchscreen (void);
GType display_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitor, g_object_unref)
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitorMode, g_object_unref)
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    gint* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      int stack_length,
                                      const gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
display_utils_has_touchscreen (void)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	gboolean result = FALSE;
	_tmp0_ = gdk_display_get_default ();
	display = _tmp0_;
	_tmp1_ = display;
	if (_tmp1_ != NULL) {
		GdkDeviceManager* manager = NULL;
		GdkDisplay* _tmp2_;
		GdkDeviceManager* _tmp3_;
		GdkDeviceManager* _tmp4_;
		GList* devices = NULL;
		GdkDeviceManager* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		_tmp2_ = display;
		_tmp3_ = gdk_display_get_device_manager (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		manager = _tmp4_;
		_tmp5_ = manager;
		_tmp6_ = gdk_device_manager_list_devices (_tmp5_, GDK_DEVICE_TYPE_SLAVE);
		devices = _tmp6_;
		_tmp7_ = devices;
		{
			GList* device_collection = NULL;
			GList* device_it = NULL;
			device_collection = _tmp7_;
			for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
				GdkDevice* device = NULL;
				device = (GdkDevice*) device_it->data;
				{
					GdkDevice* _tmp8_;
					GdkInputSource _tmp9_;
					GdkInputSource _tmp10_;
					_tmp8_ = device;
					g_object_get (_tmp8_, "input-source", &_tmp9_, NULL);
					_tmp10_ = _tmp9_;
					if (_tmp10_ == GDK_SOURCE_TOUCHSCREEN) {
						result = TRUE;
						(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
						_g_object_unref0 (manager);
						return result;
					}
				}
			}
		}
		(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
		_g_object_unref0 (manager);
	}
	result = FALSE;
	return result;
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             int stack_length,
                             const gdouble needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
	GeeLinkedList* result = NULL;
	g_return_val_if_fail (monitors != NULL, NULL);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	common_modes = _tmp0_;
	min_scale = display_utils_get_min_compatible_scale (monitors);
	first_monitor = TRUE;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
		_tmp1_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = _monitor_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp5_ = _monitor_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp6_;
			if (first_monitor) {
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp7_;
					GeeLinkedList* _tmp8_;
					GeeLinkedList* _tmp9_;
					GeeLinkedList* _tmp10_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					gint _mode_index = 0;
					_tmp7_ = monitor;
					_tmp8_ = display_monitor_get_modes (_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = _g_object_ref0 (_tmp9_);
					_mode_list = _tmp10_;
					_tmp11_ = _mode_list;
					_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
					_tmp13_ = _tmp12_;
					_mode_size = _tmp13_;
					_mode_index = -1;
					while (TRUE) {
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp14_;
						gpointer _tmp15_;
						DisplayMonitorMode* _tmp16_;
						gdouble* _tmp17_;
						gint _tmp17__length1;
						gdouble* _tmp18_;
						gint _tmp18__length1;
						_mode_index = _mode_index + 1;
						if (!(_mode_index < _mode_size)) {
							break;
						}
						_tmp14_ = _mode_list;
						_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _mode_index);
						mode = (DisplayMonitorMode*) _tmp15_;
						_tmp16_ = mode;
						_tmp17_ = display_monitor_mode_get_supported_scales (_tmp16_, &_tmp17__length1);
						_tmp18_ = _tmp17_;
						_tmp18__length1 = _tmp17__length1;
						if (_vala_double_array_contains (_tmp18_, _tmp18__length1, min_scale)) {
							GeeLinkedList* _tmp19_;
							DisplayMonitorMode* _tmp20_;
							_tmp19_ = common_modes;
							_tmp20_ = mode;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
						}
						_g_object_unref0 (mode);
					}
					_g_object_unref0 (_mode_list);
				}
				first_monitor = FALSE;
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp21_;
				GeeLinkedList* _tmp53_;
				GeeLinkedList* _tmp54_;
				_tmp21_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				to_remove = _tmp21_;
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp22_;
					GeeLinkedList* _tmp23_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gint _mode_to_check_index = 0;
					_tmp22_ = common_modes;
					_tmp23_ = _g_object_ref0 (_tmp22_);
					_mode_to_check_list = _tmp23_;
					_tmp24_ = _mode_to_check_list;
					_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
					_tmp26_ = _tmp25_;
					_mode_to_check_size = _tmp26_;
					_mode_to_check_index = -1;
					while (TRUE) {
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp27_;
						gpointer _tmp28_;
						gboolean mode_found = FALSE;
						_mode_to_check_index = _mode_to_check_index + 1;
						if (!(_mode_to_check_index < _mode_to_check_size)) {
							break;
						}
						_tmp27_ = _mode_to_check_list;
						_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _mode_to_check_index);
						mode_to_check = (DisplayMonitorMode*) _tmp28_;
						mode_found = FALSE;
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp29_;
							GeeLinkedList* _tmp30_;
							GeeLinkedList* _tmp31_;
							GeeLinkedList* _tmp32_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							gint _monitor_mode_index = 0;
							_tmp29_ = monitor;
							_tmp30_ = display_monitor_get_modes (_tmp29_);
							_tmp31_ = _tmp30_;
							_tmp32_ = _g_object_ref0 (_tmp31_);
							_monitor_mode_list = _tmp32_;
							_tmp33_ = _monitor_mode_list;
							_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
							_tmp35_ = _tmp34_;
							_monitor_mode_size = _tmp35_;
							_monitor_mode_index = -1;
							while (TRUE) {
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp36_;
								gpointer _tmp37_;
								gboolean _tmp38_ = FALSE;
								DisplayMonitorMode* _tmp39_;
								gint _tmp40_;
								gint _tmp41_;
								DisplayMonitorMode* _tmp42_;
								gint _tmp43_;
								gint _tmp44_;
								_monitor_mode_index = _monitor_mode_index + 1;
								if (!(_monitor_mode_index < _monitor_mode_size)) {
									break;
								}
								_tmp36_ = _monitor_mode_list;
								_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _monitor_mode_index);
								monitor_mode = (DisplayMonitorMode*) _tmp37_;
								_tmp39_ = mode_to_check;
								_tmp40_ = display_monitor_mode_get_width (_tmp39_);
								_tmp41_ = _tmp40_;
								_tmp42_ = monitor_mode;
								_tmp43_ = display_monitor_mode_get_width (_tmp42_);
								_tmp44_ = _tmp43_;
								if (_tmp41_ == _tmp44_) {
									DisplayMonitorMode* _tmp45_;
									gint _tmp46_;
									gint _tmp47_;
									DisplayMonitorMode* _tmp48_;
									gint _tmp49_;
									gint _tmp50_;
									_tmp45_ = mode_to_check;
									_tmp46_ = display_monitor_mode_get_height (_tmp45_);
									_tmp47_ = _tmp46_;
									_tmp48_ = monitor_mode;
									_tmp49_ = display_monitor_mode_get_height (_tmp48_);
									_tmp50_ = _tmp49_;
									_tmp38_ = _tmp47_ == _tmp50_;
								} else {
									_tmp38_ = FALSE;
								}
								if (_tmp38_) {
									mode_found = TRUE;
									_g_object_unref0 (monitor_mode);
									break;
								}
								_g_object_unref0 (monitor_mode);
							}
							_g_object_unref0 (_monitor_mode_list);
						}
						if (mode_found == FALSE) {
							GeeLinkedList* _tmp51_;
							DisplayMonitorMode* _tmp52_;
							_tmp51_ = to_remove;
							_tmp52_ = mode_to_check;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
						}
						_g_object_unref0 (mode_to_check);
					}
					_g_object_unref0 (_mode_to_check_list);
				}
				_tmp53_ = common_modes;
				_tmp54_ = to_remove;
				gee_collection_remove_all ((GeeCollection*) _tmp53_, (GeeCollection*) _tmp54_);
				_g_object_unref0 (to_remove);
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = common_modes;
	return result;
}

gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble min_scale = 0.0;
	gdouble result = 0.0;
	g_return_val_if_fail (monitors != NULL, 0.0);
	min_scale = DBL_MAX;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
		_tmp0_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = _monitor_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_monitor_size = _tmp3_;
		_monitor_index = -1;
		while (TRUE) {
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp4_;
			gpointer _tmp5_;
			DisplayMonitor* _tmp6_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp4_ = _monitor_list;
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp5_;
			_tmp6_ = monitor;
			min_scale = MIN (min_scale, display_monitor_get_max_scale (_tmp6_));
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = min_scale;
	return result;
}

